
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.tree.*;
import java.awt.event.*;

public class Browser extends JPanel
{
  BorderLayout borderLayout1;
  JSplitPane splitPane;
  TreePanel topPanel;
  TE tmpTE;
  TreePanel bottomPanel;
  JToolBar toolBar;
  JButton up;
  JButton down;
  JButton open;
  
  public Browser()
  {
    try
    {
      initHeader();
      tmpTE.setIcon(loadImageIcon("images/java.gif", "javaIcon"));
      bottomPanel.tree.addTreeSelectionListener(new Selector());
      jbInit();
    }
    catch (Exception ex)
    {
		    System.err.println("The following Exception occurred and was written to");
		    System.err.println("the error log. If you are able to reproduce the error,");
		    System.err.println("please send the log and a description of what you were");
		    System.err.println("doing to PsychoticSoftware@hotmail.com");
        System.out.println("          <-- Browser.class -->");
        ex.printStackTrace();
    }
  }

  private void initHeader()
  {
      borderLayout1 = new BorderLayout();
      Conn.conn.status.setText("Brwser: Setup Layout");
      Conn.conn.status.repaint();
      splitPane = new JSplitPane();
      Conn.conn.status.setText("Brwser: Setup Orientation");
      Conn.conn.status.repaint();
      topPanel =  new TreePanel(getProjectRoot());
      Conn.conn.status.setText("Brwser: Setup Structure Panel");
      Conn.conn.status.repaint();
      bottomPanel = new TreePanel(new ClassNode(tmpTE = new TE("Untitled2.java")));
      Conn.conn.status.setText("Brwser: Setup Project Panel");
      Conn.conn.status.repaint();
      toolBar = new JToolBar();
      Conn.conn.status.setText("Brwser: Setup Toolbar");
      Conn.conn.status.repaint();
      up = new JButton(loadImageIcon("images/plus.gif", "Up"));
      Conn.conn.status.setText("Brwser: Setup Toolbar -> Add Button");
      Conn.conn.status.repaint();
      down = new JButton(loadImageIcon("images/minus.gif", "Down"));
      Conn.conn.status.setText("Brwser: Setup Toolbar -> Remove Button");
      Conn.conn.status.repaint();
      open = new JButton(loadImageIcon("images/openProject.gif", "Open"));
      Conn.conn.status.setText("Brwser: Setup Toolbar -> Open Button");
      Conn.conn.status.repaint();
  }


  /*public static void main(String[] args)
  {
    Browser browser = new Browser();
    browser.setVisible(true);
  }*/


  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }


  public static class TreePanel extends JPanel
  {
	  public JTree tree;
    private DefaultMutableTreeNode root;
    public DefaultTreeModel model;

    public TreePanel(DefaultMutableTreeNode root)
    {
      this.root = root;
      tree = new JTree();
      tree.setCellRenderer(new MRenderer());
      tree.setModel(model = new DefaultTreeModel(root));

      setLayout(new BorderLayout());
	    add(new JScrollPane(tree), BorderLayout.CENTER);

      //java.util.Enumeration enum = root.children();
      //while(enum.hasMoreElements())
      //{
      //  System.out.println(enum.nextElement());
      //}
    }

    public DefaultMutableTreeNode getRoot()
    {
      return root;
    }

    public void update(DefaultMutableTreeNode cln)
    {
      if(cln instanceof ClassNode)
      {
        java.util.Vector allNodes;
        java.util.Enumeration enum;

        ((ClassNode)this.root).fields.removeAllChildren();
        ((ClassNode)this.root).methods.removeAllChildren();
        ((ClassNode)this.root).innerClasses.removeAllChildren();
        ((ClassNode)this.root).imports.removeAllChildren();

        ((TE)((DefaultMutableTreeNode)this.root.getUserObject()).getUserObject()).setName(((TE)((DefaultMutableTreeNode)((ClassNode)cln).root.getUserObject()).getUserObject()).getName());

        // ********************** FIELDS ******************************
        allNodes = new java.util.Vector();
        enum = ((ClassNode)cln).fields.children();
        while(enum.hasMoreElements())
        {
          allNodes.addElement((DefaultMutableTreeNode)enum.nextElement());
        }

        enum = allNodes.elements();
        while(enum.hasMoreElements())
        {
          ((ClassNode)this.root).fields.add((DefaultMutableTreeNode)enum.nextElement());
        }

        // ********************** Methods ******************************
        allNodes = new java.util.Vector();
        enum = ((ClassNode)cln).methods.children();
        while(enum.hasMoreElements())
        {
          allNodes.addElement((DefaultMutableTreeNode)enum.nextElement());
        }

        enum = allNodes.elements();
        while(enum.hasMoreElements())
        {
          ((ClassNode)this.root).methods.add((DefaultMutableTreeNode)enum.nextElement());
        }


        // ********************** Inner Classes ******************************
        allNodes = new java.util.Vector();
        enum = ((ClassNode)cln).innerClasses.children();
        while(enum.hasMoreElements())
        {
          allNodes.addElement((DefaultMutableTreeNode)enum.nextElement());
        }

        enum = allNodes.elements();
        while(enum.hasMoreElements())
        {
          ((ClassNode)this.root).innerClasses.add((DefaultMutableTreeNode)enum.nextElement());
        }


        // ********************** Imports ******************************
        allNodes = new java.util.Vector();
        enum = ((ClassNode)cln).imports.children();
        while(enum.hasMoreElements())
        {
          allNodes.addElement((DefaultMutableTreeNode)enum.nextElement());
        }

        enum = allNodes.elements();
        while(enum.hasMoreElements())
        {
         ((ClassNode)this.root).imports.add((DefaultMutableTreeNode)enum.nextElement());
        }
      }  // End if(instanceof ClassNode)

    }

  }



  private void jbInit() throws Exception
  {

    this.setLayout(borderLayout1);

    topPanel.setMinimumSize(new Dimension(0, 0));
    bottomPanel.setMinimumSize(new Dimension(0, 0));
    topPanel.setPreferredSize(new Dimension(210,200));

    up.setToolTipText("Add to project");
    down.setToolTipText("Remove from project");
    open.setToolTipText("Open a project");
    open.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        open_actionPerformed(e);
      }
    });

    splitPane.setTopComponent(topPanel);
    splitPane.setBottomComponent(bottomPanel);

    splitPane.setDoubleBuffered(true);

    splitPane.setContinuousLayout(true);
    splitPane.setDividerSize(5);
    this.add(splitPane, BorderLayout.CENTER);
    splitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
    splitPane.getAccessibleContext().setAccessibleName("Split pane Browser");

    toolBar.setFloatable(false);
    toolBar.addSeparator();
    toolBar.add(up);
    toolBar.add(down);
    toolBar.addSeparator();
    toolBar.add(open);

    this.add(toolBar, BorderLayout.NORTH);
    down.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    down.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        down_actionPerformed(e);
      }
    });
    up.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    up.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        up_actionPerformed(e);
      }
    });


    topPanel.tree.addMouseListener(new MouseAdapter()
    {
     public void mouseClicked(MouseEvent e)
     {
       int selRow = topPanel.tree.getRowForLocation(e.getX(), e.getY());
       TreePath selPath = topPanel.tree.getPathForLocation(e.getX(), e.getY());
       if(selRow > 0)
       {
         if(e.getClickCount() == 2)
         {
           selectProjectFile((TE)((DefaultMutableTreeNode)selPath.getLastPathComponent()).getUserObject());
         }
       }
     }
    });




    setSize(new Dimension(220, 610));
  }

  public DefaultMutableTreeNode getProjectRoot()
  {
   TE tmp = new TE("Untitled.spj");
   tmp.setIcon(loadImageIcon("images/myFolder.gif", "javaIcon"));

   DefaultMutableTreeNode root = new DefaultMutableTreeNode(tmp);
   //root.add(new DefaultMutableTreeNode(tmp));

   return root;
  }


  public void updateBottom(TreePanel t)
  {
    splitPane.setBottomComponent(t);
    t.repaint();
  }

  public void updateTop(TreePanel t)
  {
    splitPane.setTopComponent(t);
    t.repaint();
  }

  void up_actionPerformed(ActionEvent e)
  {
    Chooser chooser = new Chooser();
    chooser.setOpen();
    chooser.setTitle("Add To Project");

    chooser.previewer.addToProjectBox.setSelected(true);
    chooser.previewer.addToProjectBox.setEnabled(false);

	  int retval = chooser.showDialog(this, null);
	  if(retval == Chooser.APPROVE_OPTION)
    {
      java.io.File res = chooser.getSelectedFile();
    }
  }

  void down_actionPerformed(ActionEvent e)
  {
    DefaultMutableTreeNode  lastItem = getSelectedNode();
    //System.out.println("Node: " + lastItem);

    if(lastItem != null && lastItem != (DefaultMutableTreeNode)topPanel.getRoot())
    {
		  topPanel.model.removeNodeFromParent(lastItem);
    }
  }

  protected DefaultMutableTreeNode getSelectedNode()
  {
	  TreePath   selPath = topPanel.tree.getSelectionPath();

	  if(selPath != null)
    {
      return (DefaultMutableTreeNode)selPath.getLastPathComponent();
    }
	  return null;
  }

  void open_actionPerformed(ActionEvent e)
  {
    SuperEdit.superEdit.openItem_actionPerformed(e);
  }

  void selectProjectFile(TE selectedFile)
  {
    //System.out.println(selectedFile);
    java.io.File theFile = (java.io.File) selectedFile.contents;
    java.util.Enumeration enum = SuperEdit.superEdit.openedWindows.elements();

    while(enum.hasMoreElements())
    {
      Editor cur = (Editor) enum.nextElement();
      if(cur.getTitle().equals(theFile.getAbsolutePath()))
      {
        cur.toFront();
        return;
      }
    }
    SuperEdit.superEdit.makeEditor(theFile);
  }


}


