
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import borland.jbcl.layout.*;
import com.sun.java.swing.*;
import java.awt.event.*;
import java.io.*;

public class BuildOptions extends JFrame
{
  XYLayout xYLayout1 = new XYLayout();
  JTabbedPane panels = new JTabbedPane();
  JButton okButton = new JButton();
  JButton helpButton = new JButton();
  JPanel mainPanel = new JPanel();
  JLabel jLabel1 = new JLabel();
  XYLayout xYLayout2 = new XYLayout();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JRadioButton noCompiler = new JRadioButton();
  JRadioButton javaCompiler = new JRadioButton();
  ButtonGroup group = new ButtonGroup();
  JavaCompilerOptions jc = new JavaCompilerOptions();
  JFrame opts = this;
  boolean error = false;

  
  public BuildOptions()
  {
    try 
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    try
    {
	    java.net.URL url = getClass().getResource("images/opt.gif");
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}

    this.setResizable(false);
    group.add(noCompiler);
    group.add(javaCompiler);
    
    this.setTitle("Build Options");
    xYLayout1.setHeight(407);
    okButton.setText("OK");
    okButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        okButton_actionPerformed(e);
      }
    });
    helpButton.setText("Help");
    mainPanel.setLayout(xYLayout2);
    jLabel1.setText("Main Options");
    jLabel1.setFont(new Font("Serif", 1, 24));
    jLabel2.setText("Select one of the installed compilers");
    jLabel3.setText("below and then click on its tab to");
    jLabel4.setText("customize individual options.");
    noCompiler.setText("None");
    noCompiler.setForeground(Color.black);
    noCompiler.setToolTipText("Do not use any compiler");
    javaCompiler.setText("Java");
    javaCompiler.setForeground(Color.black);
    javaCompiler.setSelected(true);
    javaCompiler.setToolTipText("Use the Sun Java Compiler");
    xYLayout1.setWidth(388);
    this.getContentPane().setLayout(xYLayout1);
    this.getContentPane().add(panels, new XYConstraints(3, 0, 375, 342));
    panels.addTab("Main", mainPanel);
    panels.addTab(jc.toString(), jc);
    mainPanel.add(jLabel1, new XYConstraints(110, 4, 147, 31));
    mainPanel.add(jLabel2, new XYConstraints(34, 51, 221, 21));
    mainPanel.add(jLabel3, new XYConstraints(34, 69, 206, 18));
    mainPanel.add(jLabel4, new XYConstraints(34, 85, 178, 21));
    mainPanel.add(noCompiler, new XYConstraints(60, 145, 88, 14));
    mainPanel.add(javaCompiler, new XYConstraints(60, 164, 88, 14));
    this.getContentPane().add(okButton, new XYConstraints(122, 349, 64, -1));
    this.getContentPane().add(helpButton, new XYConstraints(193, 349, 64, -1));

    setSize(388, 407);
  }

  void okButton_actionPerformed(ActionEvent e)
  {
    this.setVisible(false);
  }

  class Executor extends Thread
  {
    String cmd;

    public Executor(String cmd)
    {
      this.cmd = cmd;
    }

    public void run()
    {
	    try
	    {
        Runtime rt = Runtime.getRuntime();
        File f = new File("eo.dat");
        FileOutputStream fos = new FileOutputStream(f);
        Process proc = rt.exec(cmd);

	      InputStream in = proc.getErrorStream();

        int ret = 0;
	      while((ret = in.read()) != -1)
	      {
          fos.write(ret);
        }
        fos.close();

        SuperEdit.superEdit.messages.model.removeAllElements();
        SuperEdit.superEdit.messages.list.repaint();

        if(f.length() > 0)
        {

          BufferedReader bis = new BufferedReader(new FileReader(f));
          String res = "";

          while((res = bis.readLine()) != null)
          {
             int err = res.indexOf(".java:");

             if(err >= 0)
             {
               SuperEdit.superEdit.messages.setVisible(true);
               error = true;
               SuperEdit.superEdit.messages.model.addElement(new ErrorCode(res));
             }

          }
          bis.close();
          SuperEdit.superEdit.messagesItem.setSelected(true);
          SuperEdit.superEdit.messages.list.repaint();
       }

       if(error)
       {
         SuperEdit.superEdit.mainStatus.setText(SuperEdit.superEdit.mainStatus.getText() + "Errors Encountered! See Messages.");
       }
       else
       {
         SuperEdit.superEdit.mainStatus.setText(SuperEdit.superEdit.mainStatus.getText() + "Done!");
       }
       SuperEdit.superEdit.mainStatus.repaint();

      }
      catch(Exception x) {JOptionPane.showMessageDialog(opts, "Could not execute " + cmd);}
    }
  }

  public void execute(String cmd)
  {
    (new Executor(cmd)).start();
  }

}

 