
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import java.io.File;

public class ButtonEditor extends JFrame
{
  ImageIcon defaultIcon = loadImageIcon("images/32/help.gif", "defaultIcon");
  JTextField tipField = new JTextField();
  JTextArea ta = new JTextArea();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField descriptionField = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField pathField = new JTextField();
  JButton browseButton = new JButton();
  JScrollPane scroller = new JScrollPane(ta);
  JLabel jLabel4 = new JLabel();
  Component parent;
  ToolbarButton button;
  JButton doButton = new JButton();
  TE te  = null;


  public ButtonEditor(Component parent, TE te)
  {
    try
    {
      this.parent = parent;
      this.te = te;
      this.button = (ToolbarButton) te.contents;
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(xYLayout1);
    this.setResizable(false);
    this.pathField.setEditable(false);
    this.setTitle("Button Editor");
    this.setSize(new Dimension(349, 385));
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });
    scroller.setBorder(new BevelBorder(BevelBorder.LOWERED));
    xYLayout1.setHeight(325);
    xYLayout1.setWidth(380);
    jLabel1.setText("ToolTip:");
    jLabel2.setText("Description:");
    jLabel3.setText("32x32 GIF Image:");
    browseButton.setText("Browse");
    browseButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        browseButton_actionPerformed(e);
      }
    });
    jLabel4.setText("Code:");
    doButton.setText("Do It!");
    doButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        doButton_actionPerformed(e);
      }
    });
    this.getContentPane().add(tipField, new XYConstraints(66, 13, 299, 22));
    this.getContentPane().add(jLabel1, new XYConstraints(10, 13, 51, 19));
    this.getContentPane().add(jLabel2, new XYConstraints(9, 44, 71, 19));
    this.getContentPane().add(descriptionField, new XYConstraints(85, 45, 281, 22));
    this.getContentPane().add(jLabel3, new XYConstraints(5, 76, 102, 19));
    this.getContentPane().add(pathField, new XYConstraints(104, 76, 183, 22));
    this.getContentPane().add(browseButton, new XYConstraints(290, 76, 78, 24));
    this.getContentPane().add(scroller, new XYConstraints(8, 124, 357, 145));
    this.getContentPane().add(jLabel4, new XYConstraints(5, 102, 40, 20));
    this.getContentPane().add(doButton, new XYConstraints(8, 272, 358, 23));

    descriptionField.setText(button.description);
    tipField.setText(button.tip);
    ta.setText(button.data);
    pathField.setText(button.path == null ? "" : button.path);


    this.setBounds(parent.getLocation().x - 100, parent.getLocation().y + 100, 380, 325);
    this.setVisible(true);
    parent.setEnabled(false);
  }

  void this_windowClosing(WindowEvent e)
  {
    parent.setEnabled(true);
    this.dispose();
  }

  void doButton_actionPerformed(ActionEvent e)
  {
    button.setToolTipText(tipField.getText().equals("") ? null : tipField.getText());
    button.setIcon(pathField.getText().equals("") ? defaultIcon : new ImageIcon( (new ImageIcon(pathField.getText()) ).getImage().getScaledInstance(32,32, Image.SCALE_DEFAULT)));
    button.set16x16(pathField.getText().equals("") ? defaultIcon : new ImageIcon( (new ImageIcon(pathField.getText()) ).getImage().getScaledInstance(16,16, Image.SCALE_DEFAULT)));
    button.set32x32(pathField.getText().equals("") ? defaultIcon : new ImageIcon( (new ImageIcon(pathField.getText()) ).getImage().getScaledInstance(32,32, Image.SCALE_DEFAULT)));

    button.path = pathField.getText();
    button.data = ta.getText();
    button.tip = tipField.getText().equals("") ? null : tipField.getText();
    button.description = descriptionField.getText();

    te.setIcon(new ImageIcon( button.get32x32().getImage().getScaledInstance(16,16, Image.SCALE_DEFAULT)));
    te.setName(button.description);

    button.repaint();
    parent.setEnabled(true);
    this.dispose();
  }

  void browseButton_actionPerformed(ActionEvent e)
  {
    Chooser chooser = new Chooser();
    chooser.setTitle("Select an image");
    chooser.setFileFilter(chooser.bothFilter);
    File theFile;


	  int retval = chooser.showDialog(this, null);
	  if(retval == Chooser.APPROVE_OPTION)
    {
	    theFile = chooser.getSelectedFile();
	    if(theFile != null)
      {
		    if(theFile.exists())
        {
           pathField.setText(theFile.getAbsolutePath());
           return;
        }
      }
    }
    pathField.setText("");
  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }

}


