/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import com.sun.java.swing.*;
import com.sun.java.swing.preview.filechooser.*;
import com.sun.java.swing.preview.*;

import java.awt.*;
import java.io.File;
import java.awt.event.*;
import java.beans.*;

public class Chooser extends JFileChooser
{

 FileTypeFilter jpgFilter, gifFilter, bothFilter, spjFilter, javaFilter, cFilter, htmlFilter, textFilter, cplusFilter;
 ThumbNailer fileView;
 FilePreviewer previewer;
 public static File lastDir = null;

 public Chooser()
 {
  super();
	previewer = new FilePreviewer(this);

	jpgFilter = new FileTypeFilter("jpg", "JPEG Compressed Image Files");
	gifFilter = new FileTypeFilter("gif", "GIF Image Files");
	spjFilter = new FileTypeFilter("spj", "SuperEdit Project");
	javaFilter = new FileTypeFilter("java", "Java Source Files");
	cFilter = new FileTypeFilter("c", "C Source Files");
	htmlFilter = new FileTypeFilter(new String[] {"html", "htm"}, "Hypertext Files");
	textFilter = new FileTypeFilter(new String[] {"txt", "text", "texi", "nfo"}, "Text Files");
	cplusFilter = new FileTypeFilter(new String[] {"cpp", "c++", "cc"}, "C++ Source Files");
	bothFilter = new FileTypeFilter(new String[] {"jpg", "gif"}, "JPEG and GIF Image Files");

	fileView = new ThumbNailer();
	fileView.putIcon("jpg", new ImageIcon("images/jpgIcon.jpg"));
	fileView.putIcon("gif", new ImageIcon("images/gifIcon.gif"));
	fileView.putIcon("java", new ImageIcon("images/java.gif"));

	this.setAccessory(previewer);
	this.setFileView(fileView);

  if(Chooser.lastDir != null)
  {
    this.setCurrentDirectory(lastDir);
  }

  this.setFileFilter(javaFilter);

  this.addChoosableFileFilter((FileFilter)bothFilter);
  this.addChoosableFileFilter((FileFilter)jpgFilter);
  this.addChoosableFileFilter((FileFilter)gifFilter);
  this.addChoosableFileFilter((FileFilter)javaFilter);

  this.addChoosableFileFilter((FileFilter)cFilter);
  this.addChoosableFileFilter((FileFilter)htmlFilter);
  this.addChoosableFileFilter((FileFilter)textFilter);
  this.addChoosableFileFilter((FileFilter)cplusFilter);
  this.addChoosableFileFilter((FileFilter)spjFilter);
  this.addChoosableFileFilter(getAcceptAllFileFilter());

  this.setFileSelectionMode(JFileChooser.FILES_ONLY);
 }

 public void setOpen()
 {
  this.setDialogType(JFileChooser.OPEN_DIALOG);
 }

 public File getSelectedFile()
 {
   File res = super.getSelectedFile();
   if(res != null)
   {
     Chooser.lastDir = new File(res.getParent());
     if(previewer.addToProjectBox.isSelected())
     {
       SuperEdit.superEdit.projectUnsaved = true;
       
       TE tmp = new TE(res);

                    if(res.getAbsolutePath().endsWith(".java"))
                    {
                      tmp.setIcon(loadImageIcon("images/java.gif", "javaIcon"));
                    }
                    else if(SuperEdit.isImage(res.getAbsolutePath()))
                    {
                      tmp.setIcon(loadImageIcon("images/preview.gif", "imageIcon"));
                    }
                    else
                    {
                      tmp.setIcon(loadImageIcon("images/defaultLeaf.gif", "imageIcon"));
                    }

       SuperEdit.superEdit.workspace.browser.topPanel.model.insertNodeInto(new com.sun.java.swing.tree.DefaultMutableTreeNode(tmp), SuperEdit.superEdit.workspace.browser.topPanel.getRoot(), SuperEdit.superEdit.workspace.browser.topPanel.getRoot().getChildCount());
       SuperEdit.superEdit.workspace.browser.topPanel.tree.expandRow(0);
       java.util.Vector sorted = new java.util.Vector();
       java.util.Enumeration enum = SuperEdit.superEdit.workspace.browser.topPanel.getRoot().children();
       while(enum.hasMoreElements())
       {
         sorted.addElement(enum.nextElement());
       }
       sorted = Utility.quicksortVector(sorted);
       SuperEdit.superEdit.workspace.browser.topPanel.getRoot().removeAllChildren();
       java.util.Enumeration enum2 = sorted.elements();
       while(enum2.hasMoreElements())
       {
         SuperEdit.superEdit.workspace.browser.topPanel.model.insertNodeInto((com.sun.java.swing.tree.DefaultMutableTreeNode) enum2.nextElement(), SuperEdit.superEdit.workspace.browser.topPanel.getRoot(), SuperEdit.superEdit.workspace.browser.topPanel.getRoot().getChildCount());
       }
       SuperEdit.superEdit.workspace.browser.topPanel.model.reload();
     }
   }
   return res;
 }


 public void setTitle(String theTitle)
 {
   setDialogTitle(theTitle);
 }

 public void setSave()
 {
  this.setDialogType(JFileChooser.SAVE_DIALOG);
 }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }


 class FilePreviewer extends JPanel  implements PropertyChangeListener
 {
    ImageIcon thumbnail = null;
	  File f = null;
    JCheckBox addToProjectBox = new JCheckBox();

    ImageIcon  defaultIco = loadImageIcon("images/32/help.gif");
    JLabel pv = new JLabel(defaultIco);

	  public FilePreviewer(JFileChooser fc)
    {
	    setPreferredSize(new Dimension(110, 125));
      this.setSize(110, 125);
	    fc.addPropertyChangeListener(this);
      addToProjectBox.setText("Add to project");
      this.add(pv);
      this.add(addToProjectBox);
      pv.setSize(100, 100);
      addToProjectBox.setSize(100, 10);
    }

	  public void loadImage()
    {
	    if(f != null)
      {
        ImageIcon tmpIcon = new ImageIcon(f.getPath());
		    if(tmpIcon.getIconWidth() > 100 && tmpIcon.getIconWidth() > tmpIcon.getIconHeight())
        {
		      thumbnail = new ImageIcon(
			         tmpIcon.getImage().getScaledInstance(100, -1, Image.SCALE_DEFAULT));
        }
		    else if(tmpIcon.getIconHeight() > 100 && tmpIcon.getIconHeight() > tmpIcon.getIconWidth())
        {
		      thumbnail = new ImageIcon(
			         tmpIcon.getImage().getScaledInstance(-1, 100, Image.SCALE_DEFAULT));
        }
        else
        {
		      thumbnail = (tmpIcon == null) ? defaultIco : tmpIcon;
        }
        pv.setIcon(thumbnail);
      }
      else
      {
        pv.setIcon(defaultIco);
      }
    }

	  public void propertyChange(PropertyChangeEvent e)
    {
	    String prop = e.getPropertyName();
	    if(prop == JFileChooser.SELECTED_FILE_CHANGED_PROPERTY)
      {
		    f = (File) e.getNewValue();
		    if(isShowing())
        {
		      loadImage();
          addToProjectBox.repaint();
          pv.repaint();
		      repaint();
        }
      }
    }

	  public void paint(Graphics g)
    {
	    if(thumbnail == null)
      {
		    loadImage();
	    }
      super.paint(g);
    }
 }

  public ImageIcon loadImageIcon(String filename)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, filename + "desc");
  }


}