/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import com.sun.java.swing.tree.DefaultMutableTreeNode;
import com.sun.java.swing.tree.TreeNode;
import com.sun.java.swing.ImageIcon;

public class ClassNode extends DefaultMutableTreeNode
{
   protected DefaultMutableTreeNode root;
   protected DefaultMutableTreeNode fields;
   protected DefaultMutableTreeNode methods;
   protected DefaultMutableTreeNode innerClasses;
   protected DefaultMutableTreeNode imports;

   public ClassNode(TE theClass)
   {
     super(new DefaultMutableTreeNode(theClass));
     root = (DefaultMutableTreeNode) getRoot();

     TE t11;

     //((TE)((DefaultMutableTreeNode)root.getUserObject()).getUserObject()).setIcon(loadImageIcon("images/java.gif", "javaIcon"));

     root.add(fields = new DefaultMutableTreeNode(t11 = new TE("Fields")));
     t11.setIcon(loadImageIcon("images/myFolder.gif", "MF"));
     addField(new TE("No Fields"));

     root.add(methods = new DefaultMutableTreeNode(t11 = new TE("Methods")));
     t11.setIcon(loadImageIcon("images/myGFolder.gif", "MGF"));
     addMethod(new TE("No Methods"));

     root.add(innerClasses = new DefaultMutableTreeNode(t11 = new TE("Inner Classes")));
     t11.setIcon(loadImageIcon("images/myPFolder.gif", "MPF"));
     innerClasses.add(new DefaultMutableTreeNode(new TE("No Inner Classes")));

     TE tmp4 = new TE("Imports");
     tmp4.setIcon(loadImageIcon("images/importIcon.gif", "importIcon"));
     root.add(imports = new DefaultMutableTreeNode(tmp4));

     addImport(tmp4 = new TE("java.lang.*"));
     tmp4.setIcon(loadImageIcon("images/importIcon.gif", "importIcon"));
   }

   public void addField(TE o)
   {
     fields.add(new DefaultMutableTreeNode(o));
   }

   public void addMethod(TE o)
   {
     methods.add(new DefaultMutableTreeNode(o));
   }

   public void addImport(TE o)
   {
     imports.add(new DefaultMutableTreeNode(o));
   }

   public void addInnerClass(ClassNode c)
   {
     innerClasses.add(c);
   }

   private void addInnerClassInternal(DefaultMutableTreeNode o)
   {
     innerClasses.add(o);
   }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }


}
