/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import com.sun.java.swing.*;
import borland.jbcl.control.*;
import java.awt.*;
import java.awt.event.*;
import symantec.itools.multimedia.*;
import java.util.*;

public class Conn extends JFrame
{
  String logoFile = "images/PsychoticSoftware.jpg";
  String logoIcon = "images/logo.gif";
  String progName = "Psychotic Software Splash";
  String warn = "WARNING: Program will not run if you close this Splash";
  Date timer = new Date();
  public static Conn conn = null;
  long timePassed = 0;
  java.net.URL psychotic = getClass().getResource(logoFile);
  symantec.itools.multimedia.ImageViewer imageViewer1 = new symantec.itools.multimedia.ImageViewer();
  JProgressBar progress = new JProgressBar();
  public StatusBar status = new MStatusBar();
  JLabel sLabel = new JLabel();
  private boolean reg = false;
  public static SuperEdit parent = null;
  boolean interrupted = false;

  public Conn()
  {
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public Conn(boolean reg)
  {
    conn = this;
    this.reg = reg;

    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    try
    {
	    java.net.URL url = getClass().getResource(logoIcon);
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}

    this.setResizable(false);
    this.getContentPane().setLayout(null);
    imageViewer1.setStyle(2);
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });
    imageViewer1.setImageURL(psychotic);

    this.setForeground(Color.black);
    this.setBackground(Color.black);
    //conn.setBackground(Color.black);
    status.setForeground(Color.yellow);
    status.setBackground(Color.black);
    progress.setBackground(Color.black);
    progress.setForeground(Color.yellow);

    imageViewer1.setForeground(Color.black);
    imageViewer1.setBackground(Color.black);


    imageViewer1.setBounds(new Rectangle(3, 0, 460, 400));
    progress.setToolTipText("Program Initialization Progress");
    progress.setBounds(new Rectangle(0, 401, 460, 18));
    status.setBevelInner(BevelPanel.FLAT);
    status.setText("Loading...");
    status.setBounds(new Rectangle(0, 420, 460, 23));
    sLabel.setText("S" + "h" + "a" + "r" + "e" + "w" + "a" + "r" + "e");
    sLabel.setForeground(Color.yellow);
    sLabel.setBackground(Color.black);
    sLabel.setFont(new Font("SansSerif", 0, 42));
    sLabel.setBounds(new Rectangle(130, 441, 210, 47));
    this.setTitle(progName);

    if(reg)
    {
      this.setBounds(getToolkit().getScreenSize().width/2 - 223,
                   getToolkit().getScreenSize().height/2 - 250,
                   468, 470);
    }
    else
    {
      this.setBounds(getToolkit().getScreenSize().width/2 - 223,
                   getToolkit().getScreenSize().height/2 - 250,
                   468, 510);
    }

    this.getContentPane().add(imageViewer1, null);
    this.getContentPane().add(progress, null);
    this.getContentPane().add(status, null);
    this.getContentPane().add(sLabel, null);

   progress.setMinimum(0);
   progress.setMaximum(370);

    setVisible(true);
  }

  public void countdown()
  {
   (new MyTimer(progress, this)).run();

  }

  void this_windowClosing(WindowEvent e)
  {
    interrupted = true;
    JOptionPane.showMessageDialog(this, warn);
    System.exit(0);
  }

 public static class MyTimer extends Thread
 {
   int s;
   JProgressBar p;
   Conn f;

   public MyTimer(JProgressBar prog, Conn fr)
   {
     p = prog;
     f = fr;
   }

   public void run()
   {
      while(parent == null)
      {
        try{sleep(100);} catch(Exception e){;}
      }

      this.stop();
      if(f.interrupted) {System.exit(0);}

      parent.setVisible(true);
      parent.workspace.setVisible(true);
      f.dispose();
   }
 }


class MStatusBar extends StatusBar
{
 private int count = 0;

 public MStatusBar()
 {
   super();

 }

 public void setText(String s)
 {
  super.setText(s);
  if(progress.getValue() < progress.getMaximum())
  {
    progress.setValue(progress.getValue()+1);
    progress.repaint();
  }
 }
}


}


