
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import borland.jbcl.layout.*;
import com.sun.java.swing.*;
import com.sun.java.swing.text.*;
import borland.jbcl.control.*;
import java.awt.event.*;

import com.sun.java.swing.preview.*;


public class EditorOptions extends JFrame
{
  XYLayout xYLayout1 = new XYLayout();
  JButton colorButton = new JButton();
  JButton fontButton = new JButton();
  JLabel label = new JLabel();
  Editor editor;
  //FontChooser fontChooser = new FontChooser(this);
  //ColorChooser colorChooser = new ColorChooser(this);


  public EditorOptions(Editor editor)
  {
    try
    {
    this.editor = editor;
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    xYLayout1.setHeight(130);
    xYLayout1.setWidth(290);
    colorButton.setText("Colors");
    colorButton.setToolTipText("Change color of selection.");
    colorButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        colorButton_actionPerformed(e);
      }
    });
    fontButton.setText("Fonts");
    fontButton.setToolTipText("Change current font.");
    fontButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        fontButton_actionPerformed(e);
      }
    });
    label.setText("Local Options");
    label.setFont(new Font("Serif", 3, 20));
    this.getContentPane().setLayout(xYLayout1);
    this.setTitle("Editor Options");
    this.getContentPane().add(colorButton, new XYConstraints(29, 51, 93, 36));
    this.getContentPane().add(fontButton, new XYConstraints(163, 51, 93, 36));
    this.getContentPane().add(label, new XYConstraints(88, 8, 130, 35));
    this.setBounds(getToolkit().getScreenSize().width/2 - 145, getToolkit().getScreenSize().height/2 - 65, 290, 130);
    this.setResizable(false);
  }

  void colorButton_actionPerformed(ActionEvent e)
  {
    this.setVisible(false);
    Color color = JColorChooser.showDialog(this, "Color Chooser", Color.black);

    //System.out.println("Color: " + color);


    StyleContext styles = new StyleContext();
    Style def = styles.getStyle(StyleContext.DEFAULT_STYLE);

    Style userdef = styles.addStyle("userdef", def);
    StyleConstants.setForeground(userdef, color);

    editor.doc.setCharacterAttributes(editor.theText.getSelectionStart(), editor.theText.getSelectionEnd()-editor.theText.getSelectionStart(), userdef, false);
    editor.par.requestFocus();
  }

  void fontButton_actionPerformed(ActionEvent e)
  {
    this.setVisible(false);
    FontChooser fontChooser = new FontChooser(this, "Select Font", Font.getFont("courier-14"));
    fontChooser.setVisible(true);

    Font f = fontChooser.getValue();

    if(fontChooser.getResult() == FontChooser.OK)
    {
      StyleContext styles = new StyleContext();
      Style def = styles.getStyle(StyleContext.DEFAULT_STYLE);

      Style userdef = styles.addStyle("userdef", def);

      StyleConstants.setFontFamily(userdef, f.getFamily());
      StyleConstants.setFontSize(userdef, f.getSize());
      StyleConstants.setItalic(userdef, (f.getStyle() == Font.ITALIC)  || (f.getStyle()== Font.BOLD + Font.ITALIC));
      StyleConstants.setBold(userdef, (f.getStyle()== Font.BOLD) || (f.getStyle()== Font.BOLD + Font.ITALIC));

      editor.doc.setCharacterAttributes(editor.theText.getSelectionStart(), editor.theText.getSelectionEnd()-editor.theText.getSelectionStart(), userdef, false);
      editor.par.requestFocus();
    }
  }
}


