
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import java.io.*;

public class Finder extends JFrame
{
  private int offset = 0;
  private int off = 0;
  private int len = 0;
  private static final String prefix = "combo";
  SuperEdit parent;
  int index = 0;
  int buffer = 0;

  JLabel jLabel1;
  XYLayout xYLayout1;
  JComboBox findCombo;
  JPanel scopePanel;
  Border scopeBorder;
  JRadioButton selectedTextRadio;
  XYLayout xYLayout2;
  JRadioButton fromCursorRadio;
  JRadioButton currentFileRadio;
  JRadioButton entireFileRadio;
  ButtonGroup group;
  JButton findButton;
  JButton nextButton;
  JButton closeButton;
  JCheckBox sensitiveBox;
  JCheckBox wholeBox;


  public Finder(SuperEdit parent)
  {
    try
    {
      Conn.conn.status.setText("Finder: Initializing...");
      Conn.conn.status.repaint();
      initHeader();
      this.parent = parent;
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void initHeader()
  {
    jLabel1 = new JLabel();
    Conn.conn.status.setText("Finder: Setup Component -> jLabel1");
    Conn.conn.status.repaint();
    xYLayout1 = new XYLayout();
    Conn.conn.status.setText("Finder: Setup Component -> xYLayout1");
    Conn.conn.status.repaint();
    findCombo = new JComboBox();
    Conn.conn.status.setText("Finder: Setup Component -> findCombo");
    Conn.conn.status.repaint();
    scopePanel = new JPanel();
    Conn.conn.status.setText("Finder: Setup Component -> scopePanel");
    Conn.conn.status.repaint();
    scopeBorder = new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED), "Scope");
    Conn.conn.status.setText("Finder: Setup Component -> scopeBorder");
    Conn.conn.status.repaint();
    selectedTextRadio = new JRadioButton();
    Conn.conn.status.setText("Finder: Setup Component -> selectedTextRadio");
    Conn.conn.status.repaint();
    xYLayout2 = new XYLayout();
    Conn.conn.status.setText("Finder: Setup Component -> xYLayout2");
    Conn.conn.status.repaint();
    fromCursorRadio = new JRadioButton();
    Conn.conn.status.setText("Finder: Setup Component -> fromCursorRadio");
    Conn.conn.status.repaint();
    currentFileRadio = new JRadioButton();
    Conn.conn.status.setText("Finder: Setup Component -> currentFileRadio");
    Conn.conn.status.repaint();
    entireFileRadio = new JRadioButton();
    Conn.conn.status.setText("Finder: Setup Component -> entireFileRadio");
    Conn.conn.status.repaint();
    group = new ButtonGroup();
    Conn.conn.status.setText("Finder: Setup Component -> group");
    Conn.conn.status.repaint();
    findButton = new JButton();
    Conn.conn.status.setText("Finder: Setup Component -> findButton");
    Conn.conn.status.repaint();
    nextButton = new JButton();
    Conn.conn.status.setText("Finder: Setup Component -> nextButton");
    Conn.conn.status.repaint();
    closeButton = new JButton();
    Conn.conn.status.setText("Finder: Setup Component -> closeButton");
    Conn.conn.status.repaint();
    sensitiveBox = new JCheckBox();
    Conn.conn.status.setText("Finder: Setup Component -> sensitiveBox");
    Conn.conn.status.repaint();
    wholeBox = new JCheckBox();
    Conn.conn.status.setText("Finder: Setup Component -> wholeBox");
    Conn.conn.status.repaint();
  }

  private void incIndex()
  {
    index = (index + 1)%10;
  }

  private void jbInit() throws Exception
  {
    try
    {
	    java.net.URL url = getClass().getResource("images/findIco.gif");
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}

    this.setResizable(false);
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });
    this.setTitle("Find");
    this.getContentPane().setLayout(xYLayout1);
    jLabel1.setText("Find");
    jLabel1.setFont(new Font("Dialog", 1, 14));
    xYLayout1.setHeight(162);
    findCombo.setEditable(true);
    xYLayout1.setWidth(405);
    scopePanel.setLayout(xYLayout2);
    scopePanel.setBorder(scopeBorder);
    selectedTextRadio.setText("Selected Text");
    fromCursorRadio.setText("From Cursor");
    currentFileRadio.setText("Entire File");
    currentFileRadio.setSelected(true);
    entireFileRadio.setText("Entire Project");
    findButton.setText("Find");
    findButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        findButton_actionPerformed(e);
      }
    });
    nextButton.setEnabled(false);
    nextButton.setText("Next");
    nextButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        nextButton_actionPerformed(e);
      }
    });
    closeButton.setText("Close");
    closeButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        closeButton_actionPerformed(e);
      }
    });
    sensitiveBox.setText("Case Sensitive");
    sensitiveBox.setForeground(new Color(102, 102, 153));
    sensitiveBox.setSelected(true);
    wholeBox.setText("Whole Word Only");
    wholeBox.setForeground(new Color(102, 102, 153));
    this.getContentPane().add(jLabel1, new XYConstraints(13, 7, 35, 23));
    this.getContentPane().add(findCombo, new XYConstraints(53, 7, 248, 23));
    this.getContentPane().add(scopePanel, new XYConstraints(11, 32, 286, 79));
    scopePanel.add(selectedTextRadio, new XYConstraints(21, 5, -1, -1));
    scopePanel.add(fromCursorRadio, new XYConstraints(21, 27, -1, 23));
    scopePanel.add(currentFileRadio, new XYConstraints(167, 5, -1, 23));
    scopePanel.add(entireFileRadio, new XYConstraints(167, 25, -1, -1));
    group.add(selectedTextRadio);
    group.add(fromCursorRadio);
    group.add(currentFileRadio);
    group.add(entireFileRadio);
    this.getContentPane().add(findButton, new XYConstraints(321, 7, 69, 26));
    this.getContentPane().add(nextButton, new XYConstraints(321, 43, 69, 26));
    this.getContentPane().add(closeButton, new XYConstraints(321, 79, 69, 26));
    this.getContentPane().add(sensitiveBox, new XYConstraints(10, 117, 103, 17));
    this.getContentPane().add(wholeBox, new XYConstraints(128, 117, 123, 17));
    this.setBounds(getToolkit().getScreenSize().width/2 - 150, getToolkit().getScreenSize().height/2 - 200, 403, 162);
  }

  void findButton_actionPerformed(ActionEvent e)
  {
    String res = (String) findCombo.getSelectedItem();

    if(this.parent.currentEditor == null) {return;}
    
    if(res.equals("") || res == null)
    {return;}

    boolean notDupe = true;

    for(int i =0; i < findCombo.getItemCount(); i++)
    {
     if(res.equals(findCombo.getItemAt(i)))
     {
       notDupe = false;
     }
    }

    if(notDupe)
    {
      findCombo.insertItemAt(res, index);
      incIndex();
    }

    this.nextButton.setEnabled(true);
    this.nextButton.repaint();

    off = getStart();
    len = getEnd() - getStart();

    int retVal = findIt(0, res);
    buffer = retVal;
    if(retVal < 0) {JOptionPane.showMessageDialog(this, "No more occurrences of " + res); buffer = 0; parent.workspace.requestFocus(); this.requestFocus();}

  }

  void closeButton_actionPerformed(ActionEvent e)
  {
    this.setVisible(false);
    this.nextButton.setEnabled(false);
    this.nextButton.repaint();
    buffer = 0;
  }

  void nextButton_actionPerformed(ActionEvent e)
  {
     int retVal = findIt(buffer, (String) findCombo.getSelectedItem());
     if(retVal < 0) {JOptionPane.showMessageDialog(this, "No more occurrences of " + (String) findCombo.getSelectedItem()); buffer = 0; this.nextButton.setEnabled(false); parent.workspace.requestFocus(); this.requestFocus();}
     else {buffer = retVal;}
  }

  void this_windowClosing(WindowEvent e)
  {
    this.nextButton.setEnabled(false);
    buffer = 0;
  }

  void saveConfig()
  {
    try
    {
      File dir = new File("Config");
      if(!dir.exists())
      {
        dir.mkdir();
      }

      File configFile = new File(dir, "Finder.properties");

      java.util.Properties props = new java.util.Properties();

      /*
         Place all modifiable components such as Checkboxes here.
      */

      for(int i = 0; i < findCombo.getItemCount(); i++)
      {
         props.put(prefix + i, "" + findCombo.getItemAt(i));
      }

      props.put("index", "" + index);
      props.put("selectedIndex", "" + findCombo.getSelectedIndex());

      props.put("entireFileRadio", "" + entireFileRadio.isSelected());
      props.put("fromCursorRadio", "" + fromCursorRadio.isSelected());
      props.put("selectedTextRadio", "" + selectedTextRadio.isSelected());
      props.put("currentFileRadio", "" + currentFileRadio.isSelected());

      props.put("sensitiveBox", "" + sensitiveBox.isSelected());
      props.put("wholeBox", "" + wholeBox.isSelected());


      FileOutputStream fos = new FileOutputStream(configFile);

      props.save(fos, Utility.genHeader("Finder Configuration File"));
      fos.close();

    }
    catch(Exception IDEx)
    {
      JOptionPane.showMessageDialog(this, "Couldn't save SuperEdit Configuration");
    }
  }

  public void loadConfig()
  {
    try
    {
      File dir = new File("Config");
      if(dir.exists())
      {
        File configFile = new File(dir, "Finder.properties");
        java.util.Properties props = new java.util.Properties();
        FileInputStream fis = new FileInputStream(configFile);
        props.load(fis);
        fis.close();

        boolean flag = true;
        int seed = 0;

        while(flag)
        {
          String res = props.getProperty(prefix + seed, "NOT FOUND");
          seed += 1;
          if(res.equals("NOT FOUND"))
          {
            flag = false;
          }
          else
          {
            findCombo.addItem(res);
      Conn.conn.status.setText("Finder: Scan Config -> Find: " + res);
      Conn.conn.status.repaint();
          }
        }

        index = Integer.valueOf(props.getProperty("index")).intValue();
        findCombo.setSelectedIndex(Integer.valueOf(props.getProperty("selectedIndex")).intValue());

        entireFileRadio.setSelected( Boolean.valueOf(props.getProperty("entireFileRadio")).booleanValue());
        fromCursorRadio.setSelected( Boolean.valueOf(props.getProperty("fromCursorRadio")).booleanValue());
        selectedTextRadio.setSelected( Boolean.valueOf(props.getProperty("selectedTextRadio")).booleanValue());
        currentFileRadio.setSelected( Boolean.valueOf(props.getProperty("currentFileRadio")).booleanValue());

        sensitiveBox.setSelected( Boolean.valueOf(props.getProperty("sensitiveBox")).booleanValue());
        wholeBox.setSelected( Boolean.valueOf(props.getProperty("wholeBox")).booleanValue());

      }
    }
    catch(Exception e) {;}
  }

  public int findIt(int start, String val)
  {
    int res = - 100;
    try
    {
      //String text = parent.currentEditor.doc.getText(0, parent.currentEditor.doc.getLength());
      //String text = parent.currentEditor.doc.getText(getStart(), getEnd() - getStart());
      //res = text.indexOf(val, start);
      res = getNextIndex(start, val);
      if(res >= 0)
      {
        parent.currentEditor.theText.setCaretPosition(res+offset);
        parent.currentEditor.theText.setSelectionStart(res+offset);
        parent.currentEditor.theText.setSelectionEnd(res + val.length()+offset);
        return res + val.length();
      }
    }
    catch(Exception e) {return -100;}
    return res ;
  }

  private int getNextIndex(int start, String val)
  {
    int x = start;

    try
    {
      //String text = parent.currentEditor.doc.getText(0, parent.currentEditor.doc.getLength());
      String text = parent.currentEditor.doc.getText(off, len);

      while(!text.regionMatches(!sensitiveBox.isSelected(), x, val, 0, val.length()))
      {
        x += 1;
        if(x + val.length() > text.length()) {return -100;}
      }

      if(wholeBox.isSelected())
      {
        if((x>0) ? isWhite(parent.currentEditor.doc.getText(x-1,1)) && isWhite(parent.currentEditor.doc.getText(x+val.length(),1)) : isWhite(parent.currentEditor.doc.getText(x+val.length(),1)))
        {
          return x;
        }
        else
        {
          return getNextIndex(x+1, val);
        }
      }
      else
      {
        return x;
      }
    }
    catch(Exception e) {return -100;}
  }

  public boolean isWhite(String str)
  {
    if(str.equals(" ") ||
       str.equals("\t") ||
       str.equals("[") ||
       str.equals("]") ||
       str.equals("(") ||
       str.equals(")") ||
       str.equals("\r") ||
       str.equals("\n") ||
       str.equals("=") ||
       str.equals("{") ||
       str.equals("}") ||
       str.equals("+") ||
       str.equals(".") ||
       str.equals("-") ||
       str.equals("*") ||
       str.equals("/") ||
       str.equals("*") ||
       str.equals("&") ||
       str.equals("|") ||
       str.equals(">") ||
       str.equals("<") ||
       str.equals(";"))

    {
      return true;
    }
    else
    {
      return false;
    }
  }

  public int getStart()
  {
    if(entireFileRadio.isSelected()) {offset=0; return 0;}
    else if(selectedTextRadio.isSelected()) {offset = parent.currentEditor.theText.getSelectionStart(); return offset;}
    else if(fromCursorRadio.isSelected()) {offset=this.parent.currentEditor.theText.getCaretPosition(); return offset;}
    else {offset = 0; return 0;}
  }

  public int getEnd()
  {
    if(entireFileRadio.isSelected()) {return parent.currentEditor.doc.getLength();}
    else if(selectedTextRadio.isSelected()) {return parent.currentEditor.theText.getSelectionEnd();}
    else if(fromCursorRadio.isSelected()) {return parent.currentEditor.doc.getLength();}
    else return parent.currentEditor.doc.getLength();
  }


}


