/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import com.sun.java.swing.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.text.*;
import java.util.Hashtable;
import java.awt.*;

public class Fontifier implements CaretListener
{
  public StyleContext highlights;
  public WordMap wordType = getWords();
  Editor editor;
  private boolean lock = false;
  public String res = " ";
  JTextPane echo;
  private boolean isComment = false;
  boolean isString = false;
  int padCell = 0;
  int lastPos = 0;
  private Style currentStyle;

  public static final int NO_COMMENT = 0;
  public static final int SLASH_SLASH = 1;
  public static final int SLASH_STAR = 2;

  private int commentType = 0;

  public Fontifier(Editor edi)
  {
    super();
    this.editor = edi;
    highlights = initContext();

    Style ls = highlights.getStyle("normal");
    this.editor.doc.setLogicalStyle(this.editor.doc.getLength() - 1, ls);

    /*JFrame tmp = new JFrame();
    tmp.getContentPane().setLayout(new BorderLayout());
    echo = makeEcho();
    tmp.getContentPane().add(echo, BorderLayout.CENTER);
    tmp.setBounds(50, 50, 300, 400);
    tmp.setVisible(true);*/
  }

  public void caretUpdate(CaretEvent e)
  {
    try
    {
      String tst = editor.doc.getText(e.getDot() - 2, 2);
      if(tst.equals("//") && commentType == NO_COMMENT && !isString && e.getDot() > lastPos)   // Start a Slash-Slash comment
      {
        isComment = true;
        commentType = SLASH_SLASH;
        //(new LooperAux(editor, e.getDot()-2, 2, highlights.getStyle("comment"), false)).start();
        //(new LooperAux(editor, e.getDot()-2, highlights.getStyle("comment"))).start();
      }
      else if(tst.equals("/*") && commentType == NO_COMMENT && !isString && e.getDot() > lastPos)   // Start a Slash-Star comment
      {
        isComment = true;
        commentType = SLASH_STAR;
        //(new LooperAux(editor, e.getDot()-2, 2, highlights.getStyle("comment"), false)).start();
      }
      else if(tst.equals("*/") && commentType == SLASH_STAR && !isString && e.getDot() > lastPos)   // End a Slash-Star comment
      {
        isComment = false;
        commentType = NO_COMMENT;
        padCell = 2;
        currentStyle = highlights.getStyle("comment");
        //(new LooperAux(editor, e.getDot()-1, highlights.getStyle("normal"))).start();
        //(new LooperAux(editor, e.getDot(), 1, highlights.getStyle("normal"), true)).start();
        lastPos = e.getDot();
        return;
      }
      else if(editor.doc.getText(e.getDot() - 1, 1).equals("\n") && commentType == SLASH_SLASH && !isString && e.getDot() > lastPos)   // End a Slash-Slash comment
      {
        isComment = false;
        commentType = NO_COMMENT;
        padCell = 1;
        currentStyle = highlights.getStyle("comment");
        //(new LooperAux(editor, e.getDot(), highlights.getStyle("normal"))).start();
        //(new LooperAux(editor, e.getDot()-1, 1, highlights.getStyle("normal"), true)).start();
        //(new LooperAux(editor, e.getDot(), highlights.getStyle("normal"))).start();
        lastPos = e.getDot();
        return;
      }
    }
    catch(Exception e3)
    {
        lastPos = e.getDot();
    }

    if(isComment && e.getDot() > lastPos)
    {
      //(new LooperAux(editor, e.getDot()-2, 2, highlights.getStyle("comment"), false)).start();
      (new LooperAux(editor, e.getDot()-2, 1, highlights.getStyle("comment"), false)).start();
      lastPos = e.getDot();
      return;
    }

    if(padCell != 0)
    {
      if(padCell==1)
      {
        (new LooperAux(editor, e.getDot()-3, 2, currentStyle, false)).start();
      }
      else if(padCell==2)
      {
        (new LooperAux(editor, e.getDot()-(padCell+1), padCell, currentStyle, false)).start();
      }

      padCell = 0;
    }

    try
    {
      String tst = editor.doc.getText(e.getDot() - 1, 1);
      if(tst.equals("\"") && !isString && e.getDot() > lastPos)   // Start a String
      {
        isString = true;
        lastPos = e.getDot();
        return;
      }

      else if(tst.equals("\"") && isString  && e.getDot() > lastPos)   // End a String
      {
        if(!editor.doc.getText(e.getDot() - 2, 1).equals("\\") && e.getDot() > lastPos)
        {
          isString = false;
          padCell = 1;
          currentStyle = highlights.getStyle("string");
        }
        lastPos = e.getDot();
        return;
      }


    }
    catch(Exception e4) {lastPos = e.getDot();}

    if(isString && e.getDot() > lastPos)
    {
      (new LooperAux(editor, e.getDot()-2, 1, highlights.getStyle("string"), false)).start();
       lastPos = e.getDot();
      return;
    }




   // This is not a comment -- do normal syntax highlighting
   Point p1 = getEndpoints(e.getDot());

   if(p1.x >= 0)
   {
     try
     {
       // editor.removeFontifier(this);
       res = editor.doc.getText(p1.x, p1.y - p1.x);

       if(!wordType.get(res).equals("normal"))
       {
         editor.watcher.resume();
         /*
          Debug info to make sure that threads are notified of document edits.
          System.out.println(res + ": " + wordType.get(res));
         */

         editor.x = p1.x;
         editor.y = p1.y;
         editor.currentStyle = highlights.getStyle(wordType.get(res));
         editor.wordFound = true;

         /*
          editor.doc.setLogicalStyle(p1.x, highlights.getStyle(wordType.get(res)));
          echo.getStyledDocument().insertString(echo.getStyledDocument().getLength(), res, highlights.getStyle(wordType.get(res)));
          editor.addFontifier(this);
         */
       }
     }
     catch(Exception ex) { System.err.println("Unhandled Fontifier Exception: " + ex); ex.printStackTrace();}
   }

  }

  public JTextPane makeEcho()
  {
    StyleContext s2 = new StyleContext();
    DefaultStyledDocument d2 = new DefaultStyledDocument(s2);
    return new JTextPane(d2);
  }

  public void update(Point p3, String res)
  {
     try
     {
       editor.doc.remove(p3.x, p3.y - p3.x);
       editor.doc.insertString(p3.x, res, highlights.getStyle(wordType.get(res)));
     }
     catch(Exception ex) { System.err.println("Unhandled Exception: " + ex); }
  }

  public boolean isWhite(String str)
  {
    if(str.equals(" ") ||
       str.equals("\t") ||
       str.equals("(") ||
       str.equals(")") ||
       str.equals("{") ||
       str.equals("}") ||
       str.equals("[") ||
       str.equals("]") ||
       str.equals(".") ||
       str.equals("\r") ||
       str.equals(";") ||
       str.equals("\n")
       )
    {
      return true;
    }
    else
    {
      return false;
    }
  }

  private WordMap getWords()
  {
    WordMap words = new WordMap();

    words.put("public", "keyword");
    words.put("private", "keyword");
    words.put("protected", "keyword");

    words.put("class", "keyword");
    words.put("interface", "keyword");
    words.put("this", "keyword");
    words.put("super", "keyword");

    words.put("static", "keyword");
    words.put("abstract", "keyword");
    words.put("void", "keyword");
    words.put("int", "keyword");
    words.put("float", "keyword");
    words.put("double", "keyword");
    words.put("long", "keyword");
    words.put("boolean", "keyword");
    words.put("char", "keyword");
    words.put("byte", "keyword");
    words.put("short", "keyword");
    words.put("String", "keyword");

    words.put("if", "keyword");
    words.put("else", "keyword");
    words.put("while", "keyword");
    words.put("do", "keyword");
    words.put("switch", "keyword");
    words.put("for", "keyword");

    words.put("import", "keyword");
    words.put("package", "keyword");
    words.put("extends", "keyword");
    words.put("implements", "keyword");

    words.put("break", "keyword");
    words.put("continue", "keyword");
    words.put("synchronized", "keyword");
    words.put("final", "keyword");
    words.put("native", "keyword");
    words.put("transient", "keyword");
    words.put("volitile", "keyword");

    words.put("try", "keyword");
    words.put("catch", "keyword");
    words.put("finally", "keyword");
    words.put("throws", "keyword");

    words.put("null", "keyword");
    words.put("return", "keyword");

    words.put("true", "keyword");
    words.put("false", "keyword");

    return words;
  }

  class WordMap
  {
   Hashtable data;

   public WordMap()
   {
     data = new Hashtable();
   }

   public void put(String key, String value)
   {
    data.put(key, value);
   }

   public String get(String key)
   {
     String found = (String) data.get(key);
     if(found == null)
     {
       IDEOptions ide =  SuperEdit.superEdit.ideOptions;
       String foundAux = (String) ide.keywordTable.get(key);
       if(foundAux == null)
       {
         return "normal";
       }
       else
       {
         return foundAux;
       }
     }
     else
     {
       return found;
     }
   }
  }

  public StyleContext initContext()
  {
    StyleContext styles = new StyleContext();
    DefaultStyledDocument doc = new DefaultStyledDocument(styles);


    Style def = styles.getStyle(StyleContext.DEFAULT_STYLE);

    //if(SuperEdit.superEdit == null){System.out.println("SuperEdit");}

    // normal -- Plain, Black, 14 pt. SansSerif
    Style normal = styles.addStyle("normal", def);
    StyleConstants.setFontFamily(normal, (String)SuperEdit.superEdit.ideOptions.fFamilyCombo.getSelectedItem());
    StyleConstants.setFontSize(normal, ((Integer)SuperEdit.superEdit.ideOptions.fSizeCombo.getSelectedItem()).intValue());
    StyleConstants.setForeground(normal, SuperEdit.superEdit.ideOptions.defaultTextColor);
    StyleConstants.setBold(normal, false);
    StyleConstants.setItalic(normal, false);

    // Keywords -- Bold, Blue, 14 pt. SansSerif
    Style sty =  styles.addStyle("keyword", normal);
    StyleConstants.setForeground(sty, SuperEdit.superEdit.ideOptions.keywordColor);
    StyleConstants.setBold(sty, true);

    // Custom Keywords -- Bold, Blue, 14 pt. SansSerif
    sty =  styles.addStyle("custom", normal);
    StyleConstants.setForeground(sty, SuperEdit.superEdit.ideOptions.customKeywordColor);
    StyleConstants.setBold(sty, true);

    // Comments -- Italic, purple, 14 pt. SansSerif
    sty =  styles.addStyle("comment", normal);
    StyleConstants.setForeground(sty, SuperEdit.superEdit.ideOptions.commentColor);
    StyleConstants.setBold(sty, false);
    StyleConstants.setItalic(sty, true);

    // String -- Plain, red, 14 pt. SansSerif
    sty =  styles.addStyle("string", normal);
    StyleConstants.setForeground(sty, SuperEdit.superEdit.ideOptions.stringColor);
    StyleConstants.setBold(sty, false);
    StyleConstants.setItalic(sty, false);

    return styles;
  }

  public class Point
  {
    public int x;
    public int y;

    public Point(int x, int y)
    {
      this.x = x;
      this.y = y;
    }

    public String toString()
    {
      return "(" + x + ", " + y + ")";
    }

    public boolean equals(Point p)
    {
      if(x == p.x && y == p.y)
      {
       return true;
      }
      else
      {
       return false;
      }
    }
  }

  public Point getEndpoints(int currentCaretPosition)
  {
    String res;
    try
    {
      int init = currentCaretPosition-1;
      res = editor.doc.getText(init, 1);
      if(isWhite(res))
      {
        int x = 0;
        int y = 0;

        int offset = 1;

        // Find rightmost char
        try{
        while(isWhite(editor.doc.getText(currentCaretPosition - offset, 1)))
        {
          offset = offset + 1;
          //System.out.println("y: " + (currentCaretPosition - offset)); // debug
        }
        y = currentCaretPosition - offset; }
        catch(Exception e2)
        {
          y = currentCaretPosition - offset + 1;
        }

        // Find leftmost char
        try{
        while(!isWhite(editor.doc.getText(currentCaretPosition - offset, 1)))
        {
          offset = offset + 1;
          //System.out.println("x: " + (currentCaretPosition - offset)); // debug
        }
        x = currentCaretPosition - offset; }
        catch(Exception e3)
        {
          x = currentCaretPosition - offset;
          //y = y + 1;
        }

        return new Point(x+1,y+1);

      }
      else
      {
        return new Point(-1,-1);
      }
    }
    catch(Exception ex) { return new Point(-2,-2); }



  }

}