
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import borland.jbcl.layout.*;
import com.sun.java.swing.*;
import com.sun.java.swing.preview.*;
import com.sun.java.swing.border.*;
import java.awt.event.*;
import java.io.Serializable;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.File;

public class IDEOptions extends JFrame implements Serializable{

  Icon defaultIcon;
  java.util.Hashtable keywordTable;

  // **************** LISTS **********************

  DefaultListModel keywordModel;
  DefaultListModel sectionModel;
  DefaultListModel itemModel;


  // **************** LISTS **********************

  XYLayout xYLayout1;
  JTabbedPane tabs;
  JPanel editorPane;
  XYLayout xYLayout2;
  JPanel displayPane;
  JPanel highlightPane;
  JPanel buttonsPane;
  JPanel pluginsPane;
  XYLayout xYLayout3;
  XYLayout xYLayout4;
  XYLayout xYLayout6;
  JButton okButton;
  JButton cancelButton;
  JButton helpButton;
  JLabel configLabel;


  // *************** ICONS ********************

  public Color browserSelectColor;
  public Color highlightColor;
  public Color defaultTextColor;
  public Color stringColor;
  public Color commentColor;
  public Color keywordColor;
  public Color customKeywordColor;


  private Icon browserSelectIcon;
  private Icon highlightIcon;
  private Icon defaultTextIcon;
  private Icon stringIcon;
  private Icon commentIcon;
  private Icon keywordIcon;
  private Icon customKeywordIcon;


  // ******************************************

  JComboBox configCombo;

  JButton saveConfigButton;
  Border editBorder;
  Border colorBorder;
  JPanel innerEditPanel;
  XYLayout xYLayout7;
  SuperEdit parent;
  JCheckBox backupBox;
  JCheckBox saveOnCloseBox;
  JCheckBox autoIndentBox;
  JCheckBox scanPluginsBox;
  JCheckBox scanRADBox1;
  JCheckBox autoMaximizeBox;
  JCheckBox scanLangsBox2;
  JCheckBox autoFontifyBox;
  JCheckBox scanStructureBox;
  JCheckBox openLastBox;
  JCheckBox rememberLocationBox;
  JLabel autoLabel;
  JCheckBox enableAutosave;
  JComboBox timeCombo;
  JLabel timeLabel;
  JCheckBox indentBox;
  JLabel sizeLabel;
  JComboBox indentCombo;
  BorderLayout borderLayout1;
  JTabbedPane buttonTabs;
  JPanel toolbarPane;
  XYLayout xYLayout5;
  XYLayout xYLayout8;
  JPanel archivePane;
  XYLayout xYLayout9;
  JPanel classPane;
  JList sectionList;
  JScrollPane sectionScroller;
  JList itemList;
  JScrollPane itemScroller;
  BevelBorder listBorder;
  JLabel jLabel1;
  JLabel jLabel2;
  JButton removeButton;
  JButton upButton;
  JButton downButton;
  JButton newButton;
  JPanel customPane;
  XYLayout xYLayout10;
  JLabel jLabel3;
  JTextField pathField;
  JButton findButton;
  JList foundarchives;
  JLabel jLabel4;
  JLabel jLabel5;
  JTextField packageField;
  JButton jButton1;
  JList packageItemList;
  JLabel jLabel6;
  JLabel jLabel7;
  JTextField customTip;
  JLabel jLabel8;
  JTextField customImageName;
  JButton jButton3;
  JPanel buttonPreview;
  JTextArea codeTextArea;
  JScrollPane codeScroller;
  JLabel jLabel9;
  JLabel jLabel10;
  JLabel jLabel11;
  JList pluginList;
  JButton addArchiveButton;
  JButton addClassButton;
  JButton addCustomItem;
  JCheckBox enableToolTipsBox;
  JPanel colorPanel;
  XYLayout xYLayout11;
  JLabel browseLabel;
  JLabel highlightLabel;
  JLabel textLabel;
  JLabel commentLabel;
  JLabel stringLabel;
  JLabel keywordLabel;
  JLabel customLabel;
  JButton changeBrowseButton;
  JButton defaultBrowseButton;
  JButton changeHighlightButton;
  JButton changeTextButton;
  JButton changeCommentButton;
  JButton changeStringButton;
  JButton changeKeywordButton;
  JButton changeCustomButton;
  JButton defaultHighlightButton;
  JButton defaultTextButton;
  JButton defaultCommentButton;
  JButton defaultStringButton;
  JButton defaultKeywordButton;
  JButton defaultCustomButton;
  JCheckBox showProgressBox;
  JLabel jLabel12;
  JLabel jLabel13;
  JLabel jLabel14;
  JComboBox fFamilyCombo;
  JComboBox fSizeCombo;
  JCheckBox showRulerBox;
  JCheckBox showSplashBox;

  JList keywordList;
  JScrollPane keyWordScroller;

  JButton addKeywordButton;
  JButton deleteKeywordButton;
  JButton removeAllKeywordsButton;
  JButton previewButton;
  XYLayout xYLayout12;
  JLabel jLabel15;
  JLabel jLabel16;
  JLabel jLabel17;
  JTextField customDescription;
  JPopupMenu popup;
  JMenuItem editPopup;
  JMenuItem removePopup;


  public IDEOptions(SuperEdit parent)
  {
    try
    {
      initHeader();
      Conn.conn.status.setText("IDEOptions: Initializing...");
      Conn.conn.status.repaint();
      this.parent = parent;
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void initHeader()
  {
    defaultIcon = loadImageIcon("images/32/help.gif", "defaultIcon");
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultIcon");
    Conn.conn.status.repaint();
    keywordTable = new java.util.Hashtable();
    Conn.conn.status.setText("IDEOptions: Setup Component -> keywordTable");
    Conn.conn.status.repaint();
    keywordModel = new DefaultListModel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> keywordModel");
    Conn.conn.status.repaint();
    sectionModel = new DefaultListModel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> sectionModel");
    Conn.conn.status.repaint();
    itemModel = new DefaultListModel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> itemModel");
    Conn.conn.status.repaint();
    xYLayout1 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout1");
    Conn.conn.status.repaint();
    tabs = new JTabbedPane();
    Conn.conn.status.setText("IDEOptions: Setup Component -> tabs");
    Conn.conn.status.repaint();
    editorPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> editorPane");
    Conn.conn.status.repaint();
    xYLayout2 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout2");
    Conn.conn.status.repaint();
    displayPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> displayPane");
    Conn.conn.status.repaint();
    highlightPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> highlightPane");
    Conn.conn.status.repaint();
    buttonsPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> buttonsPane");
    Conn.conn.status.repaint();
    pluginsPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> pluginsPane");
    Conn.conn.status.repaint();
    xYLayout3 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout3");
    Conn.conn.status.repaint();
    xYLayout4 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout4");
    Conn.conn.status.repaint();
    xYLayout6 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout6");
    Conn.conn.status.repaint();
    okButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> okButton");
    Conn.conn.status.repaint();
    cancelButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> cancelButton");
    Conn.conn.status.repaint();
    helpButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> helpButton");
    Conn.conn.status.repaint();
    configLabel = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> configLabel");
    Conn.conn.status.repaint();
    browserSelectColor = Color.yellow;
    Conn.conn.status.setText("IDEOptions: Setup Component -> browserSelectColor");
    Conn.conn.status.repaint();
    highlightColor = new Color(204, 204, 255);
    Conn.conn.status.setText("IDEOptions: Setup Component -> highlightColor");
    Conn.conn.status.repaint();
    defaultTextColor = Color.black;
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultTextColor");
    Conn.conn.status.repaint();
    stringColor = Color.red;
    Conn.conn.status.setText("IDEOptions: Setup Component -> stringColor");
    Conn.conn.status.repaint();
    commentColor = new Color(150, 7, 158);
    Conn.conn.status.setText("IDEOptions: Setup Component -> commentColor");
    Conn.conn.status.repaint();
    keywordColor = Color.blue;
    Conn.conn.status.setText("IDEOptions: Setup Component -> keywordColor");
    Conn.conn.status.repaint();
    customKeywordColor = Color.blue;
    Conn.conn.status.setText("IDEOptions: Setup Component -> customKeywordColor");
    Conn.conn.status.repaint();
    browserSelectIcon = new ColoredSquare(browserSelectColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> browserSelectIcon");
    Conn.conn.status.repaint();
    highlightIcon = new ColoredSquare(highlightColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> highlightIcon");
    Conn.conn.status.repaint();
    defaultTextIcon = new ColoredSquare(defaultTextColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultTextIcon");
    Conn.conn.status.repaint();
    stringIcon = new ColoredSquare(stringColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> stringIcon");
    Conn.conn.status.repaint();
    commentIcon = new ColoredSquare(commentColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> commentIcon");
    Conn.conn.status.repaint();
    keywordIcon = new ColoredSquare(keywordColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> keywordIcon");
    Conn.conn.status.repaint();
    customKeywordIcon = new ColoredSquare(customKeywordColor);
    Conn.conn.status.setText("IDEOptions: Setup Component -> customKeywordIcon");
    Conn.conn.status.repaint();
    configCombo = new JComboBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> configCombo");
    Conn.conn.status.repaint();
    saveConfigButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> saveConfigButton");
    Conn.conn.status.repaint();
    editBorder = new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED), "Editor Options");
    Conn.conn.status.setText("IDEOptions: Setup Component -> editBorder");
    Conn.conn.status.repaint();
    colorBorder = new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED), "Color Selections");
    Conn.conn.status.setText("IDEOptions: Setup Component -> colorBorder");
    Conn.conn.status.repaint();
    innerEditPanel = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> innerEditPanel");
    Conn.conn.status.repaint();
    xYLayout7 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout7");
    Conn.conn.status.repaint();
    backupBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> backupBox");
    Conn.conn.status.repaint();
    saveOnCloseBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> saveOnCloseBox");
    Conn.conn.status.repaint();
    autoIndentBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> autoIndentBox");
    Conn.conn.status.repaint();
    scanPluginsBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> scanPluginsBox");
    Conn.conn.status.repaint();
    scanRADBox1 = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> scanRADBox1");
    Conn.conn.status.repaint();
    autoMaximizeBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> autoMaximizeBox");
    Conn.conn.status.repaint();
    scanLangsBox2 = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> scanLangsBox2");
    Conn.conn.status.repaint();
    autoFontifyBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> autoFontifyBox");
    Conn.conn.status.repaint();
    scanStructureBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> scanStructureBox");
    Conn.conn.status.repaint();
    openLastBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> openLastBox");
    Conn.conn.status.repaint();
    rememberLocationBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> rememberLocationBox");
    Conn.conn.status.repaint();
    autoLabel = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> autoLabel");
    Conn.conn.status.repaint();
    enableAutosave = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> enableAutosave");
    Conn.conn.status.repaint();
    timeCombo = new JComboBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> timeCombo");
    Conn.conn.status.repaint();
    timeLabel = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> timeLabel");
    Conn.conn.status.repaint();
    indentBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> indentBox");
    Conn.conn.status.repaint();
    sizeLabel = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> sizeLabel");
    Conn.conn.status.repaint();
    indentCombo = new JComboBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> indentCombo");
    Conn.conn.status.repaint();
    borderLayout1 = new BorderLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> borderLayout1");
    Conn.conn.status.repaint();
    buttonTabs = new JTabbedPane();
    Conn.conn.status.setText("IDEOptions: Setup Component -> buttonTabs");
    Conn.conn.status.repaint();
    toolbarPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> toolbarPane");
    Conn.conn.status.repaint();
    xYLayout5 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout5");
    Conn.conn.status.repaint();
    xYLayout8 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout8");
    Conn.conn.status.repaint();
    archivePane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> archivePane");
    Conn.conn.status.repaint();
    xYLayout9 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout9");
    Conn.conn.status.repaint();
    classPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> classPane");
    Conn.conn.status.repaint();
    sectionList = new JList(sectionModel);
    Conn.conn.status.setText("IDEOptions: Setup Component -> sectionList");
    Conn.conn.status.repaint();
    sectionScroller = new JScrollPane(sectionList);
    Conn.conn.status.setText("IDEOptions: Setup Component -> sectionScroller");
    Conn.conn.status.repaint();
    itemList = new pList(itemModel);
    Conn.conn.status.setText("IDEOptions: Setup Component -> itemList");
    Conn.conn.status.repaint();
    itemScroller = new JScrollPane(itemList);
    Conn.conn.status.setText("IDEOptions: Setup Component -> itemScroller");
    Conn.conn.status.repaint();
    listBorder = new BevelBorder(BevelBorder.LOWERED);
    Conn.conn.status.setText("IDEOptions: Setup Component -> listBorder");
    Conn.conn.status.repaint();
    jLabel1 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel1");
    Conn.conn.status.repaint();
    jLabel2 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel2");
    Conn.conn.status.repaint();
    removeButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> removeButton");
    Conn.conn.status.repaint();
    upButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> upButton");
    Conn.conn.status.repaint();
    downButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> downButton");
    Conn.conn.status.repaint();
    newButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> newButton");
    Conn.conn.status.repaint();
    customPane = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> customPane");
    Conn.conn.status.repaint();
    xYLayout10 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout10");
    Conn.conn.status.repaint();
    jLabel3 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel3");
    Conn.conn.status.repaint();
    pathField = new JTextField();
    Conn.conn.status.setText("IDEOptions: Setup Component -> pathField");
    Conn.conn.status.repaint();
    findButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> findButton");
    Conn.conn.status.repaint();
    foundarchives = new JList();
    Conn.conn.status.setText("IDEOptions: Setup Component -> foundarchives");
    Conn.conn.status.repaint();
    jLabel4 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel4");
    Conn.conn.status.repaint();
    jLabel5 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel5");
    Conn.conn.status.repaint();
    packageField = new JTextField();
    Conn.conn.status.setText("IDEOptions: Setup Component -> packageField");
    Conn.conn.status.repaint();
    jButton1 = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jButton1");
    Conn.conn.status.repaint();
    packageItemList = new JList();
    Conn.conn.status.setText("IDEOptions: Setup Component -> packageItemList");
    Conn.conn.status.repaint();
    jLabel6 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel6");
    Conn.conn.status.repaint();
    jLabel7 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel7");
    Conn.conn.status.repaint();
    customTip = new JTextField();
    Conn.conn.status.setText("IDEOptions: Setup Component -> customTip");
    Conn.conn.status.repaint();
    jLabel8 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel8");
    Conn.conn.status.repaint();
    customImageName = new JTextField();
    Conn.conn.status.setText("IDEOptions: Setup Component -> customImageName");
    Conn.conn.status.repaint();
    jButton3 = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jButton3");
    Conn.conn.status.repaint();
    buttonPreview = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> buttonPreview");
    Conn.conn.status.repaint();
    codeTextArea =  new JTextArea();
    Conn.conn.status.setText("IDEOptions: Setup Component -> codeTextArea");
    Conn.conn.status.repaint();
    codeScroller = new JScrollPane(codeTextArea);
    Conn.conn.status.setText("IDEOptions: Setup Component -> codeScroller");
    Conn.conn.status.repaint();
    jLabel9 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel9");
    Conn.conn.status.repaint();
    jLabel10 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> ");
    Conn.conn.status.repaint();
    jLabel11 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel10");
    Conn.conn.status.repaint();
    pluginList = new JList();
    Conn.conn.status.setText("IDEOptions: Setup Component -> pluginList");
    Conn.conn.status.repaint();
    addArchiveButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> addArchiveButton");
    Conn.conn.status.repaint();
    addClassButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> addClassButton");
    Conn.conn.status.repaint();
    addCustomItem = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> addCustomItem");
    Conn.conn.status.repaint();
    enableToolTipsBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> enableToolTipsBox");
    Conn.conn.status.repaint();
    colorPanel = new JPanel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> colorPanel");
    Conn.conn.status.repaint();
    xYLayout11 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout11");
    Conn.conn.status.repaint();
    browseLabel = new JLabel(this.browserSelectIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> browseLabel");
    Conn.conn.status.repaint();
    highlightLabel = new JLabel(this.highlightIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> highlightLabel");
    Conn.conn.status.repaint();
    textLabel = new JLabel(this.defaultTextIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> textLabel");
    Conn.conn.status.repaint();
    commentLabel = new JLabel(this.commentIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> commentLabel");
    Conn.conn.status.repaint();
    stringLabel = new JLabel(this.stringIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> stringLabel");
    Conn.conn.status.repaint();
    keywordLabel = new JLabel(this.keywordIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> keywordLabel");
    Conn.conn.status.repaint();
    customLabel = new JLabel(this.customKeywordIcon, JLabel.LEFT);
    Conn.conn.status.setText("IDEOptions: Setup Component -> customLabel");
    Conn.conn.status.repaint();
    changeBrowseButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> changeBrowseButton");
    Conn.conn.status.repaint();
    defaultBrowseButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultBrowseButton");
    Conn.conn.status.repaint();
    changeHighlightButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> ");
    Conn.conn.status.repaint();
    changeTextButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> changeHighlightButton");
    Conn.conn.status.repaint();
    changeCommentButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> changeCommentButton");
    Conn.conn.status.repaint();
    changeStringButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> changeStringButton");
    Conn.conn.status.repaint();
    changeKeywordButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> changeKeywordButton");
    Conn.conn.status.repaint();
    changeCustomButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> changeCustomButton");
    Conn.conn.status.repaint();
    defaultHighlightButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultHighlightButton");
    Conn.conn.status.repaint();
    defaultTextButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultTextButton");
    Conn.conn.status.repaint();
    defaultCommentButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultCommentButton");
    Conn.conn.status.repaint();
    defaultStringButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultStringButton");
    Conn.conn.status.repaint();
    defaultKeywordButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultKeywordButton");
    Conn.conn.status.repaint();
    defaultCustomButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> defaultCustomButton");
    Conn.conn.status.repaint();
    showProgressBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component ->showProgressBox ");
    Conn.conn.status.repaint();
    jLabel12 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel12");
    Conn.conn.status.repaint();
    jLabel13 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel13");
    Conn.conn.status.repaint();
    jLabel14 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel14");
    Conn.conn.status.repaint();
    fFamilyCombo = new JComboBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> fFamilyCombo");
    Conn.conn.status.repaint();
    fSizeCombo = new JComboBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> fSizeCombo");
    Conn.conn.status.repaint();
    showRulerBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> showRulerBox");
    Conn.conn.status.repaint();
    showSplashBox = new JCheckBox();
    Conn.conn.status.setText("IDEOptions: Setup Component -> showSplashBox");
    Conn.conn.status.repaint();
    keywordList = new JList(keywordModel);
    Conn.conn.status.setText("IDEOptions: Setup Component -> keywordList");
    Conn.conn.status.repaint();
    keyWordScroller = new JScrollPane(keywordList);
    Conn.conn.status.setText("IDEOptions: Setup Component -> keyWordScroller");
    Conn.conn.status.repaint();
    addKeywordButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> addKeywordButton");
    Conn.conn.status.repaint();
    deleteKeywordButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> deleteKeywordButton");
    Conn.conn.status.repaint();
    removeAllKeywordsButton = new JButton();
    Conn.conn.status.setText("IDEOptions: Setup Component -> removeAllKeywordsButton");
    Conn.conn.status.repaint();
    previewButton = new JButton(defaultIcon);
    Conn.conn.status.setText("IDEOptions: Setup Component -> previewButton");
    Conn.conn.status.repaint();
    xYLayout12 = new XYLayout();
    Conn.conn.status.setText("IDEOptions: Setup Component -> xYLayout12");
    Conn.conn.status.repaint();
    jLabel15 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel15");
    Conn.conn.status.repaint();
    jLabel16 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel16");
    Conn.conn.status.repaint();
    jLabel17 = new JLabel();
    Conn.conn.status.setText("IDEOptions: Setup Component -> jLabel17");
    Conn.conn.status.repaint();
    customDescription = new JTextField();
    Conn.conn.status.setText("IDEOptions: Setup Component -> customDescription");
    Conn.conn.status.repaint();
    popup = new JPopupMenu();
    Conn.conn.status.setText("IDEOptions: Setup Component -> popup");
    Conn.conn.status.repaint();
    editPopup = new JMenuItem();
    Conn.conn.status.setText("IDEOptions: Setup Component -> editPopup");
    Conn.conn.status.repaint();
    removePopup = new JMenuItem();
    Conn.conn.status.setText("IDEOptions: Setup Component -> removePopup");
    Conn.conn.status.repaint();
  }

  private void jbInit() throws Exception
  {
    try
    {
	    java.net.URL url = getClass().getResource("images/opt.gif");
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}

    keywordList.setCellRenderer(new ListRenderer());
    itemList.setCellRenderer(new ListRenderer());
    sectionList.setCellRenderer(new ListRenderer(this));
    
    this.setResizable(false);
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });
    this.addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentShown(ComponentEvent e)
      {
        this_componentShown(e);
      }
    });
    xYLayout1.setHeight(440);

      Conn.conn.status.setText("IDEOptions: Buttons...");
      Conn.conn.status.repaint();

    okButton.setText("OK");
    okButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        okButton_actionPerformed(e);
      }
    });
    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        cancelButton_actionPerformed(e);
      }
    });
    helpButton.setText("Help");
    configLabel.setText("Use Configuration:");
    configLabel.setForeground(Color.black);
    configLabel.setFont(new Font("SansSerif", 3, 12));
    configCombo.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        configCombo_actionPerformed(e);
      }
    });
    saveConfigButton.setText("Save As");
    saveConfigButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        saveConfigButton_actionPerformed(e);
      }
    });

      Conn.conn.status.setText("IDEOptions: Labels");
      Conn.conn.status.repaint();

    backupBox.setText("Make Backups");
    saveOnCloseBox.setText("Save Options On Close");
    saveOnCloseBox.setSelected(true);
    autoIndentBox.setText("Auto Indent Mode");
    autoIndentBox.setSelected(true);
    scanPluginsBox.setText("Scan Plugins On Startup");
    scanRADBox1.setText("Scan RAD Modules");
    scanLangsBox2.setText("Scan Langs. On Startup");
    autoFontifyBox.setText("Auto Fontify On Open");
    scanStructureBox.setText("Scan Structure On Open");
    openLastBox.setText("Auto Open Last Project");
    rememberLocationBox.setText("Remember Window Location");
    autoLabel.setText("Save Files Every");
    autoLabel.setEnabled(false);
    autoLabel.setForeground(Color.black);
    enableAutosave.setText("Enable Auto Save");
    enableAutosave.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        enableAutosave_actionPerformed(e);
      }
    });
    timeCombo.setEnabled(false);
    indentCombo.setEnabled(false);
    sectionScroller.setBorder(listBorder);
    itemScroller.setBorder(listBorder);
    jLabel1.setText("Section Name");
    jLabel1.setFont(new Font("Dialog", 1, 12));
    jLabel2.setText("Installed Beans");
    jLabel2.setFont(new Font("Dialog", 1, 12));
    removeButton.setText("Remove");
    removeButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        removeButton_actionPerformed(e);
      }
    });
    newButton.setText("New");
    newButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        newButton_actionPerformed(e);
      }
    });
    jLabel3.setText("Path To Archive");
    jLabel3.setFont(new Font("Dialog", 1, 12));
    findButton.setText("Browse");
    jLabel5.setText("Path To Package");
    jLabel5.setFont(new Font("Dialog", 1, 12));
    jButton1.setText("Browse");
    packageItemList.setBorder(listBorder);
    jLabel7.setText("Fly Over Tool Tip");
    jLabel7.setFont(new Font("Dialog", 1, 12));
    jLabel8.setText("Choose A button Image (.gif)");
    jLabel8.setFont(new Font("Dialog", 1, 12));
    customImageName.setEditable(false);
    jButton3.setText("Browse");
    jButton3.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButton3_actionPerformed(e);
      }
    });
    buttonPreview.setLayout(xYLayout12);
    buttonPreview.setBackground(new Color(102, 102, 153));
    buttonPreview.setBorder(listBorder);
    codeScroller.setFont(new Font("Courier", 0, 14));
    codeTextArea.setFont(new Font("Courier", 0, 14));
    jLabel10.setText("Installed Plugins");
    jLabel10.setFont(new Font("Courier", 1, 20));
    jLabel11.setText("Double Click For Info");
    pluginList.setBorder(listBorder);
    addArchiveButton.setText("Add Current Item");
    addArchiveButton.setFont(new Font("Dialog", 1, 11));
    addClassButton.setText("Add Current Item");
    addClassButton.setFont(new Font("Dialog", 1, 11));
    addCustomItem.setText("Add Current Item");
    addCustomItem.setFont(new Font("Dialog", 1, 11));
    addCustomItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        addCustomItem_actionPerformed(e);
      }
    });
    enableToolTipsBox.setText("Enable Tool Tips");
    enableToolTipsBox.setSelected(true);
    browseLabel.setText("Browser Selection Color");
    highlightLabel.setText("Editor Highlight Color");
    textLabel.setText("Default Text Color");
    commentLabel.setText("Comment Color");
    stringLabel.setText("String Color");
    keywordLabel.setText("Keyword Color");
    customLabel.setText("Custom Keyword Color");
    changeBrowseButton.setText("Change");
    changeBrowseButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeBrowseButton_actionPerformed(e);
      }
    });
    defaultBrowseButton.setText("Default");
    defaultBrowseButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultBrowseButton_actionPerformed(e);
      }
    });
    changeHighlightButton.setText("Change");
    changeHighlightButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeHighlightButton_actionPerformed(e);
      }
    });
    changeTextButton.setText("Change");
    changeTextButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeTextButton_actionPerformed(e);
      }
    });
    changeCommentButton.setText("Change");
    changeCommentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeCommentButton_actionPerformed(e);
      }
    });
    changeStringButton.setText("Change");
    changeStringButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeStringButton_actionPerformed(e);
      }
    });
    changeKeywordButton.setText("Change");
    changeKeywordButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeKeywordButton_actionPerformed(e);
      }
    });
    changeCustomButton.setText("Change");
    changeCustomButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        changeCustomButton_actionPerformed(e);
      }
    });
    defaultHighlightButton.setText("Default");
    defaultHighlightButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultHighlightButton_actionPerformed(e);
      }
    });
    defaultTextButton.setText("Default");
    defaultTextButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultTextButton_actionPerformed(e);
      }
    });
    defaultCommentButton.setText("Default");
    defaultCommentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultCommentButton_actionPerformed(e);
      }
    });
    defaultStringButton.setText("Default");
    defaultStringButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultStringButton_actionPerformed(e);
      }
    });
    defaultKeywordButton.setText("Default");
    defaultKeywordButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultKeywordButton_actionPerformed(e);
      }
    });
    defaultCustomButton.setText("Default");
    defaultCustomButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        defaultCustomButton_actionPerformed(e);
      }
    });
    showProgressBox.setText("Show Progress Bars");
    showProgressBox.setSelected(true);
    showProgressBox.setToolTipText("JFC/Swing is still in Beta -- Uncheck this to avoid Unhandled Exceptions");
    jLabel12.setText("Default Font");
    jLabel12.setFont(new Font("SansSerif", 1, 14));
    jLabel13.setText("Family");
    jLabel14.setText("Size");
    showRulerBox.setText("Show Editor Ruler");
    showRulerBox.setSelected(true);
    showRulerBox.setToolTipText("JFC/Swing is still in Beta -- Uncheck this to avoid Unhandled Exceptions");
    showSplashBox.setEnabled(false);
    showSplashBox.setText("Show Splash");
    showSplashBox.setSelected(true);
    showSplashBox.setToolTipText("");
    keyWordScroller.setBorder(listBorder);
    addKeywordButton.setText("Add");
    addKeywordButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        addKeywordButton_actionPerformed(e);
      }
    });
    deleteKeywordButton.setText("Delete");
    deleteKeywordButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        deleteKeywordButton_actionPerformed(e);
      }
    });
    removeAllKeywordsButton.setText("Remove All");
    removeAllKeywordsButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        removeAllKeywordsButton_actionPerformed(e);
      }
    });
    jLabel15.setText("User Defined Keywords");
    jLabel16.setText("Preview");
    jLabel17.setText("Description:");
    editPopup.setText("Edit");
    editPopup.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        editPopup_actionPerformed(e);
      }
    });
    removePopup.setText("Remove");
    removePopup.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        removePopup_actionPerformed(e);
      }
    });
    enableToolTipsBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        enableToolTipsBox_actionPerformed(e);
      }
    });
    jLabel9.setText("Code");
    jLabel9.setFont(new Font("Dialog", 1, 12));
    jLabel6.setText("ItemsFound");
    jLabel6.setFont(new Font("Dialog", 1, 12));
    foundarchives.setBorder(listBorder);
    jLabel4.setText("Items Found");
    jLabel4.setFont(new Font("Dialog", 1, 12));
    customPane.setLayout(xYLayout10);
    upButton.setText("Move Up");
    upButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        upButton_actionPerformed(e);
      }
    });
    downButton.setText("Move Down");
    downButton.setForeground(Color.black);
    downButton.setFont(new Font("Dialog", 1, 12));
    downButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        downButton_actionPerformed(e);
      }
    });
    classPane.setLayout(xYLayout9);
    archivePane.setLayout(xYLayout8);
    toolbarPane.setLayout(xYLayout5);
    timeLabel.setText("Minutes");
    timeLabel.setEnabled(false);
    timeLabel.setForeground(Color.black);
    indentBox.setText("Indent After Newline Brace");
    indentBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        indentBox_actionPerformed(e);
      }
    });
    sizeLabel.setText("Indent Size");
    sizeLabel.setEnabled(false);
    sizeLabel.setForeground(Color.black);
    autoMaximizeBox.setText("Auto Maximize Source");
    innerEditPanel.setLayout(xYLayout7);
    pluginsPane.setLayout(xYLayout6);
    buttonsPane.setLayout(borderLayout1);
    highlightPane.setLayout(xYLayout4);
    displayPane.setLayout(xYLayout3);
    editorPane.setLayout(xYLayout2);
    xYLayout1.setWidth(425);
    this.setTitle("IDE Options");
    this.getContentPane().setLayout(xYLayout1);
    colorPanel.setLayout(xYLayout11);
    this.getContentPane().add(tabs, new XYConstraints(9, 5, 401, 364));
    tabs.addTab("Editor", editorPane);
    editorPane.add(configLabel, new XYConstraints(8, 11, 112, 21));
    editorPane.add(configCombo, new XYConstraints(123, 9, 176, -1));
    editorPane.add(saveConfigButton, new XYConstraints(309, 9, 82, -1));
    editorPane.add(innerEditPanel, new XYConstraints(12, 59, 375, 168));
    innerEditPanel.add(backupBox, new XYConstraints(13, 2, 147, 19));
    innerEditPanel.add(saveOnCloseBox, new XYConstraints(13, 26, 161, 19));
    innerEditPanel.add(autoIndentBox, new XYConstraints(13, 48, 147, 19));
    innerEditPanel.add(scanPluginsBox, new XYConstraints(208, 2, 166, 19));
    innerEditPanel.add(scanRADBox1, new XYConstraints(208, 26, 165, 19));
    innerEditPanel.add(autoMaximizeBox, new XYConstraints(13, 73, 166, 19));
    innerEditPanel.add(scanLangsBox2, new XYConstraints(208, 48, 166, 19));
    innerEditPanel.add(autoFontifyBox, new XYConstraints(13, 97, 166, 19));
    innerEditPanel.add(scanStructureBox, new XYConstraints(208, 73, 168, 19));
    innerEditPanel.add(openLastBox, new XYConstraints(208, 97, 161, 19));
    innerEditPanel.add(rememberLocationBox, new XYConstraints(13, 119, 187, 19));
    innerEditPanel.add(enableToolTipsBox, new XYConstraints(208, 119, 134, 19));
    editorPane.add(autoLabel, new XYConstraints(154, 246, 96, 21));
    editorPane.add(indentBox, new XYConstraints(22, 274, 175, -1));
    editorPane.add(enableAutosave, new XYConstraints(22, 245, 122, -1));
    editorPane.add(timeCombo, new XYConstraints(251, 246, 51, 20));
    editorPane.add(timeLabel, new XYConstraints(310, 248, 54, 19));
    editorPane.add(sizeLabel, new XYConstraints(214, 275, 71, 21));
    editorPane.add(indentCombo, new XYConstraints(281, 274, 50, 22));
    tabs.addTab("Display", displayPane);
    displayPane.add(colorPanel, new XYConstraints(11, 10, 376, 221));
    colorPanel.add(browseLabel, new XYConstraints(14, 6, 166, 26));
    colorPanel.add(highlightLabel, new XYConstraints(14, 31, 166, 26));
    colorPanel.add(textLabel, new XYConstraints(14, 56, 166, 26));
    colorPanel.add(commentLabel, new XYConstraints(14, 81, 166, 26));
    colorPanel.add(stringLabel, new XYConstraints(14, 106, 166, 26));
    colorPanel.add(keywordLabel, new XYConstraints(14, 131, 166, 26));
    colorPanel.add(customLabel, new XYConstraints(14, 156, 166, 26));
    colorPanel.add(changeBrowseButton, new XYConstraints(192, 9, -1, 21));
    colorPanel.add(defaultBrowseButton, new XYConstraints(276, 9, 77, 21));
    colorPanel.add(changeHighlightButton, new XYConstraints(192, 34, -1, 21));
    colorPanel.add(changeTextButton, new XYConstraints(192, 59, -1, 21));
    colorPanel.add(changeCommentButton, new XYConstraints(192, 84, -1, 21));
    colorPanel.add(changeStringButton, new XYConstraints(192, 109, -1, 21));
    colorPanel.add(changeKeywordButton, new XYConstraints(192, 134, -1, 21));
    colorPanel.add(changeCustomButton, new XYConstraints(192, 159, -1, 21));
    colorPanel.add(defaultHighlightButton, new XYConstraints(276, 34, 77, 21));
    colorPanel.add(defaultTextButton, new XYConstraints(276, 59, 77, 21));
    colorPanel.add(defaultCommentButton, new XYConstraints(276, 84, 77, 21));
    colorPanel.add(defaultStringButton, new XYConstraints(276, 109, 77, 21));
    colorPanel.add(defaultKeywordButton, new XYConstraints(276, 134, 77, 21));
    colorPanel.add(defaultCustomButton, new XYConstraints(276, 159, 77, 21));
    displayPane.add(showProgressBox, new XYConstraints(15, 232, -1, 21));
    displayPane.add(jLabel12, new XYConstraints(152, 255, 93, 25));
    displayPane.add(jLabel13, new XYConstraints(33, 293, 45, 18));
    displayPane.add(jLabel14, new XYConstraints(256, 291, 34, 23));
    displayPane.add(fFamilyCombo, new XYConstraints(79, 290, 150, -1));
    displayPane.add(fSizeCombo, new XYConstraints(285, 290, 61, -1));
    displayPane.add(showRulerBox, new XYConstraints(161, 232, 125, 21));
    displayPane.add(showSplashBox, new XYConstraints(287, 232, 100, 21));
    colorPanel.setBorder(colorBorder);
    tabs.addTab("User Keywords", highlightPane);
    highlightPane.add(keyWordScroller, new XYConstraints(15, 25, 247, 297));
    highlightPane.add(addKeywordButton, new XYConstraints(281, 23, 103, 31));
    highlightPane.add(deleteKeywordButton, new XYConstraints(281, 69, 103, 31));
    highlightPane.add(removeAllKeywordsButton, new XYConstraints(281, 116, 103, 31));
    highlightPane.add(jLabel15, new XYConstraints(16, 5, 185, 18));
    tabs.addTab("Buttons", buttonsPane);
    buttonsPane.add(buttonTabs, BorderLayout.CENTER);
    buttonTabs.addTab("Toolbar", toolbarPane);
    toolbarPane.add(sectionScroller, new XYConstraints(14, 24, 139, 235));
    toolbarPane.add(itemScroller, new XYConstraints(165, 24, 213, 235));
    toolbarPane.add(jLabel1, new XYConstraints(19, 7, 90, -1));
    toolbarPane.add(jLabel2, new XYConstraints(174, 7, 98, -1));
    toolbarPane.add(removeButton, new XYConstraints(97, 272, 82, 27));
    toolbarPane.add(upButton, new XYConstraints(187, 272, 84, 27));
    toolbarPane.add(downButton, new XYConstraints(277, 272, 101, 27));
    toolbarPane.add(newButton, new XYConstraints(14, 272, 73, 27));
    buttonTabs.addTab("Add Bean Archive", archivePane);
    archivePane.add(jLabel3, new XYConstraints(6, 4, 110, 21));
    archivePane.add(pathField, new XYConstraints(5, 23, 288, 26));
    archivePane.add(findButton, new XYConstraints(302, 23, 81, 26));
    archivePane.add(foundarchives, new XYConstraints(7, 81, 377, 196));
    archivePane.add(jLabel4, new XYConstraints(9, 61, 106, 21));
    archivePane.add(addArchiveButton, new XYConstraints(9, 281, 376, 22));
    buttonTabs.addTab("Add Bean Class", classPane);
    classPane.add(jLabel5, new XYConstraints(6, 4, 117, 21));
    classPane.add(packageField, new XYConstraints(6, 23, 282, 27));
    classPane.add(jButton1, new XYConstraints(301, 23, 82, 27));
    classPane.add(packageItemList, new XYConstraints(7, 78, 376, 200));
    classPane.add(jLabel6, new XYConstraints(10, 60, 88, 18));
    classPane.add(addClassButton, new XYConstraints(8, 282, 376, 22));
    buttonTabs.addTab("Custom", customPane);
    customPane.add(jLabel7, new XYConstraints(6, 6, 123, 23));
    customPane.add(customTip, new XYConstraints(5, 24, 377, 26));
    customPane.add(jLabel8, new XYConstraints(8, 76, 179, 23));
    customPane.add(customImageName, new XYConstraints(8, 99, 169, 26));
    customPane.add(jButton3, new XYConstraints(187, 99, 80, 26));
    customPane.add(buttonPreview, new XYConstraints(285, 75, 90, 70));
    buttonPreview.add(previewButton, new XYConstraints(26, 16, 34, 34));
    customPane.add(codeScroller, new XYConstraints(6, 156, 377, 120));
    customPane.add(jLabel9, new XYConstraints(9, 136, 39, 20));
    customPane.add(addCustomItem, new XYConstraints(6, 282, 376, 21));
    customPane.add(jLabel16, new XYConstraints(286, 55, 61, 19));
    customPane.add(jLabel17, new XYConstraints(8, 56, 72, 18));
    customPane.add(customDescription, new XYConstraints(79, 55, 187, 23));
    tabs.addTab("Plugins", pluginsPane);
    pluginsPane.add(jLabel10, new XYConstraints(88, 9, 221, 32));
    pluginsPane.add(jLabel11, new XYConstraints(10, 47, 126, 25));
    pluginsPane.add(pluginList, new XYConstraints(8, 72, 380, 255));
    this.getContentPane().add(okButton, new XYConstraints(157, 378, 78, 28));
    this.getContentPane().add(cancelButton, new XYConstraints(243, 378, 78, 28));
    this.getContentPane().add(helpButton, new XYConstraints(329, 378, 78, 28));
    popup.add(editPopup);
    popup.add(removePopup);

    //this.configCombo.addItem("Current");
    //this.configCombo.setSelectedIndex(0);

    timeCombo.addItem(new Integer(0));
    timeCombo.addItem(new Integer(1));
    timeCombo.addItem(new Integer(2));
    timeCombo.addItem(new Integer(3));
    timeCombo.addItem(new Integer(4));
    timeCombo.addItem(new Integer(5));
    timeCombo.addItem(new Integer(6));
    timeCombo.addItem(new Integer(7));
    timeCombo.addItem(new Integer(8));
    timeCombo.addItem(new Integer(9));
    timeCombo.addItem(new Integer(10));
    timeCombo.addItem(new Integer(11));
    timeCombo.addItem(new Integer(12));
    timeCombo.addItem(new Integer(13));
    timeCombo.addItem(new Integer(14));
    timeCombo.addItem(new Integer(15));
    timeCombo.addItem(new Integer(16));
    timeCombo.addItem(new Integer(17));
    timeCombo.addItem(new Integer(18));
    timeCombo.addItem(new Integer(19));
    timeCombo.addItem(new Integer(20));
    timeCombo.setSelectedIndex(10);

    indentCombo.addItem(new Integer(0));
    indentCombo.addItem(new Integer(1));
    indentCombo.addItem(new Integer(2));
    indentCombo.addItem(new Integer(3));
    indentCombo.addItem(new Integer(4));
    indentCombo.setSelectedIndex(2);

    fFamilyCombo.addItem("Serif");
    fFamilyCombo.addItem("SansSerif");
    fFamilyCombo.addItem("Monospaced");
    fFamilyCombo.addItem("Courier");
    fFamilyCombo.addItem("Dialog");
    fFamilyCombo.setSelectedIndex(3);

    fSizeCombo.addItem(new Integer(8));
    fSizeCombo.addItem(new Integer(10));
    fSizeCombo.addItem(new Integer(12));
    fSizeCombo.addItem(new Integer(14));
    fSizeCombo.addItem(new Integer(16));
    fSizeCombo.addItem(new Integer(18));
    fSizeCombo.setSelectedIndex(3);

    initComboBox();

    innerEditPanel.setBorder(editBorder);
    setSize(new Dimension(425, 440));
  }

  void this_componentShown(ComponentEvent e)
  {
    parent.setEnabled(false);
    parent.browser.setEnabled(false);
    parent.workspace.setEnabled(false);
  }

  void this_windowClosing(WindowEvent e)
  {
    parent.setEnabled(true);
    parent.browser.setEnabled(true);
    parent.workspace.setEnabled(true);
  }

  public void saveConfig(String name)
  {
    try
    {
      // Make sure directory exists -- If not, Create it

      File dir = new File("Config");
      if(!dir.exists())
      {
        dir.mkdir();
      }

      File configFile = new File(dir, "IDEO_" + name + ".properties");

      java.util.Properties props = new java.util.Properties();

      /*
         Place all modifiable components such as Checkboxes here.
      */

      props.put("backupBox", "" + backupBox.isSelected());
      props.put("saveOnCloseBox", "" + saveOnCloseBox.isSelected());
      props.put("autoIndentBox", "" + autoIndentBox.isSelected());
      props.put("scanPluginsBox", "" + scanPluginsBox.isSelected());
      props.put("scanRADBox1", "" + scanRADBox1.isSelected());
      props.put("autoMaximizeBox", "" + autoMaximizeBox.isSelected());
      props.put("scanLangsBox2", "" + scanLangsBox2.isSelected());

      props.put("autoFontifyBox", "" + autoFontifyBox.isSelected());
      props.put("scanStructureBox", "" + scanStructureBox.isSelected());
      props.put("openLastBox", "" + openLastBox.isSelected());
      props.put("rememberLocationBox", "" + rememberLocationBox.isSelected());
      props.put("enableAutosave", "" + enableAutosave.isSelected());
      props.put("indentBox", "" + indentBox.isSelected());
      props.put("enableToolTipsBox", "" + enableToolTipsBox.isSelected());



      props.put("autoLabelEnabled", "" + autoLabel.isEnabled());
      props.put("timeLabelEnabled", "" + timeLabel.isEnabled());
      props.put("sizeLabelEnabled", "" + sizeLabel.isEnabled());

      props.put("timeComboEnabled", "" + timeCombo.isEnabled());
      props.put("indentComboEnabled", "" + indentCombo.isEnabled());

      props.put("timeComboSelected", "" + timeCombo.getSelectedIndex());
      props.put("indentComboSelected", "" + indentCombo.getSelectedIndex());


      props.put("browserSelectColor", "" +  browserSelectColor.getRGB());
      props.put("highlightColor", "" + highlightColor.getRGB());
      props.put("defaultTextColor", "" +  defaultTextColor.getRGB());
      props.put("stringColor", "" + stringColor.getRGB());
      props.put("commentColor", "" + commentColor.getRGB());
      props.put("keywordColor", "" + keywordColor.getRGB());
      props.put("customKeywordColor", "" + customKeywordColor.getRGB());

      props.put("fFamilyComboSelected", "" + fFamilyCombo.getSelectedIndex());
      props.put("fSizeComboSelected", "" + fSizeCombo.getSelectedIndex());
      props.put("showProgressBox", "" + showProgressBox.isSelected());
      props.put("showRulerBox", "" + showRulerBox.isSelected());
      props.put("showSplashBox", "" + showSplashBox.isSelected());

      for(int i = 0; i < keywordModel.size(); i++)
      {
        props.put("keyword" + i, "" + keywordModel.getElementAt(i));
      }


      FileOutputStream fos = new FileOutputStream(configFile);

      props.save(fos, Utility.genHeader("IDE Options Configuration File"));
      fos.close();

      /*
      String[] conf = dir.list(new IDEFilter());
      for(int i=0; i<conf.length; i++)
      {
        System.out.println(conf[i]);
      }
      */

      //ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(configFile));
      //out.writeObject(this);
    }
    catch(Exception IDEx)
    {
      JOptionPane.showMessageDialog(this, "Couldn't save IDE Configuration");
      //IDEx.printStackTrace();
    }
  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }


  public void loadConfig(String confName)
  {
    try
    {
      // Make sure directory exists -- If not, Create it

      File dir = new File("Config");
      if(!dir.exists())
      {
        return;
      }

      File configFile = new File(dir, "IDEO_" + confName + ".properties");

      java.util.Properties props = new java.util.Properties();

      FileInputStream fis = new FileInputStream(configFile);

      props.load(fis);
      fis.close();



      /*
         Load Configuration into the component
      */
      backupBox.setSelected(Boolean.valueOf(props.getProperty("backupBox")).booleanValue());
      saveOnCloseBox.setSelected( Boolean.valueOf(props.getProperty("saveOnCloseBox")).booleanValue());
      autoIndentBox.setSelected( Boolean.valueOf(props.getProperty("autoIndentBox")).booleanValue());
      scanPluginsBox.setSelected( Boolean.valueOf(props.getProperty("scanPluginsBox")).booleanValue());
      scanRADBox1.setSelected( Boolean.valueOf(props.getProperty("scanRADBox1")).booleanValue());
      autoMaximizeBox.setSelected( Boolean.valueOf(props.getProperty("autoMaximizeBox")).booleanValue());
      scanLangsBox2.setSelected( Boolean.valueOf(props.getProperty("scanLangsBox2")).booleanValue());

      autoFontifyBox.setSelected( Boolean.valueOf(props.getProperty("autoFontifyBox")).booleanValue());
      scanStructureBox.setSelected( Boolean.valueOf(props.getProperty("scanStructureBox")).booleanValue());
      openLastBox.setSelected( Boolean.valueOf(props.getProperty("openLastBox")).booleanValue());
      rememberLocationBox.setSelected( Boolean.valueOf(props.getProperty("rememberLocationBox")).booleanValue());
      enableAutosave.setSelected( Boolean.valueOf(props.getProperty("enableAutosave")).booleanValue());
      indentBox.setSelected( Boolean.valueOf(props.getProperty("indentBox")).booleanValue());
      enableToolTipsBox.setSelected( Boolean.valueOf(props.getProperty("enableToolTipsBox")).booleanValue());

      autoLabel.setEnabled( Boolean.valueOf(props.getProperty("autoLabelEnabled")).booleanValue());
      timeLabel.setEnabled( Boolean.valueOf(props.getProperty("timeLabelEnabled")).booleanValue());
      sizeLabel.setEnabled( Boolean.valueOf(props.getProperty("sizeLabelEnabled")).booleanValue());
      timeCombo.setEnabled( Boolean.valueOf(props.getProperty("timeComboEnabled")).booleanValue());
      indentCombo.setEnabled( Boolean.valueOf(props.getProperty("indentComboEnabled")).booleanValue());

      timeCombo.setSelectedIndex( Integer.valueOf(props.getProperty("timeComboSelected", "10")).intValue());
      indentCombo.setSelectedIndex( Integer.valueOf(props.getProperty("indentComboSelected", "3")).intValue());

      fFamilyCombo.setSelectedIndex( Integer.valueOf(props.getProperty("fFamilyComboSelected", "3")).intValue());
      fSizeCombo.setSelectedIndex( Integer.valueOf(props.getProperty("fSizeComboSelected", "3")).intValue());
      showProgressBox.setSelected( Boolean.valueOf(props.getProperty("showProgressBox")).booleanValue());
      showRulerBox.setSelected( Boolean.valueOf(props.getProperty("showRulerBox")).booleanValue());
      showSplashBox.setSelected( Boolean.valueOf(props.getProperty("showSplashBox")).booleanValue());

      Color color;

      color = new Color(Integer.valueOf(props.getProperty("browserSelectColor", "-256")).intValue());
      browserSelectColor = color;
      changeIcon(browseLabel, browserSelectColor);

      color = new Color(Integer.valueOf(props.getProperty("highlightColor", "-3355393")).intValue());
      highlightColor = color;
      changeIcon(highlightLabel, highlightColor);

      color = new Color(Integer.valueOf(props.getProperty("defaultTextColor", "-16777216")).intValue());
      defaultTextColor = color;
      changeIcon(textLabel, defaultTextColor);

      color = new Color(Integer.valueOf(props.getProperty("stringColor", "-65536")).intValue());
      stringColor = color;
      changeIcon(stringLabel, stringColor);

      color = new Color(Integer.valueOf(props.getProperty("commentColor", "-6944866")).intValue());
      commentColor = color;
      changeIcon(commentLabel, commentColor);

      color = new Color(Integer.valueOf(props.getProperty("keywordColor", "-16776961")).intValue());
      keywordColor = color;
      changeIcon(keywordLabel, keywordColor);

      color = new Color(Integer.valueOf(props.getProperty("customKeywordColor", "-16776961")).intValue());
      customKeywordColor = color;
      changeIcon(customLabel, customKeywordColor);

        boolean flag = true;
        int seed = 0;

        removeAllKeywordsButton_actionPerformed(null);
        
        while(flag)
        {
          String res = props.getProperty("keyword" + seed, "NOT FOUND");
          seed += 1;
          if(res.equals("NOT FOUND"))
          {
            flag = false;
          }
          else
          {
            TE key = new TE(res);
            key.setIcon(loadImageIcon("images/keyword.gif", "key"));
            keywordModel.addElement(key);
            keywordTable.put(key.getName(), "custom");


          }
        }


    }
    catch(Exception IDEx)
    {
      JOptionPane.showMessageDialog(this, "Couldn't load IDE Configuration");
      //IDEx.printStackTrace();
    }
  }

  void saveConfigButton_actionPerformed(ActionEvent e)
  {
    String inputValue = JOptionPane.showInputDialog("Please input a name");

    if(inputValue==null || inputValue.equals(""))
    {
      return;
    }

    String newString = inputValue.replace(' ', '_');

    saveConfig(newString);
    configCombo.addItem(newString);
    //configCombo.setSelectedItem(newString);
    configCombo.setSelectedIndex(configCombo.getItemCount()-1);
    configCombo.repaint();
  }

  void okButton_actionPerformed(ActionEvent e)
  {
    setVisible(false);
    parent.setEnabled(true);
    parent.browser.setEnabled(true);
    parent.workspace.setEnabled(true);

  }

  void cancelButton_actionPerformed(ActionEvent e)
  {
    setVisible(false);
    parent.setEnabled(true);
    parent.browser.setEnabled(true);
    parent.workspace.setEnabled(true);
  }

  public class IDEFilter implements java.io.FilenameFilter{
    public IDEFilter()
    {
      ;
    }

    public boolean accept(File f, String name)
    {
      if(name.endsWith(".properties") && name.startsWith("IDEO_"))
      {
        return true;
      }
      else
      {
        return false;
      }
    }
  }

  void initComboBox()
  {
      File dir = new File("Config");
      if(dir.exists())
      {
        //System.out.println("Config dir exists");

        String[] conf = dir.list(new IDEFilter());
        for(int i=0; i<conf.length; i++)
        {
          this.configCombo.addItem(conf[i].substring(5, conf[i].length() - 11));

      Conn.conn.status.setText("IDEOptions: Config Files -> " + conf[i]);
      Conn.conn.status.repaint();


        }
      }
  }

  void enableAutosave_actionPerformed(ActionEvent e)
  {
    autoLabel.setEnabled(enableAutosave.isSelected());
    timeLabel.setEnabled(enableAutosave.isSelected());
    timeCombo.setEnabled(enableAutosave.isSelected());

    autoLabel.repaint();
    timeLabel.repaint();

  }

  void indentBox_actionPerformed(ActionEvent e)
  {
    sizeLabel.setEnabled(indentBox.isSelected());
    sizeLabel.repaint();
    indentCombo.setEnabled(indentBox.isSelected());
  }

  void configCombo_actionPerformed(ActionEvent e)
  {
    loadConfig((String)configCombo.getSelectedItem());
  }

  void enableToolTipsBox_actionPerformed(ActionEvent e)
  {
    ToolTipManager.sharedInstance().setEnabled(enableToolTipsBox.isSelected());
  }

  static class ColoredSquare implements Icon{
	  Color color;
	  public ColoredSquare(Color c)
    {
	    this.color = c;
	  }

	  public void paintIcon(Component c, Graphics g, int x, int y)
    {
	    Color oldColor = g.getColor();
	    g.setColor(color);
	    g.fill3DRect(x,y,getIconWidth(), getIconHeight(), true);
	    g.setColor(oldColor);
	  }
	  public int getIconWidth() { return 12; }
	  public int getIconHeight() { return 12; }

  }

  void defaultBrowseButton_actionPerformed(ActionEvent e)
  {
    browserSelectColor = Color.yellow;
    changeIcon(browseLabel, browserSelectColor);
  }

  void defaultHighlightButton_actionPerformed(ActionEvent e)
  {
    highlightColor = new Color(204, 204, 255);
    changeIcon(highlightLabel, highlightColor);
  }

  void defaultTextButton_actionPerformed(ActionEvent e)
  {
    defaultTextColor = Color.black;
    changeIcon(textLabel, defaultTextColor);
  }

  void defaultCommentButton_actionPerformed(ActionEvent e)
  {
    commentColor = new Color(150, 7, 158);
    changeIcon(commentLabel, commentColor);
  }

  void defaultStringButton_actionPerformed(ActionEvent e)
  {
    stringColor = Color.red;
    changeIcon(stringLabel, stringColor);
  }

  void defaultKeywordButton_actionPerformed(ActionEvent e)
  {
    keywordColor = Color.blue;
    changeIcon(keywordLabel, keywordColor);
  }

  void defaultCustomButton_actionPerformed(ActionEvent e)
  {
    customKeywordColor = Color.blue;
    changeIcon(customLabel, customKeywordColor);
  }

  void changeBrowseButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change Browser Selection Color", browserSelectColor);
    if(color != null)
    {
      browserSelectColor = color;
      changeIcon(browseLabel, browserSelectColor);
    }
  }

  void changeHighlightButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change Highlight Color", highlightColor);
    if(color != null)
    {
      highlightColor = color;
      changeIcon(highlightLabel, highlightColor);
    }
  }

  void changeTextButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change Text Color", defaultTextColor);
    if(color != null)
    {
      defaultTextColor = color;
      changeIcon(textLabel, defaultTextColor);
    }
  }

  void changeCommentButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change COmment Color", commentColor);
    if(color != null)
    {
      commentColor = color;
      changeIcon(commentLabel, commentColor);
    }
  }

  void changeStringButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change String Color", stringColor);
    if(color != null)
    {
      stringColor = color;
      changeIcon(stringLabel, stringColor);
    }
  }

  void changeKeywordButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change Keyword Color", keywordColor);
    if(color != null)
    {
      keywordColor = color;
      changeIcon(keywordLabel, keywordColor);
    }
  }

  void changeCustomButton_actionPerformed(ActionEvent e)
  {
    Color color = JColorChooser.showDialog(this, "Change Custom Keyword Color", customKeywordColor);
    if(color != null)
    {
      customKeywordColor = color;
      changeIcon(customLabel, customKeywordColor);
    }
  }

  protected void changeIcon(JLabel label, Color newColor)
  {
      label.setIcon(new ColoredSquare(newColor));
      label.repaint();
  }

  void addKeywordButton_actionPerformed(ActionEvent e)
  {
    String res = JOptionPane.showInputDialog(this, "Please input a keyword - NO WHITESPACES");
    if(res == null) {return;}

    res = res.trim();
    if(res == "") {return;}
    TE key = new TE(res);
    key.setIcon(loadImageIcon("images/keyword.gif", "key"));
    keywordModel.addElement(key);
    keywordTable.put(key.getName(), "custom");
    keywordList.repaint();
  }

  void deleteKeywordButton_actionPerformed(ActionEvent e)
  {
    try
    {
      Object o = keywordList.getSelectedValue();
      keywordModel.removeElement(o);
      if(o != null)
      {
        keywordTable.remove(o);
      }
      keywordList.repaint();
    }
    catch(Exception x) {;}
  }

  void removeAllKeywordsButton_actionPerformed(ActionEvent e)
  {
    try
    {
      keywordModel.removeAllElements();
      keywordTable = new java.util.Hashtable();
      keywordList.repaint();
    }
    catch(Exception x) {;}
  }

  void newButton_actionPerformed(ActionEvent e)
  {
     // Toolbar Tab
     String res = JOptionPane.showInputDialog(this, "Tab Name:");
     if(res == null) {return;}

     res = res.trim();
     res = res.replace(' ', '_');
     
     if(res.equals("")) {return;}

     ToolBarPanel t = new ToolBarPanel(res);
     //$t.setBorder(new BevelBorder(BevelBorder.RAISED));
     SuperEdit.superEdit.toolTabs.addElement(t);

     TE sec;
     sec = new TE(t);
     sec.setIcon(loadImageIcon("images/myFolder.gif", "section item"));
     sec.setIcon2(loadImageIcon("images/myFolderOpen.gif", "section item"));
     sectionModel.addElement(sec);
     sectionList.repaint();

     SuperEdit.superEdit.jTabbedPane1.addTab(res, t);
     SuperEdit.superEdit.jTabbedPane1.repaint();


  }

  void removeButton_actionPerformed(ActionEvent e)
  {
     // Toolbar Tab
     int z = sectionList.getSelectedIndex();
     int x = itemList.getSelectedIndex();

     if(x<0)
     {
       ToolBarPanel tmp = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getComponentAt(z);

       /*if(tmp.name.equals("Macros") || tmp.name.equals("Custom"))
       {
         JOptionPane.showMessageDialog(this, "Sorry. This item cannot be deleted.");
         return;
       } */
       /*else*/ if(true)
       {
         int res = JOptionPane.showConfirmDialog(this, "Remove " + tmp.name + " and all its components?");
         if(res == JOptionPane.OK_OPTION)
         {
           sectionModel.removeElementAt(z);
           SuperEdit.superEdit.jTabbedPane1.removeTabAt(z);
           sectionList.setSelectedIndex(0);
           sectionList.repaint();
           SuperEdit.superEdit.jTabbedPane1.repaint();
         }
       }
     }
     else
     {
       ToolbarButton t = (ToolbarButton) ((TE)itemModel.getElementAt(x)).contents;

       int res = JOptionPane.showConfirmDialog(this, "Remove Button \"" + t + "\"?");
       if(res == JOptionPane.OK_OPTION)
       {
         itemModel.removeElementAt(x);
         itemList.repaint();
         ToolBarPanel tmp = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getComponentAt(z);
         tmp.remove(t);
         tmp.doLayout();
         tmp.repaint();
       }
     }

  }

  void upButton_actionPerformed(ActionEvent e)
  {
     // Toolbar Tab

     int z = sectionList.getSelectedIndex();
     int x = itemList.getSelectedIndex();

     if(x < 0)
     {
       if(z <= 0) {return;}

       Object tmp = sectionModel.elementAt(z-1);
       sectionModel.setElementAt(sectionModel.elementAt(z), z-1);
       sectionModel.setElementAt(tmp, z);
       sectionList.setSelectedIndex(z-1);
       sectionList.repaint();

       ToolBarPanel tmp2 = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getComponentAt(z);
       ToolBarPanel tmp3 = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getComponentAt(z-1);

       SuperEdit.superEdit.jTabbedPane1.removeTabAt(z);
       SuperEdit.superEdit.jTabbedPane1.removeTabAt(z-1);

       SuperEdit.superEdit.jTabbedPane1.insertTab(tmp3.name, null, tmp3, null, z-1);
       SuperEdit.superEdit.jTabbedPane1.insertTab(tmp2.name, null, tmp2, null, z-1);

       SuperEdit.superEdit.jTabbedPane1.repaint();
       SuperEdit.superEdit.jTabbedPane1.setSelectedComponent(tmp2);
       SuperEdit.superEdit.jTabbedPane1.getSelectedComponent().repaint();
     }
     else
     {
       if(x <= 0) {return;}

       TE te1 = (TE) itemModel.elementAt(x-1);
       TE te2 = (TE) itemModel.elementAt(x);

       ToolbarButton button1 = (ToolbarButton) te1.contents;
       ToolbarButton button2 = (ToolbarButton) te2.contents;

       String Ttip1 = te1.getTip();
       String Tname1 = te1.getName();
       ImageIcon Ticon1 = te1.getIcon();
       String Bdata1 = button1.data;
       String Bpath1 = button1.path;
       String Btip1 = button1.tip;
       String Bdes1 = button1.description;
       ImageIcon Bi161 = button1.i16;
       ImageIcon Bi321 = button1.i32;

       String Ttip2 = te2.getTip();
       String Tname2 = te2.getName();
       ImageIcon Ticon2 = te2.getIcon();
       String Bdata2 = button2.data;
       String Bpath2 = button2.path;
       String Btip2 = button2.tip;
       String Bdes2 = button2.description;
       ImageIcon Bi162 = button2.i16;
       ImageIcon Bi322 = button2.i32;

       // Swam em'

       te1.setTip(Ttip2);
       te1.setName(Tname2);
       te1.setIcon(Ticon2);
       button1.data = Bdata2;
       button1.path = Bpath2;
       button1.tip = Btip2;
       button1.description = Bdes2;
       button1.i16 = Bi162;
       button1.i32 = Bi322;
       button1.setToolTipText(Btip2);
       button1.setIcon(Bi322);

       te2.setTip(Ttip1);
       te2.setName(Tname1);
       te2.setIcon(Ticon1);
       button2.data = Bdata1;
       button2.path = Bpath1;
       button2.tip = Btip1;
       button2.description = Bdes1;
       button2.i16 = Bi161;
       button2.i32 = Bi321;
       button2.setToolTipText(Btip1);
       button2.setIcon(Bi321);

       button1.repaint();
       button2.repaint();
       itemList.setSelectedIndex(x-1);
       itemList.repaint();

     }
  }

  void downButton_actionPerformed(ActionEvent e)
  {
     // Toolbar Tab

     int z = sectionList.getSelectedIndex();
     int x = itemList.getSelectedIndex();

     if(x < 0)
     {
       if(z < 0) {return;}

       if(z >= sectionModel.size() - 1) {return;}

       Object tmp = sectionModel.elementAt(z+1);
       sectionModel.setElementAt(sectionModel.elementAt(z), z+1);
       sectionModel.setElementAt(tmp, z);
       sectionList.setSelectedIndex(z+1);
       sectionList.repaint();

       ToolBarPanel tmp2 = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getComponentAt(z);
       ToolBarPanel tmp3 = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getComponentAt(z+1);

       SuperEdit.superEdit.jTabbedPane1.removeTabAt(z);
       SuperEdit.superEdit.jTabbedPane1.removeTabAt(z);

       SuperEdit.superEdit.jTabbedPane1.insertTab(tmp3.name, null, tmp3, null, z);
       SuperEdit.superEdit.jTabbedPane1.insertTab(tmp2.name, null, tmp2, null, z+1);

       SuperEdit.superEdit.jTabbedPane1.repaint();
       SuperEdit.superEdit.jTabbedPane1.setSelectedComponent(tmp2);
       SuperEdit.superEdit.jTabbedPane1.getSelectedComponent().repaint();
     }
     else
     {
       if(x < 0) {return;}

       if(x >= itemModel.size() - 1) {return;}

       TE te1 = (TE) itemModel.elementAt(x+1);
       TE te2 = (TE) itemModel.elementAt(x);

       ToolbarButton button1 = (ToolbarButton) te1.contents;
       ToolbarButton button2 = (ToolbarButton) te2.contents;

       String Ttip1 = te1.getTip();
       String Tname1 = te1.getName();
       ImageIcon Ticon1 = te1.getIcon();
       String Bdata1 = button1.data;
       String Bpath1 = button1.path;
       String Btip1 = button1.tip;
       String Bdes1 = button1.description;
       ImageIcon Bi161 = button1.i16;
       ImageIcon Bi321 = button1.i32;

       String Ttip2 = te2.getTip();
       String Tname2 = te2.getName();
       ImageIcon Ticon2 = te2.getIcon();
       String Bdata2 = button2.data;
       String Bpath2 = button2.path;
       String Btip2 = button2.tip;
       String Bdes2 = button2.description;
       ImageIcon Bi162 = button2.i16;
       ImageIcon Bi322 = button2.i32;

       // Swam em'

       te1.setTip(Ttip2);
       te1.setName(Tname2);
       te1.setIcon(Ticon2);
       button1.data = Bdata2;
       button1.path = Bpath2;
       button1.tip = Btip2;
       button1.description = Bdes2;
       button1.i16 = Bi162;
       button1.i32 = Bi322;
       button1.setToolTipText(Btip2);
       button1.setIcon(Bi322);

       te2.setTip(Ttip1);
       te2.setName(Tname1);
       te2.setIcon(Ticon1);
       button2.data = Bdata1;
       button2.path = Bpath1;
       button2.tip = Btip1;
       button2.description = Bdes1;
       button2.i16 = Bi161;
       button2.i32 = Bi321;
       button2.setToolTipText(Btip1);
       button2.setIcon(Bi321);

       button1.repaint();
       button2.repaint();
       itemList.setSelectedIndex(x+1);
       itemList.repaint();
     }
  }

  void jButton3_actionPerformed(ActionEvent e)
  {
    Chooser chooser = new Chooser();
    chooser.setTitle("Select an image");
    chooser.setFileFilter(chooser.bothFilter);
    File theFile;
    ImageIcon i = null;


	  int retval = chooser.showDialog(this, null);
	  if(retval == Chooser.APPROVE_OPTION)
    {
	    theFile = chooser.getSelectedFile();
	    if(theFile != null)
      {
		    if(theFile.exists())
        {
           customImageName.setText(theFile.getAbsolutePath());
           customImageName.repaint();
           ImageIcon tmpIcon = new ImageIcon(theFile.getAbsolutePath());
           i = (tmpIcon == null) ? (ImageIcon)defaultIcon : new ImageIcon(tmpIcon.getImage().getScaledInstance(32,32, Image.SCALE_DEFAULT));
           previewButton.setIcon(i);
           previewButton.repaint();
           previewButton.setToolTipText((customTip.getText().equals("")) ? null : customTip.getText());
           return;
        }
      }
    }
    customImageName.setText("");
    customImageName.repaint();
    i = (ImageIcon)defaultIcon;
    previewButton.setIcon(i);
    previewButton.repaint();
    previewButton.setToolTipText((customTip.getText().equals("")) ? null : customTip.getText());
  }

  void addCustomItem_actionPerformed(ActionEvent e)
  {
    String cTip = customTip.getText();
    String cData = codeTextArea.getText();
    String cImage = customImageName.getText();
    String cDesc = customDescription.getText();

    ToolbarButton tb = new ToolbarButton(cDesc, (cImage.equals("")) ? null : new ImageIcon(cImage), cData, (cTip.equals("")) ? null : cTip, cImage);
    TE te = new TE(tb);
    te.setIcon(tb.get16x16());

    itemModel.addElement(te);
    itemList.repaint();

    ToolBarPanel tmp = (ToolBarPanel) SuperEdit.superEdit.jTabbedPane1.getSelectedComponent();
    tmp.add(tb);
    SuperEdit.superEdit.jTabbedPane1.getSelectedComponent().doLayout();

    tmp.repaint();
    tb.repaint();
    SuperEdit.superEdit.jTabbedPane1.getSelectedComponent().repaint();
  }

  public void refreshItemList()
  {
    itemModel.removeAllElements();
    itemList.repaint();
    
    Component[] tools = ((ToolBarPanel)SuperEdit.superEdit.jTabbedPane1.getSelectedComponent()).getComponents();
    for(int i = 0; i < tools.length; i++)
    {
      ToolbarButton tb = (ToolbarButton)tools[i];
      TE te2 = new TE(tb);
      te2.setIcon(tb.get16x16());
      itemModel.addElement(te2);
      itemList.repaint();
    }
  }

  class pList extends JList
  {
   public pList(DefaultListModel dl)
   {
     super(dl);
   }

   public void processMouseEvent(java.awt.event.MouseEvent me)
   {
     if(me.isPopupTrigger())
     {
       popup.show(this, me.getX(), me.getY());
     }
     else
     {
       super.processMouseEvent(me);
     }
   }
  }

  void editPopup_actionPerformed(ActionEvent e)
  {
    int x = itemList.getSelectedIndex();
    if(x<0) {return;}

    new ButtonEditor(this, (TE)itemModel.getElementAt(x));

  }

  void removePopup_actionPerformed(ActionEvent e)
  {
    removeButton_actionPerformed(e);
  }

}


