
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import com.sun.java.swing.*;
import java.awt.event.*;

public class ImagePreviewer extends JFrame
{
  ImageIcon image;

  public ImagePreviewer(java.io.File theFile)
  {
    this.image = new ImageIcon(theFile.getAbsolutePath());
    setTitle(theFile.getName());

    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    try
    {
	    java.net.URL url = getClass().getResource("images/preview.gif");
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}

    //this.setTitle("Image Viewer");
    this.getContentPane().setLayout(new BorderLayout());

    this.setSize(image.getIconWidth()+16, image.getIconHeight()+30);
    int x = getToolkit().getScreenSize().width/2 - this.getSize().width/2;
    int y = getToolkit().getScreenSize().height/2 - this.getSize().height/2;

    this.setLocation(x < 0 ? 0 : x, y < 0 ? 0 : y);


    this.getContentPane().add(new JScrollPane(new JLabel(image)), BorderLayout.CENTER);


    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });

   this.toFront();
   setVisible(true);
  }

  void this_windowClosing(WindowEvent e)
  {
    this.dispose();
  }


}

 