
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import borland.jbcl.layout.*;
import com.sun.java.swing.*;
import java.awt.event.*;
import java.io.File;
import java.util.Properties;

public class JavaCompilerOptions extends JPanel
{
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JTextField compiler = new JTextField();
  JTextField classpath = new JTextField();
  JTextField output = new JTextField();
  JTextField root = new JTextField();
  JCheckBox autoScan = new JCheckBox();
  JButton addButton = new JButton();
  JCheckBox includeSystem = new JCheckBox();

  private String systemClasspath = "";
  private String localClasspath = "";
  private String javaHome = "";
  private String userHome = "";
  JLabel jLabel6 = new JLabel();
  JTextField compilerFlags = new JTextField();
  JLabel jLabel7 = new JLabel();
  JTextField jvm = new JTextField();
  JLabel jLabel8 = new JLabel();
  JTextField runtimeFlags = new JTextField();
  JLabel jLabel9 = new JLabel();
  JTextField runnableFile = new JTextField();


  public JavaCompilerOptions()
  {
    try 
    {
      jbInit();
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception
  {
    xYLayout1.setHeight(323);
    jLabel1.setText("Java Compiler");
    jLabel1.setFont(new Font("Serif", 1, 24));
    jLabel2.setText("Compiler:");
    jLabel3.setText("Classpath:");
    jLabel4.setText("Output Directory:");
    jLabel5.setText("Project Root:");
    compiler.setEditable(false);
    classpath.setEditable(false);
    output.setEditable(false);
    root.setEditable(false);
    autoScan.setText("Auto Scan");
    autoScan.setSelected(true);
    addButton.setText("Add To Classpath");
    includeSystem.setText("Use System Classpath");
    includeSystem.setSelected(true);
    jLabel6.setText("Extra Compiler Flags:");
    compilerFlags.setText("-O -J-ms8m -J-mx16m");
    compilerFlags.setFont(new Font("SansSerif", 1, 12));
    jLabel7.setText("JVM:");
    jvm.setEditable(false);
    jLabel8.setText("Extra Runtime Flags:");
    runtimeFlags.setText("-ms8m -mx16m");
    runtimeFlags.setFont(new Font("SansSerif", 1, 12));
    jLabel9.setText("Runnable File:");
    includeSystem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        includeSystem_actionPerformed(e);
      }
    });
    addButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        addButton_actionPerformed(e);
      }
    });
    autoScan.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        autoScan_actionPerformed(e);
      }
    });
    xYLayout1.setWidth(369);
    this.setLayout(xYLayout1);
    this.add(jLabel1, new XYConstraints(106, 4, 157, 34));
    this.add(jLabel2, new XYConstraints(26, 45, 66, 21));
    this.add(jLabel3, new XYConstraints(26, 72, 71, 21));
    this.add(jLabel4, new XYConstraints(26, 99, 104, 21));
    this.add(jLabel7, new XYConstraints(24, 152, 83, 21));
    this.add(jLabel5, new XYConstraints(26, 125, 83, 21));
    this.add(classpath, new XYConstraints(126, 71, 225, 23));
    this.add(output, new XYConstraints(126, 98, 225, 23));
    this.add(runtimeFlags, new XYConstraints(144, 287, 206, 23));
    this.add(compilerFlags, new XYConstraints(144, 257, 206, 23));
    this.add(jvm, new XYConstraints(127, 151, 224, 23));
    this.add(root, new XYConstraints(127, 124, 224, 23));
    this.add(compiler, new XYConstraints(127, 44, 224, 23));
    this.add(autoScan, new XYConstraints(19, 210, 84, 23));
    this.add(addButton, new XYConstraints(214, 215, 136, 27));
    this.add(includeSystem, new XYConstraints(19, 233, -1, -1));
    this.add(jLabel8, new XYConstraints(22, 287, 120, 20));
    this.add(jLabel6, new XYConstraints(22, 258, -1, 20));
    this.add(jLabel9, new XYConstraints(24, 179, 86, 22));
    this.add(runnableFile, new XYConstraints(128, 179, 224, 23));

    String s = File.separator;

    Properties props = System.getProperties();
    systemClasspath = props.getProperty("java.class.path");
    javaHome = props.getProperty("java.home");
    userHome = props.getProperty("user.home");
    localClasspath = javaHome + (javaHome.endsWith(s) ? "" : s) + "lib" + s + "classes.zip";


    compiler.setText(javaHome + (javaHome.endsWith(s) ? "" : s) + "bin" + s + "javac");
    jvm.setText(javaHome + (javaHome.endsWith(s) ? "" : s) + "bin" + s + "java");
    classpath.setText(includeSystem.isSelected() ? systemClasspath : localClasspath);
    root.setText(userHome + (userHome.endsWith(s) ? "" : s) + "SuperEdit_Projects" + s + "SRC");
    output.setText(userHome + (userHome.endsWith(s) ? "" : s) + "SuperEdit_Projects" + s + "OUT");

  }

  void autoScan_actionPerformed(ActionEvent e)
  {
    compiler.setEditable(!compiler.isEditable());
    compiler.repaint();
    classpath.setEditable(!classpath.isEditable());
    classpath.repaint();
    output.setEditable(!output.isEditable());
    output.repaint();
    root.setEditable(!root.isEditable());
    root.repaint();
  }

  void addButton_actionPerformed(ActionEvent e)
  {
    Chooser chooser = new Chooser();
    chooser.setOpen();
    chooser.setTitle("Add To Classpath");
    chooser.setAccessory(null);
    chooser.setFileSelectionMode(Chooser.FILES_AND_DIRECTORIES);

	  int retval = chooser.showDialog(this, null);
	  if(retval == Chooser.APPROVE_OPTION)
    {
	    File theFile = chooser.getSelectedFile();
	    if(theFile != null)
      {
		    if(theFile.exists())
        {
          classpath.setText(classpath.getText() + File.pathSeparator + theFile.getAbsolutePath());
          classpath.repaint();
        }
        else
        {
          JOptionPane.showMessageDialog(this, "Directory does not exist: " + chooser.getSelectedFile().getAbsolutePath());
        }
		    return;
      }
    }
    JOptionPane.showMessageDialog(this, "No directory was chosen.");
  }

  void includeSystem_actionPerformed(ActionEvent e)
  {
     classpath.setText(includeSystem.isSelected() ? systemClasspath : localClasspath);
     classpath.repaint();
  }

  public String getCompileCMD()
  {
    try
    {
      if(!output.getText().equals(""))
      {
        File tmp = new File(output.getText());
        if(!tmp.exists())
        {
          tmp.mkdirs();
        }
      }
    }
    catch(Exception x){;}

   return compiler.getText() + " " +
          compilerFlags.getText() + " " +
          (classpath.getText().equals("") ? "" : "-classpath " + classpath.getText()) + File.pathSeparator + output.getText() + File.pathSeparator + root.getText() + " " +
          (output.getText().equals("") ? "" : "-d " + output.getText()) + " ";
  }

  public String getRunCMD()
  {
    try
    {
      if(!output.getText().equals(""))
      {
        File tmp = new File(output.getText());
        if(!tmp.exists())
        {
          tmp.mkdirs();
        }
      }
    }
    catch(Exception x){;}

   return jvm.getText() + " " +
          runtimeFlags.getText() + " " +
          (classpath.getText().equals("") ? "" : "-classpath " + classpath.getText()) + File.pathSeparator + output.getText() + File.pathSeparator + root.getText() + " " + runnableFile.getText();
  }

  public String toString()
  {
    return "Java Compiler";
  }
}

                                      
