/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
/*
   This class performs dynamic syntax highlighting as words are
   typed by the user
 */

package SuperEdit;

public class Looper extends Thread
{
  Editor editor;

  public Looper(Editor e)
  {
    super();
    this.editor = e;
  }

  private void loop()
  {
    while(!editor.wordFound)
    {
      ; // wait until a word is found
    }

    // Word found
    editor.removeFontifier(editor.theListener);

    // Modify text pane here

    /*
      Debug information to make sure that threads are notified of document changes.
      System.out.println(" *** THREAD NOTIFIED -> (" + editor.x + ", " + editor.y + ") ***");
     */
    try{
         //editor.doc.setLogicalStyle(editor.x, editor.currentStyle);
         editor.doc.setCharacterAttributes(editor.x, editor.y - editor.x, editor.currentStyle, true);
        }
    catch(Exception e) {System.out.println("WHOOPS!");}

    //Reset flag
    editor.addFontifier(editor.theListener);
    editor.wordFound = false;
    this.suspend();
  }

  public void run()
  {
    while(true)
    {
     try
     {
       loop();
     }
     catch (Exception ex)
     {
		    System.err.println("The following Exception occurred and was written to");
		    System.err.println("the error log. If you are able to reproduce the error,");
		    System.err.println("please send the log and a description of what you were");
		    System.err.println("doing to PsychoticSoftware@hotmail.com");
        System.out.println("     <--           Looper.class -->");
        ex.printStackTrace();
     }


    }
  }

}