/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
/*
   This is an Auxilliarry highlighting thread.
   Used for colorizing comments and stuff other than keywords.
 */

package SuperEdit;
import com.sun.java.swing.text.*;
import com.sun.java.swing.*;

public class LooperAux extends Thread
{
  Editor editor;
  int offset;
  int length;
  AttributeSet s;
  boolean replace;
  boolean reset = false;
  Style style;


  public LooperAux(Editor e, int offset, int length, AttributeSet s, boolean replace)
  {
    super();
    this.editor = e;
    this.offset = offset;
    this.length = length;
    this.s = s;
    this.replace = replace;
  }

  public LooperAux(Editor e, int offset, Style style)
  {
    super();
    this.editor = e;
    this.reset = true;
    this.offset = offset;
    this.style = style;
  }


  private void executeCharAttributeChange()
  {
    editor.removeFontifier(editor.theListener);
    editor.doc.setCharacterAttributes(offset, length, s, replace);
    editor.addFontifier(editor.theListener);
    this.stop();
  }

  private void resetLogical()
  {
    editor.removeFontifier(editor.theListener);

    //editor.doc.setLogicalStyle(offset, style);

    //editor.doc.setParagraphAttributes(offset, 2, style, false);

    try{
    editor.doc.insertString(offset, "X", s);
    }
    catch(Exception e){System.out.println("Whoops 1");}


    //editor.doc.setCharacterAttributes(offset-5, 4, s, false);


    editor.addFontifier(editor.theListener);
    this.stop();
  }


  public void run()
  {
    while(true)
    {
     try
     {
       if(reset)
       {
         resetLogical();
       }
       else
       {
         executeCharAttributeChange();
       }
     }
     catch (Exception ex)
     {
		    System.err.println("The following Exception occurred and was written to");
		    System.err.println("the error log. If you are able to reproduce the error,");
		    System.err.println("please send the log and a description of what you were");
		    System.err.println("doing to PsychoticSoftware@hotmail.com");
        System.out.println("        <-- LooperAux.class -->");
        ex.printStackTrace();
     }
    }
  }

}