/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import com.sun.java.swing.Icon;
import com.sun.java.swing.ImageIcon;
import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTree;
import com.sun.java.swing.tree.TreeCellRenderer;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import java.awt.Component;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

public class MRenderer extends JLabel implements TreeCellRenderer
{
    ImageIcon  blueBall = loadImageIcon("images/blueBall.gif", "Blue Ball");
    ImageIcon  yellowBall = loadImageIcon("images/yellowBall.gif", "Yellow Ball");
    ImageIcon  greenBall = loadImageIcon("images/greenBall.gif", "Green Ball");
    ImageIcon  redBall = loadImageIcon("images/redBall.gif", "Red Ball");
    ImageIcon  defaultLeaf = loadImageIcon("images/defaultLeaf.gif", "defaultLeaf");
    ImageIcon  myFolder = loadImageIcon("images/myFolder.gif", "Folder");

    static protected Font             defaultFont;
    //static protected final Color SelectedBackgroundColor = Color.yellow;

    static
    {
	    try {
	          defaultFont = new Font("SansSerif", Font.BOLD, 12);
	        }
      catch (Exception e) {}
    }

    /** Whether or not the item that was last configured is selected. */
    protected boolean            selected;


    public Component getTreeCellRendererComponent(JTree tree, Object value,
					  boolean selected, boolean expanded,
					  boolean leaf, int row,
						  boolean hasFocus)
    {

	  Font            font;
	  String          stringValue = tree.convertValueToText(value, selected,
					   expanded, leaf, row, hasFocus);

	/* Set the text. */
	setText(stringValue);

	/* Tooltips used by the tree. */
	//setToolTipText(stringValue);

  /* Set Fonts */
  setFont(defaultFont);

	/* Set the image. */
  if(leaf)
  {
	  if(((DefaultMutableTreeNode)value).getUserObject() instanceof TE)
    {
      TE obj = (TE)((DefaultMutableTreeNode)value).getUserObject();
      if(obj.getIcon() != null)
      {
        setIcon(obj.getIcon());
      }
      else if(obj.getType() == TE.PUBLIC)
      {
	      setIcon(greenBall);
      }
      else if(obj.getType() == TE.PRIVATE)
      {
	      setIcon(redBall);
      }
      else if(obj.getType() == TE.PROTECTED)
      {
	      setIcon(blueBall);
      }
      else if(obj.getType() == TE.FRIENDLY)
      {
	      setIcon(yellowBall);
      }
      else
      {
	      setIcon(defaultLeaf);
      }

      if(obj.getTip() != null)
      {
        setToolTipText(obj.getTip());
      }

    }
    else
    {
      setIcon(defaultLeaf);
    }
  }
  else
  {
	  if(((DefaultMutableTreeNode)value).getUserObject() instanceof TE)
    {
      TE obj = (TE)((DefaultMutableTreeNode)value).getUserObject();
      if(obj.getIcon() != null)
      {
        setIcon(obj.getIcon());
      }
      else
      {
        setIcon(myFolder);
      }
    }
    else if (((DefaultMutableTreeNode)value).getUserObject() instanceof DefaultMutableTreeNode)
    {
      DefaultMutableTreeNode val2 = (DefaultMutableTreeNode) ((DefaultMutableTreeNode)value).getUserObject();

	    if(((DefaultMutableTreeNode)val2).getUserObject() instanceof TE)
      {
        TE obj = (TE)((DefaultMutableTreeNode)val2).getUserObject();
        if(obj.getIcon() != null)
        {
          setIcon(obj.getIcon());
        }
        else
        {
          setIcon(myFolder);
        }
      }
    }
    else
    {
      setIcon(myFolder);
    }
  }

	/* Update the selected flag for the next paint. */
  this.selected = selected;
	return this;
  }

  public void paint(Graphics g)
  {
	  Color            bColor;
	  Icon             currentI = getIcon();

    setForeground(Color.black);
	  if(selected)
	    bColor = SuperEdit.superEdit.ideOptions.browserSelectColor;
	  else if(getParent() != null)
	    bColor = getParent().getBackground();
	  else
	    bColor = getBackground();
	  g.setColor(bColor);
	  if(currentI != null && getText() != null) {
    int offset = (currentI.getIconWidth() + getIconTextGap());
	    g.fillRect(offset, 0, getWidth() - 1 - offset,
      		       getHeight() - 1);
	  }
	  else
	    g.fillRect(0, 0, getWidth()-1, getHeight()-1);
	  super.paint(g);
  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }


}
