package SuperEdit.RAD;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class BeanLabel extends JLabel
{
  Image image;
  String name;
  int index;
  ToolBox tb;

  ImageIcon defaultIcon = loadImageIcon("images/blank16.gif", "img");

  Border on = new BevelBorder(BevelBorder.RAISED);
  Border off = null;
  Border clk = new BevelBorder(BevelBorder.LOWERED);

  public BeanLabel(Image image, String name, int index, ToolBox tb)
  {
    super(name);
    setHorizontalAlignment(JLabel.LEFT);
    this.setIcon(image == null ? defaultIcon : new ImageIcon(image));
    this.image = image;
    this.name = name;
    this.index = index;
    this.tb = tb;
    setSize(getPreferredSize().width + 10, getPreferredSize().height);

    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {

    this.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseEntered(MouseEvent e)
      {
        this_mouseEntered(e);
      }
      public void mouseExited(MouseEvent e)
      {
        this_mouseExited(e);
      }
      public void mouseClicked(MouseEvent e)
      {
        this_mouseClicked(e);
      }
    });
  }

  void this_mouseEntered(MouseEvent e)
  {
    setBorder(on);
    repaint();
  }

  void this_mouseExited(MouseEvent e)
  {
    setBorder(off);
    repaint();
  }

  void this_mouseClicked(MouseEvent e)
  {
    setBorder(clk);
    repaint();
    tb.pane.tools.mouseClicked(e);
  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }

}