
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit.RAD;

import java.beans.*;
import com.sun.java.swing.border.*;

public class BorderEditor extends PropertyEditorSupport
{
  private static String[] tagStrings = { "BevelBorder", "None", "EmptyBorder", "EtchedBorder", "LineBorder", "MatteBorder", "SoftBevelBorder", "TitledBorder", };
  private java.util.Hashtable borders = new java.util.Hashtable();

  public BorderEditor()
  {
   borders.put(tagStrings[0], new BevelBorder(BevelBorder.RAISED));
   borders.put(tagStrings[1], null);
   borders.put(tagStrings[2], new EmptyBorder(5, 5, 5, 5));
   borders.put(tagStrings[3], new EtchedBorder(EtchedBorder.LOWERED));
   borders.put(tagStrings[4], new LineBorder(java.awt.Color.black));
   borders.put(tagStrings[5], new MatteBorder(5, 5, 5, 5, java.awt.Color.red));
   borders.put(tagStrings[6], new SoftBevelBorder(SoftBevelBorder.LOWERED));
   borders.put(tagStrings[7], new TitledBorder("Title"));
  }

  public String[] getTags()
  {
    return tagStrings;
  }

  public String getJavaInitializationString()
  {
    return "\"" + getAsText() + "\"";
  }

  public void setAsText(String text) throws IllegalArgumentException
  {
    setValue(borders.get(text));
  }
}

