
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit.RAD;

import java.awt.*;
import java.beans.*;

public class DimensionEditor extends PropertyEditorSupport
{
  private String textDimension = "(80, 40)";
  private Dimension objectDimension = new Dimension(80, 40);

  public DimensionEditor()
  {
  }

  public boolean supportsCustomEditor()
  {
    return false;
  }

  public Object getValue()
  {
    return objectDimension;
  }

  public String getAsText()
  {
    return textDimension;
  }


  public void setValue(Object o)
  {
    if(! (o instanceof Dimension)) {return;}

    Dimension d = (Dimension) o;
    objectDimension = d;
    textDimension = "(" + d.width + ", " + d.height + ")";
    firePropertyChange();
  }

  public void setAsText(String s)
  {
    try
    {
      int w = (new Integer(s.substring(s.indexOf('(') + 1, s.indexOf(',')).trim())).intValue();
      int h = (new Integer(s.substring(s.indexOf(',') + 1, s.indexOf(')')).trim())).intValue();

      objectDimension = new Dimension(w, h);
      textDimension = "(" + w + ", " + h +")";
      firePropertyChange();
    }
    catch(Exception e)
    {
      ;
    }
  }


  public String getJavaInitializationString()
  {
    //TODO: Implement this for your property type
    return "java.awt.Dimension";
  }

  public boolean isPaintable()
  {
    return false;
  }

}

