/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;
import com.sun.java.swing.text.*;
import com.sun.java.swing.*;
import java.awt.Point;

public class Scan extends Thread
{
  Editor editor;
  int currentIndex = 0;

  public Scan(Editor editor)
  {
    this.editor = editor;
  }

  public void scan()
  {
    Point p;
    try
    {
      Fontifier f = editor.theListener;
      editor.status.removeAll();
		  JProgressBar progress = new JProgressBar();
      progress.setMinimum(0);
      progress.setMaximum((int) editor.doc.getLength());
      editor.status.add(progress);
      if(editor.par.parent.ideOptions.showProgressBox.isSelected())
      {
        editor.status.revalidate();
      }
      while((p=nextToken()) != null)
      {
        try{
        editor.doc.setCharacterAttributes(p.x, p.y - p.x, f.highlights.getStyle(f.wordType.get(editor.doc.getText(p.x, p.y - p.x))), true);
        progress.setValue(p.y);  }
        catch(Exception e) {;}
      }
      editor.status.removeAll();
      if(editor.par.parent.ideOptions.showProgressBox.isSelected())
      {
        editor.status.revalidate();
      }
    }
    catch(Exception ee)
    {
       ; // Do nothing
    }
  }

  public Point nextToken()
  {
    try
    {
      Point p = getNext(currentIndex);
      currentIndex = p.y;
      return p;
    }
    catch(Exception e)
    {
      return null;
    }
  }

  private Point getNext(int start)
  {
    int x = start;
    int y = start;

    try
    {
      while(isWhite(editor.doc.getText(x, 1)))
      {
        x = x + 1;
      }
      y = x + 1;

      while(!isWhite(editor.doc.getText(y, 1)))
      {
        y = y + 1;
      }
      return new Point(x, y);
    }
    catch(Exception e)
    {
      return null;
    }
  }

  public boolean isWhite(String str)
  {
    if(str.equals(" ") ||
       str.equals("\t") ||
       str.equals("(") ||
       str.equals(")") ||
       str.equals("{") ||
       str.equals("}") ||
       str.equals("[") ||
       str.equals("]") ||
       str.equals(".") ||
       str.equals(";") ||
       str.equals("\n")
       )
    {
      return true;
    }
    else
    {
      return false;
    }
  }

  public void run()
  {
    try
    {
      scan();
      ScanAux aux = new ScanAux(this);
      aux.scan();
      this.stop();
    }
    catch (Exception ex)
    {
		    System.err.println("The following Exception occurred and was written to");
		    System.err.println("the error log. If you are able to reproduce the error,");
		    System.err.println("please send the log and a description of what you were");
		    System.err.println("doing to PsychoticSoftware@hotmail.com");
        System.out.println("             <-- Scan.class -->");
        ex.printStackTrace();
    }

  }


}