/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;
import com.sun.java.swing.text.*;
import com.sun.java.swing.*;
import java.awt.Point;

public class ScanAux
{
  Editor editor;
  int currentIndex = 0;
  String currentCustom;
  String type;

  public ScanAux(Scan scan)
  {
    this.editor = scan.editor;
  }

  public void scan()
  {
    Point p;
    try
    {
      Fontifier f = editor.theListener;
      editor.status.removeAll();
		  JProgressBar progress = new JProgressBar();
      progress.setMinimum(0);
      progress.setMaximum((int) editor.doc.getLength());
      editor.status.add(progress);
      if(editor.par.parent.ideOptions.showProgressBox.isSelected())
      {
        editor.status.revalidate();
      }

      while((p=nextToken()) != null)
      {
        try{
        //currentCustom = editor.doc.getText(p.x, p.y - p.x);
        //type = f.wordType.get(currentCustom);
        editor.doc.setCharacterAttributes(p.x, p.y - p.x, f.highlights.getStyle(type), true);
        progress.setValue(p.y);  }
        catch(Exception e) {;}
      }
      editor.status.removeAll();
      if(editor.par.parent.ideOptions.showProgressBox.isSelected())
      {
        editor.status.revalidate();
      }
    }
    catch(Exception ee)
    {
       ; // Do nothing
    }
  }

  public Point nextToken()
  {
    try
    {
      Point p = getNext(currentIndex);
      currentIndex = p.y;
      return p;
    }
    catch(Exception e)
    {
      return null;
    }
  }

  private Point getNext(int start)
  {
    int x = start;
    int y = start;

    try
    {
      while(!editor.doc.getText(x, 2).equals("/*") &&
            !editor.doc.getText(x, 2).equals("//") &&
            !editor.doc.getText(x, 1).equals("\"")
            )
      {
        x = x + 1;
      }
      y = x + 1;

      // Slash-Star Comment
      if(editor.doc.getText(x, 2).equals("/*"))
      {
        while(!editor.doc.getText(y, 2).equals("*/"))
        {
          y = y + 1;
        }
        y = y+2;
        type = "comment";
      }


      // Slash-Slash Comment
      else if(editor.doc.getText(x, 2).equals("//"))
      {
        while(!editor.doc.getText(y, 1).equals("\n"))
        {
          y = y + 1;
        }
        type = "comment";
      }



      // String
      else if(editor.doc.getText(x, 1).equals("\""))
      {
        while(!(editor.doc.getText(y, 1).equals("\"") && !editor.doc.getText(y-1, 1).equals("\\")) )
        {
          y = y + 1;
        }
        y = y+1;
        type = "string";
      }


      // Default
      else
      {
        return null;
      }



      return new Point(x, y);
    }
    catch(Exception e)
    {
      return null;
    }
  }

}