/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import java.awt.Point;
import com.sun.java.swing.JProgressBar;
import com.sun.java.swing.tree.*;
import com.sun.java.swing.ImageIcon;
import java.util.*;

public class StructureScanner extends Thread
{
  //ClassNode classNode;
  //boolean newLine = true;
  //int newLine = 1;

  Editor editor;
  /*
     Tester test;
  */
  int currentIndex = 0;
  MutableTreeNode root;
  ImageIcon importIcon = loadImageIcon("images/importIcon.gif", "importIcon");

  boolean nextTokenIsImport = false;
  boolean startMethods = false;
  int modifierBuffer = TE.FRIENDLY;
  String returnBuffer = "";
  String accessBuffer = "";
  protected boolean isSlashSlash = false;
  protected boolean isSlashStar = false;
  private boolean isClass = false;
  private boolean isClassExtender = false;
  private boolean isImplementing = false;

  int depth = 0;
  //int classCount = 0;

  Hashtable braces = new Hashtable();

  public String constructor = "None";

  boolean skipRestOfLine = false;
  boolean initialized = false;
  private String charBuffer = "";
  protected  Vector allNodes = new Vector();
  protected  Vector inners = new Vector();

  public StructureScanner(Editor editor)
  {
    this.editor = editor;
    this.root = (MutableTreeNode)this.editor.par.browser.bottomPanel.model.getRoot();
  }

  public void scan()
  {
    Point p;
    try
    {
      editor.status.removeAll();
		  JProgressBar progress = new JProgressBar();
      progress.setMinimum(0);
      progress.setMaximum((int) editor.doc.getLength());
      editor.status.add(progress);
      if(editor.par.parent.ideOptions.showProgressBox.isSelected())
      {
        editor.status.revalidate();
      }

      while((p=nextToken()) != null)
      {
        try
        {
          String res = editor.doc.getText(p.x, p.y - p.x);

                if(startMethods && !isClass)
                {
                   Record tmp3 = (Record) allNodes.lastElement();
                   tmp3.setType(1);
                   startMethods = false;
                }

          //if(isSlashSlash)
          //{
          //  ;

          //
          //else if(commentReturnBuffer)
          //{
          //  commentReturnBuffer = false;
          //}

          //else if(res.charAt(res.length()-1) == '/' && res.charAt(res.length()-2) == '*')
          //{
          //  isSlashStar = false;
          //}

          //else if(isSlashStar)
          //{
          //  ;
          //}

          if(res.charAt(0) == '/' && res.charAt(1) == '/')
          {
            //isSlashSlash = true;
            int retVal = editor.doc.getText(0, editor.doc.getLength()).indexOf("\n", currentIndex);
            if(retVal >= 0) {currentIndex = retVal;}
            else
            {
              retVal = editor.doc.getText(0, editor.doc.getLength()).indexOf("\r", currentIndex);
              if(retVal >= 0) {currentIndex = retVal;}
              else {;}
            }
          }


          else if(res.charAt(0) == '/' && res.charAt(1) == '*')
          {
            //isSlashStar = true;
            int retVal = editor.doc.getText(0, editor.doc.getLength()).indexOf("*/", currentIndex);
            if(retVal >= 0) {currentIndex = retVal + 1;}
            else
            {
              retVal = editor.doc.getText(0, editor.doc.getLength()).indexOf("*/", currentIndex);
              if(retVal >= 0) {currentIndex = retVal + 1;}
              else {;}
            }
          }

          else if(isImplementing)
          {
            ;
          }

          else if(res.equals("class") && depth == 0)
          {
            p=nextToken(); res = editor.doc.getText(p.x, p.y - p.x);
            if (res == null) {return;}
            constructor = res;
            currentIndex = editor.doc.getText(0, editor.doc.getLength()).indexOf("{", currentIndex);
          }

          else if(res.equals("extends"))
          {
            isClassExtender = true;
          }

          else if(res.equals("implements"))
          {
            isImplementing = true;
          }



          else if(nextTokenIsImport)
          {
            nextTokenIsImport = false;
            DefaultTreeModel model = this.editor.par.browser.bottomPanel.model;
            MutableTreeNode theImports = (MutableTreeNode) model.getChild(root,3);
            int newIndex = model.getChildCount(theImports);

            TE newEntry  = new TE(res);
            newEntry.setPoint(p);
            newEntry.setEditor(editor);
            newEntry.setIcon(importIcon);

            model.insertNodeInto(new DefaultMutableTreeNode(newEntry), theImports, newIndex);

          }

          else if(res.equals("import") || res.equals("package"))
          {
            nextTokenIsImport = true;
          }

          else if(isClass)
          {
            isClass = false;
            if(depth > 0)
            {
              TE nt;
              inners.addElement(new Record(new DefaultMutableTreeNode(nt = new TE(res, modifierBuffer)), 2));
              nt.setPoint(p);
              nt.setEditor(editor);
            }
            modifierBuffer = TE.FRIENDLY;
          }

          else if(isClassExtender)
          {
            isClassExtender = false;
          }


          else if(initialized)
          {
            initialized = false;
            //p=nextToken(); res = editor.doc.getText(p.x, p.y - p.x);
            //if(res == null) {return;}
          }


          else if(skipRestOfLine)
          {
            ;
          }

          else if(depth == 1)
          {
            boolean flag = true;

            while(flag)
            {
              if(res == null) {return;}
              if(isModifier(res) || isAccess(res))
              {
                // get next token
                p=nextToken(); res = editor.doc.getText(p.x, p.y - p.x);
              }

              else if(res.equals("class"))
              {
                  isClass = true;
                  flag = false;
              }

              else if(res.equals("extends"))
              {
                  isClassExtender = true;
                  flag = false;
              }

              else if(res.equals("implements"))
              {
                  isImplementing = true;
                  flag = false;
              }

              else
              {
                // res is currently the Type. Get 1 more for variable name
                if(!res.equals(constructor))
                {
                  p=nextToken(); res = editor.doc.getText(p.x, p.y - p.x);
                }
                if(res == null) {return;}


                if(startMethods)
                {
                   Record tmp3 = (Record) allNodes.lastElement();
                   tmp3.setType(1);
                   startMethods = false;
                }

                  TE newEntry  = new TE(res, modifierBuffer);
                  newEntry.setPoint(p);
                  newEntry.setEditor(editor);
                  //model.insertNodeInto(new DefaultMutableTreeNode(newEntry), theFields, newIndex);

                  //**************

                  allNodes.addElement(new Record(new DefaultMutableTreeNode(newEntry), 0));

                  //**************

                  modifierBuffer = TE.FRIENDLY;
                  skipRestOfLine = true;
                  flag = false;
              }
            }
          } // end else if depth = 1

          progress.setValue(p.y);
        }
        catch(Exception e) {;}
      }
      editor.status.removeAll();
      if(editor.par.parent.ideOptions.showProgressBox.isSelected())
      {
        editor.status.revalidate();
      }

      // Now, update the Browser

      Enumeration an;

      an = Utility.quicksortVector(allNodes).elements();
      //an = allNodes.elements();
      while(an.hasMoreElements())
      {
        Record cur = (Record) an.nextElement();

        DefaultTreeModel model = this.editor.par.browser.bottomPanel.model;
        MutableTreeNode theSlot = (MutableTreeNode) model.getChild(root,cur.getType());
        int newIndex = model.getChildCount(theSlot);

        model.insertNodeInto(cur.getNode(), theSlot, newIndex);
      }

      an = Utility.quicksortVector(inners).elements();
      //an = inners.elements();
      while(an.hasMoreElements())
      {
        Record cur = (Record) an.nextElement();

        DefaultTreeModel model = this.editor.par.browser.bottomPanel.model;
        MutableTreeNode theSlot = (MutableTreeNode) model.getChild(root,cur.getType());
        int newIndex = model.getChildCount(theSlot);

        model.insertNodeInto(cur.getNode(), theSlot, newIndex);
      }

    }
    catch(Exception ee)
    {
       ; // Do nothing
    }
  }

  public Point nextToken()
  {
    try
    {
      Point p = getNext(currentIndex);
      currentIndex = p.y;
      return p;
    }
    catch(Exception e)
    {
      return null;
    }
  }

  private Point getNext(int start)
  {
    int x = start;
    int y = start;

    try
    {
      while(isWhite(editor.doc.getText(x, 1),x))
      {
        x = x + 1;
      }
      y = x + 1;

      while(!isWhite(editor.doc.getText(y, 1),y))
      {
        y = y + 1;
      }
      return new Point(x, y);
    }
    catch(Exception e)
    {
      return null;
    }
  }

  public boolean isWhite(String str, int cPosition)
  {
    if(str.equals(" ") || str.equals("\t"))
    {
      return true;
    }

    else if(str.equals("["))
    {
      charBuffer = str;
      return true;
    }
    else if(str.equals("]"))
    {
      charBuffer = str;
      return true;
    }
    else if(str.equals("("))
    {
      charBuffer = str;
      return true;
    }
    else if(str.equals(")"))
    {
      charBuffer = str;
      return true;
    }

    else if(str.equals("\r") || str.equals("\n"))
    {
      isSlashSlash = false;
      return true;
    }
    else if(str.equals("="))
    {
      if(!isSlashSlash && !isSlashStar)
      {
        initialized = true;
      }
      charBuffer = str;
      return true;
    }
    else if(str.equals("{"))
    {
      if(braces.get("" + cPosition) == null)
      {
        braces.put("" + cPosition, "" + cPosition);
        ++depth;
      }

      isImplementing = false;
      if(charBuffer.equals(")")) {startMethods = true;}
      charBuffer = str;
      return true;
    }
    else if(str.equals("}"))
    {
      if(braces.get("" + cPosition) == null)
      {
        braces.put("" + cPosition, "" + cPosition);
        --depth;
      }

      charBuffer = str;
      return true;
    }
    else if(str.equals(";"))
    {
      if(!isSlashSlash && !isSlashStar)
      {
        skipRestOfLine = false;
      }
      charBuffer = str;
      return true;
    }
    else
    {
      return false;
    }
  }

  public boolean isModifier(String str)
  {
    if(str.equals("public"))
    {
       modifierBuffer = TE.PUBLIC;
       return true;
    }
    else if(str.equals("private"))
    {
       modifierBuffer = TE.PRIVATE;
       return true;
    }
    else if(str.equals("protected"))
    {
       modifierBuffer = TE.PROTECTED;
       return true;
    }
    else
    {
      return false;
    }
  }

  public boolean isAccess(String str)
  {
    if(str.equals("static") ||
       str.equals("native") ||
       str.equals("transient")
       )
    {
      accessBuffer = str;
      return true;
    }
    else
    {
      return false;
    }
  }


  public boolean isReturn(String str)
  {
    if(str.equals("void") ||
       str.equals("int") ||
       str.equals("float") ||
       str.equals("short") ||
       str.equals("double") ||
       str.equals("long") ||
       str.equals("boolean")
       )
    {
      returnBuffer = str;
      return true;
    }
    else
    {
      return false;
    }
  }

  public void run()
  {
    try
    {

      for(int i=0; i<=3; i++)
      {
        // deletes all children
        DefaultTreeModel model = this.editor.par.browser.bottomPanel.model;
        DefaultMutableTreeNode theSlot = (DefaultMutableTreeNode) model.getChild(root,i);

        theSlot.removeAllChildren();
        //model.reload(theSlot);

        if(i==3)
        {
          TE newEntry  = new TE("java.lang.*");
          newEntry.setIcon(loadImageIcon("images/importIcon.gif", "importIcon"));
          model.insertNodeInto(new DefaultMutableTreeNode(newEntry), theSlot, model.getChildCount(theSlot));
        }
      }

      ((TE)((DefaultMutableTreeNode)this.editor.par.browser.bottomPanel.getRoot().getUserObject()).getUserObject()).setName(editor.toString());

      scan();
      this.editor.par.browser.bottomPanel.model.reload();
      this.stop();
    }
    catch (Exception ex)
    {
		    System.err.println("The following Exception occurred and was written to");
		    System.err.println("the error log. If you are able to reproduce the error,");
		    System.err.println("please send the log and a description of what you were");
		    System.err.println("doing to PsychoticSoftware@hotmail.com");
        System.out.println("           <-- StructureScanner.class -->");
        ex.printStackTrace();
    }

  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }

  public class Record
  {
   private int type;
   private DefaultMutableTreeNode node;

   public Record(DefaultMutableTreeNode node, int type)
   {
    this.node = node;
    this.type = type;
   }

   public void setType(int type)
   {
     this.type = type;
   }

   public int getType()
   {
     return type;
   }

   public DefaultMutableTreeNode getNode()
   {
     return node;
   }

   public String toString()
   {
     return node.toString();
   }
  }

  private int t2 = 0;


}
