
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import com.sun.java.swing.*;
import borland.jbcl.layout.*;
import java.awt.event.*;
import java.net.URL;
import com.sun.java.swing.event.*;
import java.io.*;
import com.sun.java.swing.border.*;
import borland.jbcl.control.*;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import SuperEdit.RAD.*;

public class SuperEdit extends JFrame
{

  public static SuperEdit superEdit = null;
  private static boolean sp = true;
  private static boolean loadedTabs = false;
  public static java.io.PrintStream errorLog = null;
  public java.util.Vector toolTabs = new java.util.Vector();
  public java.util.Vector openedWindows = new java.util.Vector();
  XYConstraints tabConstraints = new XYConstraints(395, 5, 600,  75);

  Workspace workspace = new Workspace(this);
  Browser browser = workspace.getBrowser();
  boolean isBrowserOpen = false;
  Icon paintIco = loadImageIcon("images/paint.gif", "Paint");
  int seed = 1;


  Finder finder = new Finder(this);
  Replacer replacer = new Replacer(this);
  boolean projectUnsaved = false;

  JMenuBar menuBar = new JMenuBar();
  JMenu fileMenu = new JMenu();
  JMenuItem newItem = new JMenuItem();
  JMenuItem openItem = new JMenuItem();
  JMenu reOpenItem = new JMenu();
  JMenuItem untitledItem = new JMenuItem();
  JMenuItem saveItem = new JMenuItem();
  JMenuItem saveAsItem = new JMenuItem();
  JMenuItem exitIte = new JMenuItem();
  JMenu editMenu = new JMenu();
  JMenuItem cutItem = new JMenuItem();
  JMenuItem copyItem = new JMenuItem();
  JMenuItem pasteItem = new JMenuItem();
  JMenu buildMenu = new JMenu();
  JMenuItem buildOptionsItem = new JMenuItem();
  JMenu langModulesMenu = new JMenu();
  JMenu radModulesItem = new JMenu();
  JMenu toolsMenu = new JMenu();
  JMenuItem toolsOptionsItem = new JMenuItem();
  JMenu helpMenu = new JMenu();
  JMenuItem contentsItem = new JMenuItem();
  JMenuItem aboutItem = new JMenuItem();
  JMenuItem registerItem = new JMenuItem();
  JMenuItem undoItem = new JMenuItem();
  JMenuItem redoItem = new JMenuItem();
  XYLayout xYLayout1 = new XYLayout();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  ButtonGroup group2 = new ButtonGroup();
  ToolBarPanel macro = new ToolBarPanel("Macros");
  ToolBarPanel custom = new ToolBarPanel("Custom");
  public String lastProject = "NONE";
  File currentProject = null;

  JMenu viewMenu = new JMenu();
  JCheckBoxMenuItem workspaceItem = new JCheckBoxMenuItem();
  JCheckBoxMenuItem browserItem = new JCheckBoxMenuItem();
  JCheckBoxMenuItem messagesItem = new JCheckBoxMenuItem();

  JButton refreshButton = new JButton();

  ButtonBar buttonBar = new ButtonBar();
  SoftBevelBorder border = new SoftBevelBorder(SoftBevelBorder.RAISED);
  EtchedBorder etched = new EtchedBorder(EtchedBorder.LOWERED);
  IDEOptions ideOptions = new IDEOptions(this);
  JMenuItem languageOptions = new JMenuItem();
  JMenuItem radOptions = new JMenuItem();

  Editor currentEditor = null;
  JMenu searchMenu = new JMenu();
  JMenuItem findItem = new JMenuItem();
  JMenuItem findAgainItem = new JMenuItem();
  JMenuItem replaceItem = new JMenuItem();
  StatusBar mainStatus = new StatusBar();
  JMenuItem saveProjectItem = new JMenuItem();
  BuildOptions buildOptions = new BuildOptions();
  Messages messages = new Messages();


  public SuperEdit()
  {
    try
    {
      SuperEdit.superEdit = this;
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace() ;
    }
  }


  public static void main(String[] args)
  {
    // Connect to the error log
    try
    {
      File dir = new File("Logs");
      if(!dir.exists())
      {
        dir.mkdir();
      }
      File logFile = new File(dir, "err.log");
      errorLog = new java.io.PrintStream(new FileOutputStream(logFile.getAbsolutePath(), true));
      System.setErr(errorLog);
      errorLog.println("");
      errorLog.println("******** SuperEdit 1.0: Session started on " + new java.util.Date() + " ********");

    }
    catch(Exception e){System.out.println("Could not connect to log file");}

    java.util.Properties props2 = new java.util.Properties();
    try
    {
      File dir = new File("Config");
      if(dir.exists())
      {
        File configFile = new File(dir, "SuperEdit.properties");
        FileInputStream fis = new FileInputStream(configFile);
        props2.load(fis);
        fis.close();

        //Initialize tabs
        loadedTabs = true;
      }
    }
    catch(Exception x){;}

    sp = Boolean.valueOf(props2.getProperty("autosave", "true")).booleanValue();

    Conn cc;
    if(sp)
    {
      cc =  new Conn(false);
      (new Wrap(cc)).start();
    }

    SuperEdit superEdit1 = new SuperEdit();

    superEdit1.finder.loadConfig();
    superEdit1.replacer.loadConfig();

    if(!sp)
    {
      superEdit1.setVisible(true);
    }

    int X=0;
    int Y=superEdit1.getSize().height;
    int WIDTH=superEdit1.getToolkit().getScreenSize().width;
    int HEIGHT=superEdit1.getToolkit().getScreenSize().height - (superEdit1.getSize().height + 150);


    try
    {
      // Make sure directory exists -- If not, Create it

      File dir = new File("Config");
      if(dir.exists())
      {
        File configFile = new File(dir, "SuperEdit.properties");
        java.util.Properties props = new java.util.Properties();
        FileInputStream fis = new FileInputStream(configFile);
        props.load(fis);
        fis.close();

        String fil = props.getProperty("lastDir");
        if(fil != null)
        {
          try{
              Chooser.lastDir = new File(fil);
              }catch(Exception k){;}
        }

        try
        {
          int index = Integer.valueOf(props.getProperty("config")).intValue();
          superEdit1.ideOptions.configCombo.setSelectedIndex(index);
        }
        catch(Exception et) {;}

        if(superEdit1.ideOptions.rememberLocationBox.isSelected())
        {
          int a = Integer.valueOf(props.getProperty("x")).intValue();
          int b = Integer.valueOf(props.getProperty("y")).intValue();
          int c = Integer.valueOf(props.getProperty("width")).intValue();
          int d = Integer.valueOf(props.getProperty("height")).intValue();

          int TPPEFERREDwidth = Integer.valueOf(props.getProperty("TPPEFERREDwidth")).intValue();
          int TPPEFERREDheight = Integer.valueOf(props.getProperty("TPPEFERREDheight")).intValue();
          superEdit1.workspace.browser.topPanel.setPreferredSize(new Dimension(TPPEFERREDwidth, TPPEFERREDheight));

          int BW = Integer.valueOf(props.getProperty("Bwidth")).intValue();
          int BH = Integer.valueOf(props.getProperty("Bheight")).intValue();
          superEdit1.workspace.browser.setSize(BW, BH);

          int TPwidth = Integer.valueOf(props.getProperty("TPwidth")).intValue();
          int TPheight = Integer.valueOf(props.getProperty("TPheight")).intValue();
          superEdit1.workspace.browser.topPanel.setSize(TPwidth, TPheight);


          X = a;
          Y = b;
          WIDTH = c;
          HEIGHT = d;
        }
      } // end if dir exists
    }
    catch(Exception e) {;}

    superEdit1.workspace.setBounds(X, Y, WIDTH, HEIGHT);

    // *********** SWAP THESE FOR SPLASH SCREEN

    if(!sp)
    {
      superEdit1.workspace.setVisible(true);
    }

    ToolTipManager.sharedInstance().setEnabled(superEdit1.ideOptions.enableToolTipsBox.isSelected());

    superEdit1.initWorkspace();

    File swingFile = new File("SwingBeans.jar");

    if(superEdit1.ideOptions.scanRADBox1.isSelected() && swingFile.exists())
    {
	    try
      {
	      BeanBoxFrame.getToolBox().addBeansInJar(swingFile.getPath());
	    }
      catch (Throwable th) {}
    }

    if(sp)
    {
     cc.parent = superEdit1;
    }
    //superEdit1.workspace.tabs.getComponentAt(1).setVisible(false);

    if(args.length > 0)
    {
      try
      {
        superEdit1.makeEditor(new File(args[0]));
      }
      catch(Exception x){}
    }

  }

  public void toggleBrowser(boolean mode)
  {
    if(mode)
    {
     //browser.repaint();
     browser.setVisible(true);
     browser.setBounds(workspace.getLocation().x, workspace.getLocation().y, 205, workspace.getSize().height);
     workspace.setBounds(workspace.getLocation().x + 205, workspace.getLocation().y, workspace.getSize().width - 205, workspace.getSize().height);
    }
    else
    {
     browser.setVisible(false);
     workspace.setBounds(workspace.getLocation().x - 205, workspace.getLocation().y, workspace.getSize().width + 205, workspace.getSize().height);
     //workspace.repaint();
    }
  }

  java.util.Enumeration getWindows()
  {
    return openedWindows.elements();
  }

  public void refreshAll()
  {
   this.repaint();
   workspace.repaint();
   browser.repaint();
   if(ideOptions.isVisible()){ideOptions.repaint();}
   if(finder.isVisible()){finder.repaint();}
  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }


  private void jbInit() throws Exception
  {
    try
    {
	    URL url = getClass().getResource("images/logo.gif");
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}

    //browser.repaint();
    int height = 130;
    int width = getToolkit().getScreenSize().width;
    setBounds(0, 0, width, height);

    this.setJMenuBar(menuBar);
    refreshButton.setToolTipText("Refresh");
    languageOptions.setText("Options");
    languageOptions.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        languageOptions_actionPerformed(e);
      }
    });
    radOptions.setText("Options");
    radOptions.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        radOptions_actionPerformed(e);
      }
    });
    searchMenu.setText("Search");
    findItem.setText("Find");
    findItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        findItem_actionPerformed(e);
      }
    });
    findAgainItem.setText("Find Again");
    findAgainItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        findAgainItem_actionPerformed(e);
      }
    });
    replaceItem.setText("Replace");
    mainStatus.setBevelInner(BevelPanel.FLAT);
    mainStatus.setFont(new Font("Dialog", 1, 12));
    mainStatus.setText("Initialization Complete...");
    saveProjectItem.setText("Save Project");
    compileItem.setText("Compile");
    compileItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        compileItem_actionPerformed(e);
      }
    });
    makeItem.setText("Make");
    makeItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        makeItem_actionPerformed(e);
      }
    });
    runItem.setText("Run");
    runItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        runItem_actionPerformed(e);
      }
    });
    buildItem.setText("Build");
    gotoItem.setText("Goto Line");
    newProjectItem.setText("New Project");
    garbageButton.setToolTipText("Garbage Collect");
    garbageButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        garbageButton_actionPerformed(e);
      }
    });
    newProjectItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        newProjectItem_actionPerformed(e);
      }
    });
    gotoItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        gotoItem_actionPerformed(e);
      }
    });
    buildItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        buildItem_actionPerformed(e);
      }
    });

    group2.add(noneLangItem);
    group2.add(javaLangItem);
    group2.add(textLangItem);

    noneLangItem.setText("None");
    noneLangItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        noneLangItem_actionPerformed(e);
      }
    });
    javaLangItem.setText("Java");
    javaLangItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        javaLangItem_actionPerformed(e);
      }
    });
    textLangItem.setText("Plain Text");
    textLangItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        textLangItem_actionPerformed(e);
      }
    });

    noneLangItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.ALT_MASK));
    javaLangItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_2, ActionEvent.ALT_MASK));
    textLangItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_3, ActionEvent.ALT_MASK));


    ((JRadioButtonMenuItem)javaLangItem).setSelected(true);

    saveProjectItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        saveProjectItem_actionPerformed(e);
      }
    });
    replaceItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        replaceItem_actionPerformed(e);
      }
    });
    refreshButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        refreshButton_actionPerformed(e);
      }
    });
    this.setJMenuBar(menuBar);
    this.setTitle("SuperEdit 1.0");
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(WindowEvent e)
      {
        this_windowClosing(e);
      }
    });
    this.getContentPane().setLayout(xYLayout1);
    fileMenu.setText("File");
    fileMenu.setToolTipText("Open/Create/Save source files.");
    newItem.setText("New File");
    openItem.setText("Open");
    reOpenItem.setText("ReOpen");
    untitledItem.setText("Untitled");
    saveItem.setText("Save");
    saveAsItem.setText("Save As");
    saveAsItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        saveAsItem_actionPerformed(e);
      }
    });
    exitIte.setText("Exit");
    exitIte.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        exitIte_actionPerformed(e);
      }
    });
    editMenu.setText("Edit");
    editMenu.setToolTipText("Edit current source file.");
    cutItem.setText("Cut");
    copyItem.setText("Copy");
    pasteItem.setText("Paste");
    undoItem.setEnabled(false);
    undoItem.setText("Undo");
    redoItem.setEnabled(false);
    redoItem.setText("Redo");
    buildMenu.setText("Build");
    buildMenu.setToolTipText("Compile or run the application.");
    buildOptionsItem.setText("Options");
    buildOptionsItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        buildOptionsItem_actionPerformed(e);
      }
    });
    langModulesMenu.setText("Language Modules");
    langModulesMenu.setToolTipText("Language syntax font-locks and highlighting.");
    radModulesItem.setText("RAD Modules");
    radModulesItem.setToolTipText("Visual development  plugins.");
    toolsMenu.setText("Tools");
    toolsMenu.setToolTipText("Tools and Wizards.");
    toolsOptionsItem.setText("Options");
    toolsOptionsItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        toolsOptionsItem_actionPerformed(e);
      }
    });
    helpMenu.setText("Help");
    helpMenu.setToolTipText("Learn how to use this application.");
    contentsItem.setText("Contents");
    contentsItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        contentsItem_actionPerformed(e);
      }
    });
    aboutItem.setText("About");
    aboutItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        aboutItem_actionPerformed(e);
      }
    });
    registerItem.setText("Register");
    registerItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        registerItem_actionPerformed(e);
      }
    });
    xYLayout1.setHeight(122);
    jTabbedPane1.setBorder(etched);
    //$jTabbedPane1.setToolTipText("User Defined Comonents");
    //$macro.setBorder(border);
    macro.setToolTipText("Macro Definitions");
    workspaceItem.setState(true);
    workspaceItem.setText("Workspace");
    workspaceItem.addChangeListener(new com.sun.java.swing.event.ChangeListener()
    {
      public void stateChanged(ChangeEvent e)
      {
        workspaceItem_stateChanged(e);
      }
    });
    browserItem.setText("Browser");
    browserItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        browserItem_actionPerformed(e);
      }
    });
    messagesItem.setText("Messages");
    messagesItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        messagesItem_actionPerformed(e);
      }
    });
    viewMenu.setText("View");
    viewMenu.setToolTipText("Show/Hide windows.");
    xYLayout1.setWidth(761);
    //$custom.setBorder(border);
    menuBar.add(fileMenu);
    menuBar.add(editMenu);
    menuBar.add(searchMenu);
    menuBar.add(buildMenu);
    menuBar.add(langModulesMenu);
    menuBar.add(radModulesItem);
    menuBar.add(toolsMenu);
    menuBar.add(viewMenu);
    menuBar.add(helpMenu);
    fileMenu.add(newItem);
    fileMenu.add(newProjectItem);
    fileMenu.add(openItem);
    fileMenu.add(reOpenItem);
    fileMenu.add(saveItem);
    fileMenu.add(saveAsItem);
    fileMenu.add(saveProjectItem);
    fileMenu.addSeparator();
    fileMenu.add(exitIte);
    reOpenItem.add(untitledItem);

    editMenu.add(cutItem);
    editMenu.add(copyItem);
    editMenu.add(pasteItem);
    editMenu.add(gotoItem);
    editMenu.addSeparator();
    editMenu.add(undoItem);
    editMenu.add(redoItem);

    buildMenu.add(compileItem);
    buildMenu.add(makeItem);
    buildMenu.add(buildItem);
    buildMenu.add(runItem);
    buildMenu.addSeparator();
    buildMenu.add(buildOptionsItem);
    toolsMenu.addSeparator();
    toolsMenu.add(toolsOptionsItem);
    helpMenu.add(contentsItem);
    helpMenu.add(aboutItem);
    helpMenu.addSeparator();
    helpMenu.add(registerItem);

    refreshButton.setIcon(paintIco);

    int tabWidth = width - 405;
    tabConstraints = new XYConstraints(395, 5, tabWidth,  75);
    this.getContentPane().add(jTabbedPane1, tabConstraints);
    viewMenu.add(workspaceItem);
    viewMenu.add(browserItem);
    viewMenu.add(messagesItem);

    if(!loadedTabs)
    {
      jTabbedPane1.addTab("Macros", macro);
      jTabbedPane1.addTab("Custom", custom);
    }

    toolTabs.addElement(macro);
    toolTabs.addElement(custom);

    this.getContentPane().add(refreshButton, new XYConstraints(355, 10, 32, 32));
    this.getContentPane().add(buttonBar, new XYConstraints(0, 4, 355, 60));
    this.getContentPane().add(mainStatus, new XYConstraints(4, 65, 349, 20));
    this.getContentPane().add(garbageButton, new XYConstraints(355, 46, 32, 32));
    langModulesMenu.add(noneLangItem);
    langModulesMenu.add(javaLangItem);
    langModulesMenu.add(textLangItem);
    langModulesMenu.addSeparator();
    langModulesMenu.add(languageOptions);
    radModulesItem.add(radOptions);
    searchMenu.add(findItem);
    searchMenu.add(findAgainItem);
    searchMenu.add(replaceItem);

    int tabHeight = jTabbedPane1.getSize().height;
    jTabbedPane1.setSize(new Dimension(tabWidth, tabHeight));
    macro.setSize(new Dimension(tabWidth, macro.getSize().height));
    custom.setSize(new Dimension(tabWidth, custom.getSize().height));

    Icon copy = loadImageIcon("images/copy.gif", "Copy");
    Icon cut = loadImageIcon("images/cut.gif", "Cut");
    Icon new2 = loadImageIcon("images/new.gif", "New");
    Icon open = loadImageIcon("images/open.gif", "Open");
    Icon paste = loadImageIcon("images/paste.gif", "Paste");
    Icon save = loadImageIcon("images/save.gif", "Save");
    Icon undo = loadImageIcon("images/undo.gif", "Undo");
    Icon redo = loadImageIcon("images/redo.gif", "Redo");

    newItem.setIcon(new2);
    openItem.setIcon(open);
    saveItem.setIcon(save);
    cutItem.setIcon(cut);
    copyItem.setIcon(copy);
    pasteItem.setIcon(paste);
    undoItem.setIcon(undo);
    undoItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        undoItem_actionPerformed(e);
      }
    });
    redoItem.setIcon(redo);
    redoItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        redoItem_actionPerformed(e);
      }
    });

    cutItem.setEnabled(false);
    copyItem.setEnabled(false);
    pasteItem.setEnabled(false);
    undoItem.setEnabled(false);
    redoItem.setEnabled(false);

    undoItem.setHorizontalTextPosition(JButton.RIGHT);
    redoItem.setHorizontalTextPosition(JButton.RIGHT);


    newItem.setHorizontalTextPosition(JButton.RIGHT);
    newItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        newItem_actionPerformed(e);
      }
    });
    openItem.setHorizontalTextPosition(JButton.RIGHT);
    openItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        openItem_actionPerformed(e);
      }
    });
    saveItem.setHorizontalTextPosition(JButton.RIGHT);
    saveItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        saveItem_actionPerformed(e);
      }
    });
    cutItem.setHorizontalTextPosition(JButton.RIGHT);
    cutItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        cutItem_actionPerformed(e);
      }
    });
    copyItem.setHorizontalTextPosition(JButton.RIGHT);
    copyItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        copyItem_actionPerformed(e);
      }
    });
    pasteItem.setHorizontalTextPosition(JButton.RIGHT);
    pasteItem.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        pasteItem_actionPerformed(e);
      }
    });

    this.setResizable(true);

    /*
    isBrowserOpen = !isBrowserOpen;
    toggleBrowser(isBrowserOpen);
    isBrowserOpen = !isBrowserOpen;
    toggleBrowser(isBrowserOpen);
    */

    //Add Accelerators
    cutItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
    copyItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));
    pasteItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK));

    undoItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.CTRL_MASK));
    redoItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.ALT_MASK));

    newItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    openItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));

    findItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F, ActionEvent.CTRL_MASK));
    replaceItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK));
    findAgainItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0));

    saveItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));

    gotoItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_G, ActionEvent.CTRL_MASK));


    // Init toolbar

    if(!loadedTabs)
    {
      TE sec;
      sec = new TE(macro);
      sec.setIcon(loadImageIcon("images/myFolder.gif", "section item"));
      sec.setIcon2(loadImageIcon("images/myFolderOpen.gif", "section item"));
      ideOptions.sectionModel.addElement(sec);

      sec = new TE(custom);
      sec.setIcon(loadImageIcon("images/myFolder.gif", "section item"));
      sec.setIcon2(loadImageIcon("images/myFolderOpen.gif", "section item"));
      ideOptions.sectionModel.addElement(sec);

      ideOptions.sectionList.setSelectedIndex(0);
    }

    java.util.Properties props3 = new java.util.Properties();
    try
    {
      File dir = new File("Config");
      if(dir.exists())
      {
        File configFile = new File(dir, "SuperEdit.properties");
        FileInputStream fis = new FileInputStream(configFile);
        props3.load(fis);
        fis.close();
        initToolbar(props3);
      }
    }
    catch(Exception x){;}
  }

  private void initWorkspace()
  {
    boolean load = ideOptions.scanRADBox1.isSelected();
    Conn.conn.status.setText("Scanning RAD modules. Be patient...  ");

    GUI rad = new GUI(workspace, !load, false);
    workspace.tabs.addTab("RAD", loadImageIcon("images/gui.gif", "GUI Image"), rad);
    //rad.setVisible(false);

    //workspace.tabs.setSelectedIndex(1);
  }


  void this_windowClosing(WindowEvent e)
  {
    java.util.Enumeration enum = getWindows();
    while(enum.hasMoreElements())
    {
      Editor cur = (Editor) enum.nextElement();
      if(cur.saveButton.isEnabled())
      {
        int res = JOptionPane.showConfirmDialog(workspace, "Save " + cur.getTitle());
        if(res == JOptionPane.OK_OPTION)
        {
          cur.saveButton_actionPerformed(null);
        }
      }
    }

    if(projectUnsaved)
    {
        int res = JOptionPane.showConfirmDialog(workspace, "Save Project " + ((TE)workspace.browser.topPanel.getRoot().getUserObject()).getName() + "?");
        if(res == JOptionPane.OK_OPTION)
        {
          saveProjectItem_actionPerformed(null);
        }
    }

    saveConfig();
    finder.saveConfig();
    replacer.saveConfig();
    errorLog.println("******** Session Terminated on " + new java.util.Date() + " ********");

    try{errorLog.close();}catch(Exception et){;}
    dispose();
    System.exit(0);
  }

  void workspaceItem_stateChanged(ChangeEvent e)
  {
    workspace.setVisible(workspaceItem.getState());
  }

  void browserItem_actionPerformed(ActionEvent e)
  {
    isBrowserOpen = !isBrowserOpen;
    //toggleBrowser(isBrowserOpen);
    browser.setVisible(isBrowserOpen);
  }

  public void repaint()
  {
    tabConstraints.setHeight(getSize().height - 55);
    jTabbedPane1.repaint();
    super.repaint();
  }

  void refreshButton_actionPerformed(ActionEvent e)
  {
    refreshAll();
  }

  void openItem_actionPerformed(ActionEvent e)
  {
    (new Opener()).start();
  }

  void newItem_actionPerformed(ActionEvent e)
  {
    (new EditorMaker()).start();
  }


  public class EditorMaker extends Thread
  {
    File loadThis = null;

    public EditorMaker()
    {
      super();
    }

    public EditorMaker(File lt)
    {
      super();
      loadThis = lt;
    }

    public void run()
    {
      Editor currentEditor;

      if(loadThis == null)
      {
        currentEditor = new Editor(workspace);
        currentEditor.setTitle("<Untitled-" + seed++ + ">");
      }
      else
      {
        currentEditor = new Editor(workspace, loadThis);
      }

      if(((JRadioButtonMenuItem)noneLangItem).isSelected())
      {
        if(currentEditor.theListener != null)
        {
          currentEditor.removeFontifier(currentEditor.theListener);
        }
      }

      workspace.getDesktop().add(currentEditor, JLayeredPane.PALETTE_LAYER);

      if(ideOptions.autoMaximizeBox.isSelected())
      {
        try
        {
          currentEditor.setMaximum(true);
        }
        catch(Exception e0) {;}
      }
      openedWindows.addElement(currentEditor);
      currentEditor.setVisible(true);
      workspace.getDesktop().moveToFront(currentEditor);
      currentEditor.requestFocus();

    }
  }

  void toolsOptionsItem_actionPerformed(ActionEvent e)
  {
    ideOptions.setLocation(this.getToolkit().getScreenSize().width/2 - 212, this.getToolkit().getScreenSize().height/2 - 220);
    ideOptions.setVisible(true);
  }


  void saveConfig()
  {
    try
    {
      File dir = new File("Config");
      if(!dir.exists())
      {
        dir.mkdir();
      }

      File configFile = new File(dir, "SuperEdit.properties");

      java.util.Properties props = new java.util.Properties();

      /*
         Place all modifiable components such as Checkboxes here.
      */

      props.put("x", "" + workspace.getLocation().x);
      props.put("y", "" + workspace.getLocation().y);
      props.put("width", "" + workspace.getSize().width);
      props.put("height", "" + workspace.getSize().height);
      props.put("config", "" + ideOptions.configCombo.getSelectedIndex());

      props.put("Bwidth", "" + workspace.browser.getSize().width);
      props.put("Bheight", "" + workspace.browser.getSize().height);

      props.put("TPwidth", "" + workspace.browser.topPanel.getSize().width);
      props.put("TPheight", "" + workspace.browser.topPanel.getSize().height);

      props.put("TPPEFERREDwidth", "" + workspace.browser.topPanel.getSize().width);
      props.put("TPPEFERREDheight", "" + workspace.browser.topPanel.getSize().height);
      props.put("autosave", "" + ideOptions.showSplashBox.isSelected());

      props.put("lastProject", lastProject);

      if(Chooser.lastDir != null)
      {
        props.put("lastDir", "" + Chooser.lastDir);
      }

      int z = jTabbedPane1.getTabCount();

      for(int i = 0; i < z; i++)
      {
        ToolBarPanel tab = (ToolBarPanel) jTabbedPane1.getComponentAt(i);
        Component[] buttons = tab.getComponents();

        props.put("tab" + i, "" + tab.name);

        for(int x = 0; x < buttons.length; x++)
        {
         ToolbarButton tb = (ToolbarButton) buttons[x];
         props.put(tab.name + "Button" + x, "" + tb.description);

         props.put(tb.description + "Tip", tb.tip);
         props.put(tb.description + "Path", tb.path.replace(File.separatorChar, '$'));
         props.put(tb.description + "Data", tb.data);
        }
      }


      
      FileOutputStream fos = new FileOutputStream(configFile);

      props.save(fos, Utility.genHeader("SuperEdit Master Configuration File"));
      fos.close();

    }
    catch(Exception IDEx)
    {
      JOptionPane.showMessageDialog(this, "Couldn't save SuperEdit Configuration");
    }

  }

  void cutItem_actionPerformed(ActionEvent e)
  {
   if(currentEditor != null)
   {
     currentEditor.cutButton_actionPerformed(e);
   }
  }

  void copyItem_actionPerformed(ActionEvent e)
  {
   if(currentEditor != null)
   {
     currentEditor.copyButton_actionPerformed(e);
   }
  }

  void pasteItem_actionPerformed(ActionEvent e)
  {
   if(currentEditor != null)
   {
     currentEditor.pasteButton_actionPerformed(e);
   }
  }

  void undoItem_actionPerformed(ActionEvent e)
  {
   if(currentEditor != null)
   {
     currentEditor.undoAction.actionPerformed(e);
     //undoItem.setEnabled(currentEditor.undoButton.isEnabled());
     //redoItem.setEnabled(currentEditor.redoButton.isEnabled());
   }
  }

  void redoItem_actionPerformed(ActionEvent e)
  {
   if(currentEditor != null)
   {
     currentEditor.redoAction.actionPerformed(e);
     //undoItem.setEnabled(currentEditor.undoButton.isEnabled());
     //redoItem.setEnabled(currentEditor.redoButton.isEnabled());
   }
  }

  public static class Wrap extends Thread
  {
    Conn sp;

    public Wrap(Conn sp)
    {
      this.sp = sp;
    }

    public void run()
    {
      sp.countdown();
    }

  }

  void findItem_actionPerformed(ActionEvent e)
  {
    finder.setVisible(true);
  }

  void findAgainItem_actionPerformed(ActionEvent e)
  {
    if(!finder.fromCursorRadio.isSelected()){finder.fromCursorRadio.setSelected(true);}
    finder.findButton_actionPerformed(e);
  }

  void replaceItem_actionPerformed(ActionEvent e)
  {
    replacer.setVisible(true);
  }

  void exitIte_actionPerformed(ActionEvent e)
  {
    this_windowClosing(null);
  }

  public void initToolbar(java.util.Properties props)
  {
    boolean tabFlag = true;
    int tabCount = 0;

    while(tabFlag)
    {
      String tabName = props.getProperty("tab" + tabCount, "NOT FOUND");
      tabCount += 1;
      if(tabName.equals("NOT FOUND"))
      {
        tabFlag = false;
      }
      else
      {
        // First, add the tab
        String res = tabName;
        if(res == null) {return;}

        res = res.trim();
        if(res.equals("")) {return;}

      Conn.conn.status.setText("SuperEdit: Toolbar -> " + res);
      Conn.conn.status.repaint();

        ToolBarPanel t = new ToolBarPanel(res);
        toolTabs.addElement(t);

        TE sec;
        sec = new TE(t);
        sec.setIcon(loadImageIcon("images/myFolder.gif", "section item"));
        sec.setIcon2(loadImageIcon("images/myFolderOpen.gif", "section item"));
        ideOptions.sectionModel.addElement(sec);
        ideOptions.sectionList.repaint();

        jTabbedPane1.addTab(res, t);
        jTabbedPane1.repaint();


        // Buttons
        boolean buttonFlag = true;
        int buttonCount = 0;

        while(buttonFlag)
        {
          String buttonName = props.getProperty(tabName + "Button" + buttonCount, "NOT FOUND");
          buttonCount += 1;
          if(buttonName.equals("NOT FOUND"))
          {
            buttonFlag = false;
          }
          else
          {
            String cTip = props.getProperty(buttonName + "Tip");
            String cData = props.getProperty(buttonName + "Data");
            String cImage = props.getProperty(buttonName + "Path").replace('$', File.separatorChar);
            String cDesc = buttonName;

      Conn.conn.status.setText("SuperEdit: Toolbar -> " + res + ": " + buttonName);
      Conn.conn.status.repaint();

            if(cImage == null){cImage = "";}

            ToolbarButton tb = new ToolbarButton(cDesc, (cImage.equals("")) ? null : new ImageIcon(cImage), cData, (cTip.equals("")) ? null : cTip, cImage);
            TE te = new TE(tb);
            te.setIcon(tb.get16x16());

            ideOptions.itemModel.addElement(te);
            ideOptions.itemList.repaint();

            ToolBarPanel tmp = (ToolBarPanel) jTabbedPane1.getComponentAt(jTabbedPane1.indexOfTab(tabName));
            tmp.add(tb);
            jTabbedPane1.getSelectedComponent().doLayout();

            tmp.repaint();
            tb.repaint();
            jTabbedPane1.getSelectedComponent().repaint();

          }
        } // end while button flag
      }
    }
  }

  void saveItem_actionPerformed(ActionEvent e)
  {
    if(currentEditor == null) {return;}
    currentEditor.saveButton_actionPerformed(e);
  }

  void saveAsItem_actionPerformed(ActionEvent e)
  {
    if(currentEditor == null) {return;}
    currentEditor.currentFileName = null;
    currentEditor.saveButton_actionPerformed(e);
  }

  private File project = null;
  JMenuItem noneLangItem = new JRadioButtonMenuItem();
  JMenuItem javaLangItem = new JRadioButtonMenuItem();
  JMenuItem textLangItem = new JRadioButtonMenuItem();
  JMenuItem compileItem = new JMenuItem();
  JMenuItem makeItem = new JMenuItem();
  JMenuItem runItem = new JMenuItem();
  JMenuItem buildItem = new JMenuItem();
  JMenuItem gotoItem = new JMenuItem();
  JMenuItem newProjectItem = new JMenuItem();
  JButton garbageButton = new JButton(loadImageIcon("images/garbage.gif", "Paint"));

  void saveProjectItem_actionPerformed(ActionEvent e)
  {
    if(currentProject != null)
    {
      saveProject(currentProject);
      return;
    }

    File saveThis = null;

    Chooser chooser = new Chooser();
    chooser.setSave();
    chooser.setTitle("Save Project");
    chooser.previewer.addToProjectBox.setVisible(false);

    int retval = chooser.showDialog(this, null);
    if(retval != Chooser.APPROVE_OPTION) {return;}

    saveThis = chooser.getSelectedFile();
    if(saveThis == null) {return;}

    if(!saveThis.getAbsolutePath().endsWith(".spj"))
    {
      saveThis = new File(saveThis.getAbsolutePath() + ".spj");
    }
    lastProject = saveThis.getAbsolutePath();
    saveProject(saveThis);
  }

  private void saveProject(File f)
  {
    projectUnsaved = false;
    try
    {
      java.util.Properties props = new java.util.Properties();
      int seed = 0;

      FileOutputStream fs = new FileOutputStream(f);

      DefaultMutableTreeNode root = workspace.browser.topPanel.getRoot();
      java.util.Enumeration enum = root.children();
      while(enum.hasMoreElements())
      {
        DefaultMutableTreeNode o = (DefaultMutableTreeNode) enum.nextElement();
        if(o.getUserObject() instanceof TE)
        {
          TE oo = (TE) o.getUserObject();
          if(oo.contents instanceof File)
          {
            File ooo = (File) oo.contents;
            props.put("File" + seed++, ooo.getAbsolutePath().replace(File.separatorChar, '$'));
          }
        }
      }
      props.save(fs, Utility.genHeader("SuperEdit 1.0b1 Project File"));
      fs.close();
      ((TE)root.getUserObject()).setName(f.getName());
      workspace.browser.topPanel.model.reload(root);

    }
    catch(Exception x) {;}
  }

  void noneLangItem_actionPerformed(ActionEvent e)
  {
    java.util.Enumeration enum = openedWindows.elements();
    while(enum.hasMoreElements())
    {
      Editor edi = (Editor) enum.nextElement();
      if(edi.theListener != null)
      {
        edi.removeFontifier(edi.theListener);
      }
    }
  }

  void javaLangItem_actionPerformed(ActionEvent e)
  {
    java.util.Enumeration enum = openedWindows.elements();
    while(enum.hasMoreElements())
    {
      Editor edi = (Editor) enum.nextElement();
      if(edi.theListener != null)
      {
        edi.addFontifier(edi.theListener);
      }
    }
  }

  void textLangItem_actionPerformed(ActionEvent e)
  {
    java.util.Enumeration enum = openedWindows.elements();
    while(enum.hasMoreElements())
    {
      Editor edi = (Editor) enum.nextElement();
      if(edi.theListener != null)
      {
        edi.removeFontifier(edi.theListener);
      }
    }
    ideOptions.autoIndentBox.setSelected(false);
    ideOptions.indentBox.setSelected(false);
  }


  class Opener extends Thread
  {
    File fileGiven = null;

    public Opener()
    {
      super();
    }

    public Opener(File fileGiven)
    {
      super();
      this.fileGiven = fileGiven;
    }

    public void run()
    {
      int retval =  Chooser.APPROVE_OPTION;

      Chooser chooser = null;
      chooser = new Chooser();

      if(fileGiven == null)
      {
        chooser.setOpen();
        chooser.setTitle("Open File");

	      retval = chooser.showDialog(SuperEdit.superEdit, null);
      }

	    if(retval == Chooser.APPROVE_OPTION)
      {
	      File theFile = (fileGiven == null) ? chooser.getSelectedFile() : fileGiven;
	      if(theFile != null)
        {
		      if(theFile.exists())
          {
            if(theFile.getAbsolutePath().endsWith(".spj"))
            {
              try
              {
                workspace.toFront();
                
                FileInputStream fis = new FileInputStream(theFile);
                java.util.Properties props = new java.util.Properties();
                props.load(fis);

                lastProject = theFile.getAbsolutePath();
                currentProject = theFile;
                boolean flag = true;
                int seed = 0;

                DefaultMutableTreeNode root = workspace.browser.topPanel.getRoot();
                root.removeAllChildren();

                ((TE)root.getUserObject()).setName(theFile.getName());

                workspace.browser.topPanel.model.reload(root);


                while(flag)
                {
                  String res = props.getProperty("File" + seed, "NOT FOUND").replace('$', File.separatorChar);
                  seed += 1;
                  if(res.equals("NOT FOUND"))
                  {
                    flag = false;
                  }
                  else
                  {
                    TE tmp = new TE(new File(res));
                    if(res.endsWith(".java"))
                    {
                      tmp.setIcon(loadImageIcon("images/java.gif", "javaIcon"));
                    }
                    else if(isImage(res))
                    {
                      tmp.setIcon(loadImageIcon("images/preview.gif", "imageIcon"));
                    }
                    else
                    {
                      tmp.setIcon(loadImageIcon("images/defaultLeaf.gif", "imageIcon"));
                    }
                    workspace.browser.topPanel.model.insertNodeInto(new com.sun.java.swing.tree.DefaultMutableTreeNode(tmp), SuperEdit.superEdit.workspace.browser.topPanel.getRoot(), SuperEdit.superEdit.workspace.browser.topPanel.getRoot().getChildCount());
                    workspace.browser.topPanel.tree.expandRow(0);
                  }
                }
              }
              catch(Exception x) {;}
            }
            else if(isImage(theFile.getAbsolutePath()))
            {
              workspace.toFront();
              new ImagePreviewer(theFile);
            }
            else
            {
              (new EditorMaker(theFile)).start();
              workspace.toFront();
            }
          }
          else
          {
            JOptionPane.showMessageDialog(SuperEdit.superEdit, "File does not exist: " + chooser.getSelectedFile().getAbsolutePath());
            workspace.toFront();
          }

		      return;
        }
      }
      JOptionPane.showMessageDialog(SuperEdit.superEdit, "No file was chosen.");
      workspace.toFront();
    }
  }

  public void makeEditor(File theFile)
  {
    (new Opener(theFile)).start();
  }

  static boolean isImage(String s)
  {
    if(s.endsWith(".gif")) {return true;}
    else if(s.endsWith(".jpg")) {return true;}
    else if(s.endsWith(".bmp")) {return true;}

    else if(s.endsWith(".JPG")) {return true;}
    else if(s.endsWith(".GIF")) {return true;}
    else if(s.endsWith(".BMP")) {return true;}

    else if(s.endsWith(".Gif")) {return true;}
    else if(s.endsWith(".Jpg")) {return true;}
    else if(s.endsWith(".Bmp")) {return true;}

    else {return false;}    
  }

  void compileItem_actionPerformed(ActionEvent e)
  {
    if(buildOptions.noCompiler.isSelected()) {return;}
    
    if(currentEditor == null) {return;}

    if(currentEditor.saveButton.isEnabled())
    {
      JOptionPane.showMessageDialog(null, "You must save this file before you compile it.");
      return;
    }

    //System.out.println(buildOptions.jc.getCMD() + " " + currentEditor.getTitle());
    mainStatus.setText("Compiling " + currentEditor.currentFileName.getName() + " -> ");
    mainStatus.repaint();
    buildOptions.execute(buildOptions.jc.getCompileCMD() + " " + currentEditor.getTitle());
  }

  void makeItem_actionPerformed(ActionEvent e)
  {
    String res = "Done";

    mainStatus.setText("Running Make ... ");
    mainStatus.repaint();
    try
    {
      Runtime.getRuntime().exec(buildOptions.jc.getRunCMD() + "edu.neu.ccs.jmk.Make -w");
    }
    catch(Exception x){res = "Error Encounted";}

    mainStatus.setText("Running Make ... " + res);
    mainStatus.repaint();
  }

  void buildItem_actionPerformed(ActionEvent e)
  {
    JOptionPane.showMessageDialog(this, "Sorry, This is not implemented yet");
  }

  void runItem_actionPerformed(ActionEvent e)
  {
    if(buildOptions.jc.runnableFile.getText().equals(""))
    {
      JOptionPane.showMessageDialog(this, "You must select a Runnable file in Build/Options first.");
      return;
    }

    mainStatus.setText("Running " + buildOptions.jc.runnableFile.getText() + " -> ");
    mainStatus.repaint();
    buildOptions.execute(buildOptions.jc.getRunCMD());
    mainStatus.setText("Running " + buildOptions.jc.runnableFile.getText() + " -> Stopped");
    mainStatus.repaint();

  }

  void buildOptionsItem_actionPerformed(ActionEvent e)
  {
    buildOptions.setLocation(this.getToolkit().getScreenSize().width/2 - 194, this.getToolkit().getScreenSize().height/2 - 204);
    buildOptions.setVisible(true);
  }

  void messagesItem_actionPerformed(ActionEvent e)
  {
    messages.setVisible(messagesItem.isSelected());
  }

  void gotoItem_actionPerformed(ActionEvent e)
  {
    String res = JOptionPane.showInputDialog(null, "Goto Line:");

    if(currentEditor == null){return;}

    try
    {
      int lineNo = (new Integer(res)).intValue();
      currentEditor.gotoLine(lineNo);
    }
    catch(Exception x){;}
    workspace.toFront();
  }

  void newProjectItem_actionPerformed(ActionEvent e)
  {
    currentProject = null;
    DefaultMutableTreeNode root = workspace.browser.topPanel.getRoot();

    root.removeAllChildren();

    ((TE)root.getUserObject()).setName("Untitled.spj");
    workspace.browser.topPanel.model.reload(root);
  }

  void garbageButton_actionPerformed(ActionEvent e)
  {
    Runtime.getRuntime().gc();
  }

 class AutoPainter extends Thread
 {
   int m;

   public AutoPainter(int seconds)
   {
     m = (seconds == 0) ? 1 : seconds;
   }

   public void run()
   {
      while(true)
      {
        try
        {
          sleep(m*1000);
        }
        catch(Exception e) {;}

          refreshAll();
      }
   }
 }

  void languageOptions_actionPerformed(ActionEvent e)
  {
    JOptionPane.showMessageDialog(workspace, "Sorry, This is not implemented yet. \nTry Checking Tools/Options");
  }

  void radOptions_actionPerformed(ActionEvent e)
  {
    JOptionPane.showMessageDialog(workspace, "Sorry, This is not implemented yet. \nTry Checking Tools/Options");
  }

  void contentsItem_actionPerformed(ActionEvent e)
  {
    new HelpWindow();
  }

  void aboutItem_actionPerformed(ActionEvent e)
  {
    (new AboutBox(workspace, "About SuperEdit 1.0 B1")).show();
  }

  void registerItem_actionPerformed(ActionEvent e)
  {
    new RegisterBox();
  }



}


