/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.text.*;
import java.awt.*;
import java.awt.event.*;

public class ToolbarButton extends JButton
{
 String description;
 ImageIcon i32;
 ImageIcon i16;
 ImageIcon defaultIcon = loadImageIcon("images/32/help.gif", "defaultIcon");
 String data;
 String path = "";
 String tip;
 private int seed = 1;

 public ToolbarButton(String description, ImageIcon image, String data2, String tip, String path)
 {
  super();
  this.path = path;
  this.tip = tip;
  setPreferredSize(new Dimension(34, 34));
  setSize(new Dimension(34, 34));
  i32 = (image == null) ? defaultIcon : new ImageIcon(image.getImage().getScaledInstance(32,32, Image.SCALE_DEFAULT));
  i16 = (image == null) ? new ImageIcon(defaultIcon.getImage().getScaledInstance(16,16, Image.SCALE_DEFAULT)) : new ImageIcon(image.getImage().getScaledInstance(16,16, Image.SCALE_DEFAULT));
  this.description = description;
  this.data = data2;
  setToolTipText(tip);
  setIcon(i32);
  setBorder(null);

  addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        if(SuperEdit.superEdit.currentEditor == null) {return;}
        Editor editor = SuperEdit.superEdit.currentEditor;

          StyleContext styles = new StyleContext();
          Style def = styles.getStyle(StyleContext.DEFAULT_STYLE);
          Style normal = styles.addStyle("normal", def);
          StyleConstants.setFontFamily(normal, (String)SuperEdit.superEdit.ideOptions.fFamilyCombo.getSelectedItem());
          StyleConstants.setFontSize(normal, ((Integer)SuperEdit.superEdit.ideOptions.fSizeCombo.getSelectedItem()).intValue());
          StyleConstants.setForeground(normal, SuperEdit.superEdit.ideOptions.defaultTextColor);
          StyleConstants.setBold(normal, false);
          StyleConstants.setItalic(normal, false);
          try
          {
            editor.doc.insertString(editor.theText.getCaretPosition(), Utility.expandMacro(data, "$", "" + seed++), normal);
          }
          catch(Exception x) {;};
      }
    });

    addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseEntered(MouseEvent e)
      {
        setBorder(new BevelBorder(BevelBorder.RAISED));
        repaint();
      }
      public void mouseExited(MouseEvent e)
      {
        setBorder(null);
        repaint();
      }
    });


 }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }

  public ImageIcon get32x32()
  {
    return i32;
  }

  public ImageIcon get16x16()
  {
    return i16;
  }

  public void set32x32(ImageIcon ii)
  {
    i32=ii;
  }

  public void set16x16(ImageIcon ii)
  {
    i16=ii;
  }

  public String toString()
  {
    return description;
  }

  
}