/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */
package SuperEdit;

import java.util.*;

public class Utility
{

  public static Vector quicksortVector (Vector A)
  {
    if(A.size() < 2) {return A;}
    else {return quicksortVector(A, 0, A.size() -1);}
  }

  public static Vector quicksortVector (Vector A, int p, int r)
  {
    String mid;  // Used for partitioning
    Object tmp;  // used to temporarily store item while sorting in place
    int original_left = p;
    int original_right = r;
    mid = A.elementAt((p + r) / 2).toString();   // Partition the elements

    do
	  {
	    while(stringAltB(A.elementAt(p).toString() , mid))
	    {
	      p++;
	    }
	    while (stringAltB(mid , A.elementAt(r).toString()))
	    {
	      r--;
	    }
	    if (p <= r)
	    {
	      tmp = A.elementAt(p);
	      A.setElementAt(A.elementAt(r), p);
	      A.setElementAt(tmp, r);
	      p++;
	      r--;
	    }
    }
    while (p <= r); // Do Nothing

    if (original_left < r)
	  {
	    A = quicksortVector(A, original_left, r);
    }
    if (p < original_right)
	  {
	    A = quicksortVector(A, p, original_right);
    }
    return A;
  }

  public static long obj2long(Object o)
  {
   String res = o.toString().trim();
   if (res == "" || res == null) {return 0;}

   byte[] b = res.getBytes();

   long number = 0;

   //for(int i = 0; i < b.length; i++)
   //{
     number = number + (new Byte(b[0])).longValue();
   //}

   return number;

  }

  public static int char2int(char c)
  {
    switch(c)
    {
      case '_' : return 0;

      case '0' : return 1;
      case '1' : return 2;
      case '2' : return 3;
      case '3' : return 4;
      case '4' : return 5;
      case '5' : return 6;
      case '6' : return 7;
      case '7' : return 8;
      case '8' : return 9;
      case '9' : return 10;

      case 'A' : return 11;
      case 'B' : return 12;
      case 'C' : return 13;
      case 'D' : return 14;
      case 'E' : return 15;
      case 'F' : return 16;
      case 'G' : return 17;
      case 'H' : return 18;
      case 'I' : return 19;
      case 'J' : return 20;
      case 'K' : return 21;
      case 'L' : return 22;
      case 'M' : return 23;
      case 'N' : return 24;
      case 'O' : return 25;
      case 'P' : return 26;
      case 'Q' : return 27;
      case 'R' : return 28;
      case 'S' : return 29;
      case 'T' : return 30;
      case 'U' : return 31;
      case 'V' : return 32;
      case 'W' : return 33;
      case 'X' : return 34;
      case 'Y' : return 35;
      case 'Z' : return 36;


      case 'a' : return 37;
      case 'b' : return 38;
      case 'c' : return 39;
      case 'd' : return 40;
      case 'e' : return 41;
      case 'f' : return 42;
      case 'g' : return 43;
      case 'h' : return 44;
      case 'i' : return 45;
      case 'j' : return 46;
      case 'k' : return 47;
      case 'l' : return 48;
      case 'm' : return 49;
      case 'n' : return 50;
      case 'o' : return 51;
      case 'p' : return 52;
      case 'q' : return 53;
      case 'r' : return 54;
      case 's' : return 55;
      case 't' : return 56;
      case 'u' : return 57;
      case 'v' : return 58;
      case 'w' : return 59;
      case 'x' : return 60;
      case 'y' : return 61;
      case 'z' : return 62;

      default : return 100;
    }
  }

  public static boolean stringAgtB(String A, String B)
  {
    int length = (A.length() < B.length()) ? A.length()-1 : B.length()-1;

    int currentIndex = 0;

    while(currentIndex <= length)
    {
      if(char2int(A.charAt(currentIndex)) > char2int(B.charAt(currentIndex)))
      {
        return true;
      }
      else if(char2int(A.charAt(currentIndex)) < char2int(B.charAt(currentIndex)))
      {
        return false;
      }
      else
      {
        currentIndex += 1;
      }
    }

    return false;
  }

  public static boolean stringAltB(String A, String B)
  {
    int length = (A.length() < B.length()) ? A.length()-1 : B.length()-1;

    int currentIndex = 0;

    while(currentIndex <= length)
    {
      if(char2int(A.charAt(currentIndex)) < char2int(B.charAt(currentIndex)))
      {
        return true;
      }
      else if(char2int(A.charAt(currentIndex)) > char2int(B.charAt(currentIndex)))
      {
        return false;
      }
      else
      {
        currentIndex += 1;
      }
    }

    return false;
  }

  public static String genHeader(String start)
  {
   String res = start;
   res = res +
   "\n#" +
   "\n#                  _____                       ______    ___ __"  +
   "\n#                 / ___/__  ______  ___  _____/ ____/___/ (_) /_" +
   "\n#                 \\__ \\/ / / / __ \\/ _ \\/ ___/ __/ / __  / / __/" +
   "\n#                ___/ / /_/ / /_/ /  __/ /  / /___/ /_/ / / /_"  +
   "\n#               /____/\\__,_/ .___/\\___/_/  /_____/\\__,_/_/\\__/" +
   "\n#                         /_/" +
   "\n#" +
   "\n#                          ___     ____       __     ___" +
   "\n#                         <  /    / __ \\     / /_   <  /" +
   "\n#                         / /    / / / /    / __ \\  / /" +
   "\n#                        / / _  / /_/ /    / /_/ / / /" +
   "\n#                       /_/ (_) \\____/    /_.___/ /_/" +
   "\n#" +
   "\n#";

   return res;
  }

  public static String expandMacro(String str, String find, String newVal)
  {
    if(find == null || newVal == null) {return str;}

    int pos = str.indexOf(find);
    if(pos < 0) {return str;}

    return str.substring(0, pos) + newVal + expandMacro(str.substring(pos + newVal.length()), find, newVal);

  }


}