
/*
 * Copyright 1998 by PsychoticSoftware
 *
 * This program is free software; you can redistribute it and/or
 * modify it. All we ask is for a simple dredit in any application 
 * you use any part of this source code in -- maybe in a README file.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 */


package SuperEdit;

import java.awt.*;
import com.sun.java.swing.JFrame;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import borland.jbcl.layout.*;
import java.awt.event.*;

public class Workspace extends JFrame
{
  JDesktopPane desktop;
  SuperEdit parent;
  JSplitPane splitPane;
  Browser browser;
  Border wb;
  JTabbedPane tabs = new JTabbedPane(JTabbedPane.BOTTOM);

  public Workspace(SuperEdit parent)
  {
    try
    {
      this.parent = parent;
      initHeader();
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public ImageIcon loadImageIcon(String filename, String description)
  {
      java.net.URL url = getClass().getResource(filename);
      return new ImageIcon(url, description);
  }

  private void initHeader()
  {
     desktop = new JDesktopPane();Conn.conn.status.setText("Workspace: Creating Desktop");Conn.conn.status.repaint();
     splitPane = new JSplitPane();Conn.conn.status.setText("Workspace: Setup Orientation");Conn.conn.status.repaint();
     browser = new Browser();Conn.conn.status.setText("Workspace: Installing Browser");Conn.conn.status.repaint();
     wb = new BevelBorder(BevelBorder.LOWERED);Conn.conn.status.setText("Workspace: Creating Border");Conn.conn.status.repaint();
  }

  public JDesktopPane getDesktop()
  {
   return desktop;
  }

  public Browser getBrowser()
  {
   return browser;
  }

  private void jbInit()
  {
    try
    {
	    java.net.URL url = getClass().getResource("images/logo.gif");
      java.awt.image.ImageProducer imageProd = (java.awt.image.ImageProducer) url.getContent();
      Image image = createImage( imageProd );
	    setIconImage(image);
    }
    catch(Exception e) {;}
    this.setTitle("Workspace");

    this.getContentPane().setLayout(new BorderLayout());
    this.getContentPane().add(tabs, BorderLayout.CENTER);
    tabs.addTab("Code", loadImageIcon("images/code.gif", "Code Image"), new SourceTab());


  }

  class SourceTab extends JPanel
  {
    public SourceTab()
    {
      super();
      try
      {
        jbInit();
      }
      catch(Exception x) {x.printStackTrace();}
    }

    private void jbInit() throws Exception
    {
      desktop.setOpaque(true);
      desktop.setBorder(wb);

          // Open a New Editor
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  parent.newItem_actionPerformed(e);
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);

          // Undo
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  parent.undoItem_actionPerformed(e);
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);

          // Redo
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  parent.redoItem_actionPerformed(e);
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.ALT_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);

          // highlight
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  if(parent.currentEditor != null)
                  {
                    parent.currentEditor.highlightPopup_actionPerformed(e);
                  }
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_H, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);


          // remove highlight
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  if(parent.currentEditor != null)
                  {
                    parent.currentEditor.removeHighlightPopup_actionPerformed(e);
                  }
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_H, ActionEvent.ALT_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);

          // Find
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  if(parent.currentEditor != null)
                  {
                    parent.findItem_actionPerformed(e);
                  }
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_F, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);


          // Find Again
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  if(parent.currentEditor != null)
                  {
                    parent.findAgainItem_actionPerformed(e);
                  }
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0), JComponent.WHEN_IN_FOCUSED_WINDOW);


          // Replace
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  if(parent.currentEditor != null)
                  {
                    parent.replaceItem_actionPerformed(e);
                  }
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);


          // Save
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                  if(parent.currentEditor != null)
                  {
                    parent.currentEditor.saveButton_actionPerformed(e);
                    parent.currentEditor.saveButton.setEnabled(false);
                    parent.currentEditor.repaint();
                  }
              }
            } , KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);


          // Open
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                 parent.openItem_actionPerformed(e);
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);


          // goto
          desktop.registerKeyboardAction(new AbstractAction(){
              public void actionPerformed(ActionEvent e) {
                 parent.gotoItem_actionPerformed(e);
              }
          } , KeyStroke.getKeyStroke(KeyEvent.VK_G, ActionEvent.CTRL_MASK), JComponent.WHEN_IN_FOCUSED_WINDOW);


      this.setLayout(new BorderLayout());

      browser.setMinimumSize(new Dimension(0, 0));
      desktop.setMinimumSize(new Dimension(0, 0));
      //browser.setPreferredSize(new Dimension(210,600));

      splitPane.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
      splitPane.setLeftComponent(browser);
      splitPane.setRightComponent(desktop);

      splitPane.setDoubleBuffered(true);
      splitPane.setContinuousLayout(true);
      splitPane.setDividerSize(3);
      this.add(splitPane, BorderLayout.CENTER);
    }
  }

}


